<?php
    global $bookingpress_common_date_format;
 ?>
<el-main class="bpa-frontend-main-container" id="bookingpress_booking_form_<?php echo esc_html($bookingpress_uniq_id); ?>">
    <div class="bpa-front-loader-container" v-if="is_front_appointment_empty_loader == '1'">
        <div class="bpa-front-loader"></div>
    </div>
    <div id="bpa-front-data-empty-view--my-bookings" class="bpa-front-data-empty-view--my-bookings __bpa-is-guest-view" v-if="bookingpress_is_user_logged_in == '0' && is_front_appointment_empty_loader == '0'">
    
        <picture>
            <source srcset="<?php echo esc_url(BOOKINGPRESS_IMAGES_URL . '/data-grid-empty-view-vector.webp'); ?>" type="image/webp">
            <img src="<?php echo esc_url(BOOKINGPRESS_IMAGES_URL . '/data-grid-empty-view-vector.png'); ?>">
        </picture>
        <h4><?php esc_html_e('Please login to your account to view bookings!', 'bookingpress-appointment-booking'); ?></h4>
    </div>
    <div id="bpa-front-my-booking-container" v-if="bookingpress_is_user_logged_in == '1' && is_front_appointment_empty_loader == '0'">    
        <div class="bpa-front-default-card bpa-front-my-appointments-container" > 
            <div class="bpa-front-ma-header">
                <div class="bpa-front-ma-header--left">
                    <h2 class="bpa-front-module-heading">{{ mybooking_title_text }}</h2>
                </div>
                <div class="bpa-front-ma-header--right">
                    <div class="bpa-front-ma-header__profile-dropdown" v-if="hide_customer_details != '1'">
                        <div class="bpa-front-ma-header__profile-dropdown--img" v-if="bookingpress_avatar_url != ''">                          
                            <img :src="bookingpress_avatar_url" alt="">
                        </div>
                        <div class="bpa-front-ma-header__profile-dropdown--body">														
                            <h4>{{bookingpress_user_fullname}}</h4>
                            <p>{{bookingpress_user_email}}</p>												
                        </div>	

                    </div>
                </div>    
            </div>
            <div class="bpa-front-ma-lists">
                <div class="bpa-front-ma-list--filter-wrapper">
                    <div class="bpa-front-ma--fw__row">                
                        <div class="bpa-front-ma--fw__col">
                            <el-date-picker class="bpa-front-form-control bpa-front-form-control--date-range-picker" v-model="appointment_date_range" format="<?php echo esc_html($bookingpress_common_date_format); ?>" type="daterange" 
                            start-placeholder="<?php esc_html_e('Start date', 'bookingpress-appointment-booking'); ?>" end-placeholder="<?php esc_html_e('End date', 'bookingpress-appointment-booking'); ?>" @change="search_range_change($event)"
                            popper-class="bpa-front--date-range-picker" range-separator="<?php esc_html_e('To', 'bookingpress-appointment-booking'); ?>"> </el-date-picker>
                        </div>    
                        <div class="bpa-front-ma--fw__col">
                            <el-input class="bpa-front-form-control" v-model="search_appointment" :placeholder="search_appointment_title" v-if="hide_search_bar != '1'"></el-input>
                        </div>
                        <div class="bpa-front-ma--fw__col">
                            <div class="bpa-tf-btn-group">
                                <el-button class="bpa-front-btn bpa-front-btn__medium bpa-front-btn--full-width" @click="resetFilter" >
                                    {{reset_button_title}}
                                </el-button>
                                <el-button class="bpa-front-btn bpa-front-btn__medium bpa-front-btn--primary bpa-front-btn--full-width" @click="loadFrontAppointments()">
                                    {{apply_button_title}}
                                </el-button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="bpa-front-ma-list--items">
                    <div class="bpa-front-loader-container" v-if="is_display_loader == '1'">
                        <div class="bpa-front-loader"></div>
                    </div>
                    <div class="bpa-front-ma-list--item__item-card">
                        <el-row type="flex" v-if="items.length == 0">
                            <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
                                <div class="bpa-front-data-empty-view--my-bookings">
                                    <picture>
                                        <source srcset="<?php echo esc_url(BOOKINGPRESS_IMAGES_URL . '/data-grid-empty-view-vector.webp'); ?>" type="image/webp">
                                        <img src="<?php echo esc_url(BOOKINGPRESS_IMAGES_URL . '/data-grid-empty-view-vector.png'); ?>">
                                    </picture>
                                    <h4><?php esc_html_e('No Appointments found!', 'bookingpress-appointment-booking'); ?></h4>
                                </div>
                            </el-col>
                        </el-row>
                    </div>
                    <div class="bpa-front-ma-list--item-row" v-if="items.length != 0" v-for="items_data in items">
                        <div class="bpa-front-ma-list--item__heading">
                            <h6>{{items_data.date}}</h6>
                        </div>                    
                        <div class="bpa-front-ma-list--item__item-card" v-for="items_list in items_data.data">
                            <div class="bpa-front-ma-list--item__ic-row">
                                <div class="bpa-front-ma-list--item__ic-col">
                                    <h4>{{items_list.appointment_service_name}}</h4>
                                </div>
                                <div class="bpa-front-ma-list--item__ic-col">
                                    <p>
                                        <span class="material-icons-round">access_time</span>
                                        {{items_list.appointment_duration}}
                                    </p>
                                </div>
                                <div class="bpa-front-ma-list--item__ic-col">
                                    <p>
                                        <span class="material-icons-round">calendar_today</span>
                                        {{items_list.appointment_date}}  {{ items_list.appointment_time }}
                                    </p>
                                </div>
                                <div class="bpa-front-ma-list--item__ic-col">
                                    <p>{{items_list.appointment_payment}}</p>
                                </div>
                                <div class="bpa-front-ma-list--item__ic-col --pills">
                                    <el-tag class="bpa-front-pill --warning" v-if="items_list.appointment_status =='Pending'">{{items_list.appointment_status}}</el-tag>
                                    <el-tag class="bpa-front-pill" v-if="items_list.appointment_status =='Approved'">{{items_list.appointment_status}}</el-tag>
                                    <el-tag class="bpa-front-pill --info" v-if="items_list.appointment_status == 'Cancelled'">{{items_list.appointment_status}}</el-tag>                            
                                    <el-tag class="bpa-front-pill --rejected" v-if="items_list.appointment_status == 'Rejected'">{{items_list.appointment_status}}</el-tag>
                                </div>
                                <div class="bpa-front-ma-list--item__ic-col bpa-front-ma-list--item__item-card--actions">
                                    <el-popconfirm 
                                        confirm-button-text='<?php esc_html_e('Yes', 'bookingpress-appointment-booking'); ?>' 
                                        cancel-button-text='<?php esc_html_e('No', 'bookingpress-appointment-booking'); ?>' 
                                        icon="false" 
                                        :title="confirmation_message_for_the_cancel_appointment"
                                        @confirm = "cancelAppointment(items_list.appointment_id)" 
                                        confirm-button-type="bpa-front-btn bpa-front-btn__small bpa-front-btn--danger" 
                                        cancel-button-type="bpa-front-btn bpa-front-btn__small"
                                        v-if="allow_cancel_appointments == true">
                                        <el-button type="text" slot="reference" class="bpa-btn bpa-front-btn--icon-without-box __danger" :disabled="is_disabled" v-if="items_list.appointment_status != 'Cancelled' && items_list.appointment_status != 'Rejected'">
                                            <span class="material-icons-round">event_busy</span>
                                        </el-button>
                                    </el-popconfirm>
                                </div>                        
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>	       
    </div>    	
</el-main>
