<el-tab-pane class="bpa-tabs--v_ls__tab--pane-body" label="redirection_rules" data-tab_name="redirection_rule_setting_form">
    <span slot="label">
        <i class="material-icons-round">account_balance_wallet</i>
        <?php esc_html_e('Redirection Rules', 'bookingpress-appointment-booking'); ?>
    </span>
    <div class="bpa-general-settings-tabs--pb__card bpa-payment-settings-tabs--pb__card">
        <el-row type="flex" class="bpa-mlc-head-wrap-settings bpa-gs-tabs--pb__heading __bpa-is-groupping">
            <el-col :xs="12" :sm="12" :md="12" :lg="12" :xl="12" class="bpa-gs-tabs--pb__heading--left">
                <h1 class="bpa-page-heading"><?php esc_html_e('Redirection Rules', 'bookingpress-appointment-booking'); ?></h1>
            </el-col>
            <el-col :xs="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="bpa-hw-right-btn-group bpa-gs-tabs--pb__btn-group">    
                    <el-button class="bpa-btn bpa-btn--primary" :class="(is_display_save_loader == '1') ? 'bpa-btn--is-loader' : ''" @click="saveSettingsData('redirection_rule_setting_form','redirection_rule_setting_form')" :disabled="is_disabled" >                    
                      <span class="bpa-btn__label"><?php esc_html_e('Save', 'bookingpress-appointment-booking'); ?></span>
                      <div class="bpa-btn--loader__circles">                    
                          <div></div>
                          <div></div>
                          <div></div>
                      </div>
                    </el-button>
                    <el-button class="bpa-btn" @click="openNeedHelper('list_redirection_settings', 'redirection_settings', '<?php esc_html_e('Redirection Settings', 'bookingpress-appointment-booking'); ?>')">
                        <span class="material-icons-round">help</span>
                        <?php esc_html_e('Need help?', 'bookingpress-appointment-booking'); ?>
                    </el-button>                    
                    <el-button class="bpa-btn" @click="open_feature_request_url">
                        <span class="material-icons-round">lightbulb</span>
                        <?php esc_html_e('Feature Requests', 'bookingpress-appointment-booking'); ?>
                    </el-button>
                </div>
            </el-col>
        </el-row>
        <div class="bpa-gs--tabs-pb__content-body">
            <el-form ref="redirection_rule_setting_form" :model="redirection_rule_setting_form" @submit.native.prevent >    
                <div class="bpa-gs__cb--item">  
                    <div class="bpa-gs__cb--item-heading">
                        <h4 class="bpa-sec--sub-heading"><?php esc_html_e('Redirect Page After Booking Approved', 'bookingpress-appointment-booking'); ?></h4>
                    </div> 
                    <div class="bpa-gs__cb--item-body">
                        <el-row type="flex" class="bpa-gs--tabs-pb__cb-item-row">
                            <el-col :xs="12" :sm="12" :md="12" :lg="6" :xl="6" class="bpa-gs__cb-item-left">
                                <h4> <?php esc_html_e('Please Select Page', 'bookingpress-appointment-booking'); ?></h4>
                            </el-col>
                            <el-col :xs="12" :sm="12" :md="12" :lg="18" :xl="18" class="bpa-gs__cb-item-right">
                                <el-form-item>
                                    <el-select class="bpa-form-control" filterable v-model="redirection_rule_setting_form.after_appointment_approved_fixed_redirection_val">
                                        <el-option v-for="item in bookingpress_all_global_pages" :key="item.post_title" :label="item.post_title"  :value="''+item.ID"></el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>
                    </div>
                </div>
                <div class="bpa-gs__cb--item">
                    <div class="bpa-gs__cb--item-heading">
                        <h4 class="bpa-sec--sub-heading"><?php esc_html_e('Redirect Page After Booking Pending', 'bookingpress-appointment-booking'); ?></h4>
                    </div>
                    <div class="bpa-gs__cb--item-body">
                        <el-row type="flex" class="bpa-gs--tabs-pb__cb-item-row">
                            <el-col :xs="12" :sm="12" :md="12" :lg="6" :xl="6" class="bpa-gs__cb-item-left">
                                <h4> <?php esc_html_e('Please Select Page', 'bookingpress-appointment-booking'); ?></h4>
                            </el-col>
                            <el-col :xs="12" :sm="12" :md="12" :lg="18" :xl="18" class="bpa-gs__cb-item-right">
                                <el-form-item>
                                    <el-select class="bpa-form-control" filterable v-model="redirection_rule_setting_form.after_appointment_pending_fixed_redirection_val">
                                        <el-option v-for="item in bookingpress_all_global_pages" :key="item.post_title" :label="item.post_title"  :value="''+item.ID"></el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>
                    </div>
                </div>
                <div class="bpa-gs__cb--item">
                    <div class="bpa-gs__cb--item-heading">
                        <h4 class="bpa-sec--sub-heading"><?php esc_html_e('Redirect Page After Booking Canceled', 'bookingpress-appointment-booking'); ?></h4>
                    </div>
                    <div class="bpa-gs__cb--item-body">
                        <el-row type="flex" class="bpa-gs--tabs-pb__cb-item-row">
                            <el-col :xs="12" :sm="12" :md="12" :lg="6" :xl="6" class="bpa-gs__cb-item-left">
                                <h4> <?php esc_html_e('Please Select Page', 'bookingpress-appointment-booking'); ?></h4>
                            </el-col>
                            <el-col :xs="12" :sm="12" :md="12" :lg="18" :xl="18" class="bpa-gs__cb-item-right">
                                <el-form-item>
                                    <el-select class="bpa-form-control" filterable v-model="redirection_rule_setting_form.after_appointment_canceled_fixed_redirection_val">
                                        <el-option v-for="item in bookingpress_all_global_pages" :key="item.post_title" :label="item.post_title"  :value="''+item.ID"></el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>
                    </div>  
                </div>
            </el-form>
        </div>
    </div>    
</el-tab-pane>
