<?php

global $BookingPress, $wpdb, $bookingpress_version;

$bookingpress_old_version = get_option('bookingpress_version', true);

if (version_compare($bookingpress_old_version, '1.0.2', '<') ) {
    $tbl_bookingpress_default_workhours = $wpdb->prefix . 'bookingpress_default_workhours';
    $wpdb->query("UPDATE `{$tbl_bookingpress_default_workhours}` SET `bookingpress_start_time` = NULL, bookingpress_end_time = NULL WHERE bookingpress_start_time = '00:00:00' AND bookingpress_end_time = '00:00:00'"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False Positive alarm
}


if (version_compare($bookingpress_old_version, '1.0.3', '<') ) {
    $args  = array(
    'role'   => 'administrator',
    'fields' => 'id',
    );
    $users = get_users($args);

    if (count($users) > 0 ) {
        foreach ( $users as $key => $user_id ) {
            $bookingpressroles = $BookingPress->bookingpress_capabilities();
            $userObj           = new WP_User($user_id);
            foreach ( $bookingpressroles as $bookingpressrole => $bookingpress_roledescription ) {
                $userObj->add_cap($bookingpressrole);
            }
            unset($bookingpressrole);
            unset($bookingpressroles);
            unset($bookingpress_roledescription);
        }
    }
}

if (version_compare($bookingpress_old_version, '1.0.6', '<') ) {
    $tbl_bookingpress_entries = $wpdb->prefix . 'bookingpress_entries';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} ADD bookingpress_customer_id INT(11) DEFAULT NULL AFTER bookingpress_entry_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm

    $tbl_bookingpress_users = $wpdb->prefix . 'bookingpress_users';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_wpuser_id bookingpress_wpuser_id INT(11) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_password bookingpress_user_password VARCHAR(255) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_country_phone bookingpress_user_country_phone VARCHAR(60) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm

    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_entry_id INT(11) DEFAULT NULL AFTER bookingpress_appointment_booking_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    // Update customers avatar to usermeta table
    $tbl_bookingpress_users_meta = $wpdb->prefix . 'bookingpress_usermeta';

    include_once ABSPATH . 'wp-admin/includes/upgrade.php';
    @set_time_limit(0);

    $charset_collate = '';
    if ($wpdb->has_cap('collation') ) {
        if (! empty($wpdb->charset) ) {
            $charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
        }
        if (! empty($wpdb->collate) ) {
            $charset_collate .= " COLLATE $wpdb->collate";
        }
    }
    $bookingpress_dbtbl_create = array();
    $sql_table                 = "DROP TABLE IF EXISTS `{$tbl_bookingpress_users_meta}`;
    CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_users_meta}`(
        `bookingpress_usermeta_id` int(11) NOT NULL AUTO_INCREMENT,
        `bookingpress_customer_id` int(11) NOT NULL,
        `bookingpress_usermeta_key` TEXT NOT NULL,
        `bookingpress_usermeta_value` TEXT DEFAULT NULL,
        `bookingpress_usermeta_created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
        PRIMARY KEY (`bookingpress_usermeta_id`)
    ) {$charset_collate};";

    $bookingpress_dbtbl_create[ $tbl_bookingpress_users_meta ] = dbDelta($sql_table);

    $bookingpress_customer_avatar_details = array();

    $bookingpress_customers_details = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_users} WHERE bookingpress_user_type = 2", ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    if (is_array($bookingpress_customers_details) && ! empty($bookingpress_customers_details) ) {
        foreach ( $bookingpress_customers_details as $customer_detail_key => $customer_detail_val ) {
            $customer_id = $customer_detail_val['bookingpress_customer_id'];
            $wpuser_id   = $customer_detail_val['bookingpress_wpuser_id'];

            if (! empty($customer_id) && ! empty($wpuser_id) ) {
                $bookingpress_get_existing_avatar_details = get_user_meta($wpuser_id, 'customer_avatar_details', true);
                if (! empty($bookingpress_get_existing_avatar_details) ) {
                    $bookingpress_customer_avatar_details[] = array(
                    'bookingpress_customer_id'    => $customer_id,
                    'bookingpress_usermeta_key'   => 'customer_avatar_details',
                    'bookingpress_usermeta_value' => $bookingpress_get_existing_avatar_details,
                    );
                }
            }
        }
    }

    if (is_array($bookingpress_customer_avatar_details) && ! empty($bookingpress_customer_avatar_details) ) {
        foreach ( $bookingpress_customer_avatar_details as $customer_avatar_key => $customer_avatar_val ) {
            $BookingPress->update_bookingpress_usermeta($customer_avatar_val['bookingpress_customer_id'], $customer_avatar_val['bookingpress_usermeta_key'], maybe_serialize($customer_avatar_val['bookingpress_usermeta_value']));
        }
    }
}

if (version_compare($bookingpress_old_version, '1.0.9', '<') ) {
    $tbl_bookingpress_entries           = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_users             = $wpdb->prefix . 'bookingpress_users';
    $tbl_bookingpress_users_meta        = $wpdb->prefix . 'bookingpress_usermeta';
    $tbl_bookingpress_customers         = $wpdb->prefix . 'bookingpress_customers';
    $tbl_bookingpress_customers_meta    = $wpdb->prefix . 'bookingpress_customers_meta';
    $tbl_bookingpress_default_workhours = $wpdb->prefix . 'bookingpress_default_workhours';
     // phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_daysoff,$tbl_bookingpress_users,$tbl_bookingpress_users_meta, $tbl_bookingpress_default_workhours are table names. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) DEFAULT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_id bookingpress_customermeta_id bigint(11) NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) NOT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_key bookingpress_customersmeta_key TEXT NOT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_value bookingpress_customersmeta_value TEXT DEFAULT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_created_date bookingpress_customersmeta_created_date datetime NOT NULL DEFAULT CURRENT_TIMESTAMP");


    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} DROP COLUMN bookingpress_user_password");

    $wpdb->query("ALTER TABLE {$tbl_bookingpress_default_workhours} CHANGE bookingpress_employee_workhours_id bookingpress_workhours_id smallint NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_default_workhours} CHANGE bookingpress_employee_workday_key bookingpress_workday_key varchar(11) NOT NULL");

    // RENAME TABLE wpa_bookingpress_users TO wpa_bookingpress_customers
    $wpdb->query("RENAME TABLE {$tbl_bookingpress_users} TO {$tbl_bookingpress_customers}");
    $wpdb->query("RENAME TABLE {$tbl_bookingpress_users_meta} TO {$tbl_bookingpress_customers_meta}");
     // phpcs:enable
}

if (version_compare($bookingpress_old_version, '1.0.12', '<') ) {
    global $BookingPress;

    $tbl_bookingpress_customers = $wpdb->prefix . 'bookingpress_customers';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_customers} ADD bookingpress_created_at INT(11)  NOT NULL DEFAULT 0  AFTER bookingpress_user_country_phone"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_customers} ADD bookingpress_created_by INT(1)  NOT NULL DEFAULT 0 AFTER bookingpress_created_at"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers is table name defined globally. False Positive alarm
    $tbl_bookingpress_payment_logs = $wpdb->prefix . 'bookingpress_payment_logs';
    $is_update_column              = $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_invoice_id bigint(11)  NOT NULL DEFAULT 0  AFTER bookingpress_payment_log_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
    if ($is_update_column ) {
        $bookingpress_payment_log_data = $wpdb->get_results('SELECT `bookingpress_payment_log_id` FROM ' . $tbl_bookingpress_payment_logs); // phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
        $i                             = 0;
        if (! empty($bookingpress_payment_log_data) ) {
            foreach ( $bookingpress_payment_log_data as $log_data ) {
                $i++;
                $bookingpress_log_id = $log_data->bookingpress_payment_log_id;
                $wpdb->update(
                    $tbl_bookingpress_payment_logs,
                    array(
                    'bookingpress_invoice_id' => $i,
                    ),
                    array( 'bookingpress_payment_log_id' => $bookingpress_log_id ),
                    array( '%d' ),
                    array( '%d' )
                );
            }
        }
        $BookingPress->bookingpress_update_settings('bookingpress_last_invoice_id', 'invoice_setting', $i);
    }
}

if (version_compare($bookingpress_old_version, '1.0.13', '<') ) {
    global $BookingPress;
    $tbl_bookingpress_settings = $wpdb->prefix . 'bookingpress_settings';

    $bookingpress_approve_redirection_page_id = $bookingpress_pending_redirection_page_id = $bookingpress_canceled_redirection_page_id = 0;

    // Get default thankyou page id & cancel page id
    $bookingpress_wp_pages = get_pages();
    $bookingpress_wp_pages = json_decode(json_encode($bookingpress_wp_pages), true);
    foreach ( $bookingpress_wp_pages as $bookingpress_page_key => $bookingpress_page_val ) {
        if ($bookingpress_page_val['post_name'] == 'thank-you' ) {
            $bookingpress_pending_redirection_page_id = $bookingpress_approve_redirection_page_id = $bookingpress_page_val['ID'];
        }

        if ($bookingpress_page_val['post_name'] == 'cancel-appointment' ) {
            $bookingpress_canceled_redirection_page_id = $bookingpress_page_val['ID'];
        }
    }

    // Get current redirection urls
    $bookingpress_approve_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_approved'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if ($bookingpress_approve_redirection_url ) {
        $bookingpress_approve_redirection_tmp_page_id = url_to_postid($bookingpress_approve_redirection_url['setting_value']);
        if (! empty($bookingpress_approve_redirection_tmp_page_id) ) {
            $bookingpress_approve_redirection_page_id = $bookingpress_approve_redirection_tmp_page_id;
        }
    }

    $bookingpress_pending_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_pending'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if (! empty($bookingpress_pending_redirection_url) ) {
        $bookingpress_pending_redirection_tmp_page_id = url_to_postid($bookingpress_pending_redirection_url['setting_value']);
        if (! empty($bookingpress_pending_redirection_tmp_page_id) ) {
            $bookingpress_pending_redirection_page_id = $bookingpress_pending_redirection_tmp_page_id;
        }
    }

    $bookingpress_canceled_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_canceled'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if (! empty($bookingpress_canceled_redirection_url) ) {
        $bookingpress_canceled_redirection_tmp_page_id = url_to_postid($bookingpress_canceled_redirection_url['setting_value']);
        if (! empty($bookingpress_canceled_redirection_tmp_page_id) ) {
            $bookingpress_canceled_redirection_page_id = $bookingpress_canceled_redirection_tmp_page_id;
        }
    }

    $bookingpress_redirection_rule_setting_form = array(
    'after_appointment_approved_redirection_type'      => 'fixed_redirection',
    'after_appointment_approved_fixed_redirection_val' => $bookingpress_approve_redirection_page_id,
    'after_appointment_pending_redirection_type'       => 'fixed_redirection',
    'after_appointment_pending_fixed_redirection_val'  => $bookingpress_pending_redirection_page_id,
    'after_appointment_canceled_redirection_type'      => 'fixed_redirection',
    'after_appointment_canceled_fixed_redirection_val' => $bookingpress_canceled_redirection_page_id,
    );

    foreach ( $bookingpress_redirection_rule_setting_form as $bookingpress_redirection_rule_setting_key => $bookingpress_redirection_rule_setting_val ) {
        $BookingPress->bookingpress_update_settings($bookingpress_redirection_rule_setting_key, 'redirection_rule_setting_form', $bookingpress_redirection_rule_setting_val);
    }

    $BookingPress->bookingpress_update_settings('share_timeslot_between_services', 'general_setting', false);
}

if (version_compare($bookingpress_old_version, '1.0.14', '<') ) {

    $tbl_bookingpress_settings = $wpdb->prefix . 'bookingpress_settings';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_settings} CHANGE setting_value setting_value TEXT NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm

    $tbl_bookingpress_entries              = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $tbl_bookingpress_payment_logs         = $wpdb->prefix . 'bookingpress_payment_logs';
     // phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries, $tbl_bookingpress_appointment_bookings,$tbl_bookingpress_payment_logs are table names. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} CHANGE bookingpress_service_currency bookingpress_service_currency VARCHAR(100) ");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} CHANGE bookingpress_service_currency bookingpress_service_currency VARCHAR(100) ");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} CHANGE bookingpress_payment_currency bookingpress_payment_currency VARCHAR(100) ");
    // phpcs:enable
}

if (version_compare($bookingpress_old_version, '1.0.15', '<') ) {
    $tbl_bookingpress_form_fields = $wpdb->prefix . 'bookingpress_form_fields';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_form_fields} CHANGE `bookingpress_field_position` `bookingpress_field_position` FLOAT NULL DEFAULT '0';"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_form_fields is table name defined globally. False Positive alarm
}
if (version_compare($bookingpress_old_version, '1.0.18', '<') ) {
    global $BookingPress;
    $bookingpress_db_fields = array(
        'bookingpress_setting_name'  => 'all_category_title',
        'bookingpress_setting_value' => 'ALL',
        'bookingpress_setting_type'  => 'booking_form',
    );    
    $tbl_bookingpress_customize_settings = $wpdb->prefix . 'bookingpress_customize_settings';
    $wpdb->insert($tbl_bookingpress_customize_settings, $bookingpress_db_fields);

    $BookingPress->bookingpress_update_settings('no_payment_method_available', 'message_setting', 'Oops! There is no payment method available.');
}
if ( version_compare( $bookingpress_old_version, '1.0.20', '<' ) ) {
	global $BookingPress;
	$BookingPress->bookingpress_update_settings( 'show_time_as_per_service_duration', 'general_setting', 'true' );
	$BookingPress->bookingpress_update_settings( 'default_time_slot', 'general_setting', '30' );

    $tbl_bookingpress_entries              = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $tbl_bookingpress_payment_logs         = $wpdb->prefix . 'bookingpress_payment_logs';

    //Add appointment end time in appointment_booking table.
    //----------------------------------------------------------------------------------------------
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_appointment_end_time TIME DEFAULT NULL AFTER bookingpress_appointment_time"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    //Add payment id in appointment booking table
    //----------------------------------------------------------------------------------------------
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_payment_id bigint(11) DEFAULT 0 AFTER bookingpress_entry_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    //Update appointment end time and payment log id in appointment table.
    //----------------------------------------------------------------------------------------------
    $bookingpress_payment_logs = $wpdb->get_results("SELECT bookingpress_appointment_booking_ref, bookingpress_appointment_end_time, bookingpress_payment_log_id FROM {$tbl_bookingpress_payment_logs}", ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
    if(!empty($bookingpress_payment_logs) && is_array($bookingpress_payment_logs)){
        foreach($bookingpress_payment_logs as $k => $v){
            $bookingpress_appointment_id = intval($v['bookingpress_appointment_booking_ref']);
            $bookingpress_appointment_data = $wpdb->get_var($wpdb->prepare("SELECT COUNT(bookingpress_appointment_booking_id) FROM {$tbl_bookingpress_appointment_bookings} WHERE bookingpress_appointment_booking_id = %d", $bookingpress_appointment_id)); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
            if($bookingpress_appointment_data > 0 && !empty($v['bookingpress_appointment_end_time'])){
                $wpdb->update($tbl_bookingpress_appointment_bookings, array('bookingpress_appointment_end_time' => $v['bookingpress_appointment_end_time'], 'bookingpress_payment_id' => $v['bookingpress_payment_log_id']), array('bookingpress_appointment_booking_id' => $bookingpress_appointment_id) );
            }
        }
    }
    //----------------------------------------------------------------------------------------------

    //Add appointment end time in bookingpress_entries table.
    //----------------------------------------------------------------------------------------------
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} ADD bookingpress_appointment_end_time TIME DEFAULT NULL AFTER bookingpress_appointment_time"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm

    $bookingpress_appointment_data = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_appointment_bookings}", ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    if(!empty($bookingpress_appointment_data) && is_array($bookingpress_appointment_data)) {
        foreach($bookingpress_appointment_data as $k => $v){
            $bookingpress_entry_id = intval($v['bookingpress_entry_id']);
            $bookingpress_appointment_id = intval($v['bookingpress_appointment_booking_id']);
            if(!empty($bookingpress_entry_id) && !empty($bookingpress_appointment_id)) {
                $bookingpress_entry_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_entries} WHERE bookingpress_entry_id = %d", $bookingpress_entry_id),ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm     
                 $bookingpress_appointment_data = array();                             
                if(!empty($bookingpress_entry_data)) {        
                    if(!empty($v['bookingpress_appointment_end_time'])) {
                        $wpdb->update($tbl_bookingpress_entries, array('bookingpress_appointment_end_time' => $v['bookingpress_appointment_end_time']), array('bookingpress_entry_id' => $bookingpress_entry_id) );
                    }
                }    
            }                              
        }
    }
}
if ( version_compare( $bookingpress_old_version, '1.0.21', '<' ) ){
    global $BookingPress;
	
    $tbl_bookingpress_entries              = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $tbl_bookingpress_payment_logs         = $wpdb->prefix . 'bookingpress_payment_logs';

    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} ADD bookingpress_paid_amount float DEFAULT 0 AFTER bookingpress_appointment_status"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_paid_amount float DEFAULT 0 AFTER bookingpress_appointment_status"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_paid_amount float DEFAULT 0 AFTER bookingpress_additional_info"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm

    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} ADD bookingpress_due_amount float DEFAULT 0 AFTER bookingpress_paid_amount"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_due_amount float DEFAULT 0 AFTER bookingpress_paid_amount"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_due_amount float DEFAULT 0 AFTER bookingpress_paid_amount"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm

    //Update paid amount in entries and appointment table
    $wpdb->query("UPDATE {$tbl_bookingpress_entries} as bpa_entries, {$tbl_bookingpress_appointment_bookings} as bpa_appointment_bookings SET bpa_entries.bookingpress_paid_amount = bpa_entries.bookingpress_service_price, bpa_appointment_bookings.bookingpress_paid_amount = bpa_appointment_bookings.bookingpress_service_price WHERE bpa_entries.bookingpress_entry_id = bpa_appointment_bookings.bookingpress_entry_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries, $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    //Update paid amount in payment log table
    $wpdb->query("UPDATE {$tbl_bookingpress_payment_logs} as bpa_payment_logs SET bpa_payment_logs.bookingpress_paid_amount = bpa_payment_logs.bookingpress_service_price"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    // Add the column in the Payment log table.
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_customer_name varchar(255) DEFAULT NULL AFTER bookingpress_customer_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_customer_phone varchar(255) DEFAULT NULL AFTER bookingpress_customer_name"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_customer_country VARCHAR(60) DEFAULT NULL AFTER bookingpress_customer_lastname"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm

    // Add the column in the Appointmnet table.
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_name varchar(255) DEFAULT NULL AFTER bookingpress_customer_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_phone varchar(255) DEFAULT NULL AFTER bookingpress_customer_name"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm    
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_firstname varchar(255) DEFAULT NULL AFTER bookingpress_customer_phone"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm    
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_lastname varchar(255) DEFAULT NULL AFTER bookingpress_customer_firstname"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_country varchar(60) DEFAULT NULL AFTER bookingpress_customer_lastname"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm    
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_customer_email varchar(255) DEFAULT NULL AFTER bookingpress_customer_country"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    $bookingpress_appointment_data = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_appointment_bookings}", ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
    if(!empty($bookingpress_appointment_data) && is_array($bookingpress_appointment_data)) {
        foreach($bookingpress_appointment_data as $k => $v){
            $bookingpress_entry_id = intval($v['bookingpress_entry_id']);
            $bookingpress_appointment_id = intval($v['bookingpress_appointment_booking_id']);
            if(!empty($bookingpress_entry_id) && !empty($bookingpress_appointment_id)) {
                $bookingpress_entry_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_entries} WHERE bookingpress_entry_id = %d", $bookingpress_entry_id),ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm     
                 $bookingpress_appointment_data = array();                             
                if(!empty($bookingpress_entry_data)) {
                    $bookingpress_appointment_data = array(
                        'bookingpress_customer_name' => $bookingpress_entry_data['bookingpress_customer_name'],
                        'bookingpress_customer_phone' => $bookingpress_entry_data['bookingpress_customer_phone'],
                        'bookingpress_customer_firstname' => $bookingpress_entry_data['bookingpress_customer_firstname'],
                        'bookingpress_customer_lastname' => $bookingpress_entry_data['bookingpress_customer_lastname'],
                        'bookingpress_customer_country' => $bookingpress_entry_data['bookingpress_customer_country'],
                        'bookingpress_customer_email' => $bookingpress_entry_data['bookingpress_customer_email'],
                    );
                    $wpdb->update($tbl_bookingpress_appointment_bookings,$bookingpress_appointment_data, array('bookingpress_appointment_booking_id' => $bookingpress_appointment_id) );
                    unset($bookingpress_appointment_data['bookingpress_customer_firstname']);
                    unset($bookingpress_appointment_data['bookingpress_customer_lastname']);
                    unset($bookingpress_appointment_data['bookingpress_customer_email']);
                    $wpdb->update($tbl_bookingpress_payment_logs,$bookingpress_appointment_data, array('bookingpress_appointment_booking_ref' => $bookingpress_appointment_id) );
                }    
            }                              
        }
    }
}
if ( version_compare( $bookingpress_old_version, '1.0.22', '<' ) ){
    global $BookingPress,$wpdb;
	$BookingPress->bookingpress_update_settings( 'onsite_appointment_status', 'general_setting', 'Pending' );
}    
if ( version_compare( $bookingpress_old_version, '1.0.23', '<' ) ){
    global $BookingPress,$wpdb;    
    $default_date_format = $BookingPress->bookingpress_get_customize_settings('default_date_format', 'booking_form');
    if($default_date_format != 'F j, Y' && $default_date_format != 'd/m/Y'  && $default_date_format != 'm/d/Y'  && $default_date_format != 'Y-m-d' && $default_date_format != 'd.m.Y' && $default_date_format != 'd-m-Y' ) {
        $default_date_format = 'F j, Y';
    } 
    $BookingPress->bookingpress_update_settings( 'default_date_format', 'general_setting', $default_date_format );

    $bookingpress_after_booking_redirection = $BookingPress->bookingpress_get_settings('after_appointment_approved_fixed_redirection_val', 
    'redirection_rule_setting_form');
    $bookingpress_after_booking_redirection = !empty($bookingpress_after_booking_redirection ) ? $bookingpress_after_booking_redirection  : '';
    $bookingpress_after_cancelled_redirection = $BookingPress->bookingpress_get_settings('after_appointment_canceled_fixed_redirection_val', 
    'redirection_rule_setting_form');
    $bookingpress_after_cancelled_redirection = !empty( $bookingpress_after_cancelled_redirection ) ? $bookingpress_after_cancelled_redirection : '';    
    $bookingpress_cancel_url = $BookingPress->bookingpress_get_settings('paypal_cancel_url','payment_setting');    
    $bookingpress_cancel_url = !empty($bookingpress_cancel_url) ? url_to_postid($bookingpress_cancel_url)  : '';   
    if(empty($bookingpress_cancel_url)) {
        $bookingpress_cancel_url = !empty(get_option('page_on_front')) ? get_option('page_on_front') : 0 ;  
    }
    /*
    $title_font_size = $BookingPress->bookingpress_get_customize_settings('title_font_size', 'booking_form');
    $title_font_size = !empty($title_font_size) ? $title_font_size : '16';
    */
    $booking_form_css = $BookingPress->bookingpress_get_customize_settings('custom_css', 'booking_form');
    $booking_my_booking_css = $BookingPress->bookingpress_get_customize_settings('custom_css', 'booking_my_booking');
    $booking_form_css .= $booking_my_booking_css;    

    $tbl_bookingpress_customize_settings = $wpdb->prefix . 'bookingpress_customize_settings';
    $booking_form = array(
        'after_booking_redirection'            => $bookingpress_after_booking_redirection,
        'after_failed_payment_redirection'     => $bookingpress_cancel_url,        
        'sub_title_color'             => '#535D71',
        'custom_css'                  => $booking_form_css,
    );		
    foreach($booking_form as $key => $value) {
        $bookingpress_customize_settings_db_fields = array(
            'bookingpress_setting_name'  => $key,
            'bookingpress_setting_value' => $value,
            'bookingpress_setting_type'  => 'booking_form',
        );
        $wpdb->insert( $tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields );
    }
    $my_booking_form = array(
        'after_cancelled_appointment_redirection'     => $bookingpress_after_cancelled_redirection,
        'reset_button_title'          => __('Reset', 'bookingpress-appointment-booking'),  
        'apply_button_title'          => __('Apply', 'bookingpress-appointment-booking'),  
        'search_appointment_title'    => __('Search appointments', 'bookingpress-appointment-booking'),  
    );		    
    foreach($my_booking_form as $key => $value) {
        $bookingpress_customize_settings_db_fields = array(
            'bookingpress_setting_name'  => $key,
            'bookingpress_setting_value' => $value,
            'bookingpress_setting_type'  => 'booking_my_booking',
        );
        $wpdb->insert( $tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields );
    }
}
if ( version_compare( $bookingpress_old_version, '1.0.24', '<' ) ) {    
        global $BookingPress,$wpdb;    
    update_option('bookingpress_customize_changes_notice', 0);    
    $tbl_bookingpress_customize_settings = $wpdb->prefix . 'bookingpress_customize_settings';    
    $bookingpress_get_customize_notice = get_option('bookingpress_customize_changes_notice');    
    if(empty($bookingpress_get_customize_notice) || $bookingpress_get_customize_notice == 0) {
        $booking_form = array(
            'sub_title_color' => '#535D71',
        );	
        foreach($booking_form as $key => $value) {
            $bookingpress_customize_settings_db_fields = array(
                'bookingpress_setting_name'  => $key,
                'bookingpress_setting_value' => $value,
                'bookingpress_setting_type'  => 'booking_form',
            );
            $wpdb->update( 
                $tbl_bookingpress_customize_settings,
                $bookingpress_customize_settings_db_fields, 
                array(
                    'bookingpress_setting_name' => $key,
                    'bookingpress_setting_type' => 'booking_form',
                ) 
            );
        }
    }
}
$bookingpress_new_version = '1.0.24';
update_option('bookingpress_new_version_installed', 1);
update_option('bookingpress_version', $bookingpress_new_version);
update_option('bookingpress_updated_date_' . $bookingpress_new_version, current_time('mysql'));


