<?php
if (! class_exists('BookingPress') ) {
    class BookingPress
    {
        var $bookingpress_slugs;
        function __construct()
        {
			global $wp, $wpdb, $bookingpress_capabilities_global, $tbl_bookingpress_categories, $tbl_bookingpress_services, $tbl_bookingpress_servicesmeta, $tbl_bookingpress_customers, $tbl_bookingpress_settings, $tbl_bookingpress_default_workhours, $tbl_bookingpress_default_daysoff, $tbl_bookingpress_notifications, $tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_entries, $bookingpress_common_date_format, $tbl_bookingpress_form_fields, $tbl_bookingpress_customize_settings,$tbl_bookingpress_debug_payment_log, $tbl_bookingpress_customers_meta, $tbl_bookingpress_other_debug_logs, $bookingpress_common_time_format, $pagenow,$Bookingpress;

            $tbl_bookingpress_categories           = $wpdb->prefix . 'bookingpress_categories';
            $tbl_bookingpress_services             = $wpdb->prefix . 'bookingpress_services';
            $tbl_bookingpress_servicesmeta         = $wpdb->prefix . 'bookingpress_servicesmeta';
            $tbl_bookingpress_customers            = $wpdb->prefix . 'bookingpress_customers';
            $tbl_bookingpress_settings             = $wpdb->prefix . 'bookingpress_settings';
            $tbl_bookingpress_default_workhours    = $wpdb->prefix . 'bookingpress_default_workhours';
            $tbl_bookingpress_default_daysoff      = $wpdb->prefix . 'bookingpress_default_daysoff';
            $tbl_bookingpress_notifications        = $wpdb->prefix . 'bookingpress_notifications';
            $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
            $tbl_bookingpress_payment_logs         = $wpdb->prefix . 'bookingpress_payment_logs';
            $tbl_bookingpress_entries              = $wpdb->prefix . 'bookingpress_entries';
            $tbl_bookingpress_form_fields          = $wpdb->prefix . 'bookingpress_form_fields';
            $tbl_bookingpress_customize_settings   = $wpdb->prefix . 'bookingpress_customize_settings';
            $tbl_bookingpress_debug_payment_log    = $wpdb->prefix . 'bookingpress_debug_payment_log';
            $tbl_bookingpress_customers_meta       = $wpdb->prefix . 'bookingpress_customers_meta';
            $tbl_bookingpress_other_debug_logs     = $wpdb->prefix . 'bookingpress_other_debug_logs';                                        

            register_activation_hook(BOOKINGPRESS_DIR . '/bookingpress-appointment-booking.php', array( 'BookingPress', 'install' ));
            register_activation_hook(BOOKINGPRESS_DIR . '/bookingpress-appointment-booking.php', array( 'BookingPress', 'bookingpress_check_network_activation' ));
            register_uninstall_hook(BOOKINGPRESS_DIR . '/bookingpress-appointment-booking.php', array( 'BookingPress', 'uninstall' ));

            /* Set Page Capabilities Global */
            $bookingpress_capabilities_global = array(
            'bookingpress'               => 'bookingpress',
            'bookingpress_calendar'      => 'bookingpress_calendar',
            'bookingpress_appointments'  => 'bookingpress_appointments',
            'bookingpress_payments'      => 'bookingpress_payments',
            'bookingpress_customers'     => 'bookingpress_customers',
            'bookingpress_services'      => 'bookingpress_services',
            'bookingpress_notifications' => 'bookingpress_notifications',
            'bookingpress_customize'     => 'bookingpress_customize',
            'bookingpress_settings'      => 'bookingpress_settings',
            );

            $this->bookingpress_slugs = $this->bookingpress_page_slugs();
            $default_date_format = 'F j, Y';
            $bookingpress_settings_table_exists = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(1) FROM information_schema.tables WHERE table_schema=%s AND table_name=%s",DB_NAME,$tbl_bookingpress_settings));
            if($bookingpress_settings_table_exists == 1) {
                $default_date_format = $this->bookingpress_get_settings('default_date_format','general_setting');
                $default_date_format = !empty($default_date_format) ? $default_date_format : 'F j, Y';         
            }
			$bookingpress_common_time_format = $this->bookingpress_check_common_time_format( get_option( 'time_format' ) );
            $bookingpress_common_date_format = $this->bookingpress_check_common_date_format($default_date_format);    

            add_action('admin_menu', array( $this, 'bookingpress_menu' ), 27);
            add_action('admin_enqueue_scripts', array( $this, 'set_css' ), 11);
            add_action('admin_enqueue_scripts', array( $this, 'set_js' ), 10);

            add_action('wp_head', array( $this, 'set_front_css' ), 1);

            add_filter('plugin_action_links', array( $this, 'bookingpress_plugin_action_links' ), 10, 2);
            add_action('admin_enqueue_scripts', array( $this, 'set_global_javascript_variables' ), 10);

            if (! function_exists('is_plugin_active') ) {
                include ABSPATH . '/wp-admin/includes/plugin.php';
            }

            if (is_plugin_active('wp-rocket/wp-rocket.php') && ! is_admin() ) {
                add_filter('script_loader_tag', array( $this, 'bookingpress_prevent_rocket_loader_script' ), 10, 2);
            }

            if (! is_admin() ) {
                add_filter('script_loader_tag', array( $this, 'bookingpress_prevent_rocket_loader_script_clf' ), 10, 2);
            }

            if (is_plugin_active('js_composer/js_composer.php') && file_exists(BOOKINGPRESS_CORE_DIR . '/vc/bookingpress_class_vc_extend.php') ) {

                include_once BOOKINGPRESS_CORE_DIR . '/vc/bookingpress_class_vc_extend.php';

                global $bookingpress_vcextend;
                $bookingpress_vcextend = new Bookingpress_VCExtend();
            }

            add_filter('admin_footer_text', '__return_empty_string', 11);
            add_filter('update_footer', '__return_empty_string', 11);
            add_action('admin_init', array( $this, 'bookingpress_hide_update_notice' ), 1);

            add_action('bookingpress_user_update_meta', array( $this, 'bookingpress_user_update_meta_details' ), 10, 2);

            add_action('wp_ajax_bookingpress_remove_uploaded_file', array( $this, 'bookingpress_remove_uploaded_file' ), 10);

            add_action('deleted_user', array( $this, 'bookingpress_after_deleted_user_action' ), 10, 2);

            if (! empty($GLOBALS['wp_version']) && version_compare($GLOBALS['wp_version'], '5.7.2', '>') ) {
                add_filter('block_categories_all', array( $this, 'bookingpress_gutenberg_category' ), 10, 2);
            } else {
                add_filter('block_categories', array( $this, 'bookingpress_gutenberg_category' ), 10, 2);
            }

            add_action('enqueue_block_editor_assets', array( $this, 'bookingpress_enqueue_gutenberg_assets' ));

            add_action('wp_ajax_bookingpress_get_help_data', array( $this, 'bookingpress_get_help_data_func' ));

            add_action('admin_footer', array( $this, 'bookingpress_admin_footer_func' ));

            add_action('admin_notices', array( $this, 'bookingpress_admin_notices' ));
            add_action('bookingpress_payment_log_entry', array( $this, 'bookingpress_write_payment_log' ), 10, 6);

            add_action('wp_ajax_bookingpress_view_debug_payment_log', array( $this, 'bookingpress_view_debug_payment_log_func' ), 10);
            add_action('wp_ajax_bookingpress_lite_deactivate_plugin', array( $this, 'bookingpress_lite_deactivate_plugin_func' ));
            add_action('wp_ajax_bookingpress_clear_debug_payment_log', array( $this, 'bookingpress_clear_debug_payment_log_func' ), 10);

            add_action('wp_ajax_bookingpress_download_payment_log', array( $this, 'bookingpress_download_payment_log_func' ), 10);

            add_action('admin_init', array( $this, 'bookingpress_debug_log_download_file' ));

            add_action('admin_head', array( $this, 'bookingpress_hide_admin_notices' ));

            add_action('admin_init', array( $this, 'upgrade_data' ));

            if($pagenow == "plugins.php"){
                add_action('admin_footer', array( $this, 'bookingpress_deactivate_feedback_popup' ));
            }

            add_action('wp', array( $this, 'bookingpress_get_sysinfo_func' ));

            add_action('bookingpress_other_debug_log_entry', array( $this, 'bookingpress_other_debug_logs_func' ), 10, 5);

            register_deactivation_hook(BOOKINGPRESS_DIR . '/bookingpress-appointment-booking.php', array( 'BookingPress', 'deactivate_lite_version' ));

            add_action('wp_ajax_bookingpress_dismisss_admin_notice', array($this, 'bookingpress_dismisss_admin_notice_func'));
        }

        function bookingpress_dismisss_admin_notice_func(){
            update_option('bookingpress_customize_changes_notice', 1);
        }


        public static function deactivate_lite_version()
        {
            $dependent = 'bookingpress-appointment-booking-pro/bookingpress-appointment-booking-pro.php';
            if (is_plugin_active($dependent) ) {
                add_action('update_option_active_plugins', array( 'BookingPress', 'deactivate_pro_version' ));
            }
        }

        public static function deactivate_pro_version()
        {
            $dependent = 'bookingpress-appointment-booking-pro/bookingpress-appointment-booking-pro.php';
            deactivate_plugins($dependent);
        }

        public function bookingpress_other_debug_logs_func( $bookingpress_other_log_type = '', $bookingpress_other_log_event = '', $bookingpress_other_log_event_from = '', $bookingpress_other_log_raw_data = '', $bookingpress_ref_id = 0 )
        {
            global $wpdb, $BookingPress, $bookingpress_other_debug_log_id, $tbl_bookingpress_other_debug_logs;

            $bookingpress_active_gateway = false;

            $bookingpress_active_gateway = $BookingPress->bookingpress_get_settings($bookingpress_other_log_type, 'debug_log_setting');

            $inserted_id = 0;
            if ($bookingpress_active_gateway == 'true' ) {
                if ($bookingpress_ref_id == null ) {
                    $bookingpress_ref_id = 0;
                }

                $bookingpress_database_log_data = array(
                'bookingpress_other_log_ref_id'     => sanitize_text_field($bookingpress_ref_id),
                'bookingpress_other_log_type'       => sanitize_text_field($bookingpress_other_log_type),
                'bookingpress_other_log_event'      => sanitize_text_field($bookingpress_other_log_event),
                'bookingpress_other_log_event_from' => sanitize_text_field($bookingpress_other_log_event_from),
                'bookingpress_other_log_raw_data'   => json_encode(stripslashes_deep($bookingpress_other_log_raw_data)),
                'bookingpress_other_log_added_date' => current_time('mysql'),
                );

                $wpdb->insert($tbl_bookingpress_other_debug_logs, $bookingpress_database_log_data);
                $inserted_id = $wpdb->insert_id;

                if (empty($bookingpress_ref_id) ) {
                    $bookingpress_ref_id = $inserted_id;
                }
            }
            $bookingpress_other_debug_log_id = $bookingpress_ref_id;
            return $inserted_id;
        }

        function bookingpress_get_sysinfo_func()
        {
            if (! empty($_REQUEST['bookingpress_sysinfo']) && ( $_REQUEST['bookingpress_sysinfo'] == 'bkp999repute' ) ) {
                include 'wp-load.php';
                include_once ABSPATH . 'wp-admin/includes/plugin.php';

                $directaccesskey = 'bkp999repute';
                $directaccess    = isset($_REQUEST['bookingpress_sysinfo']) ? sanitize_text_field($_REQUEST['bookingpress_sysinfo']) : '';

                if (is_user_logged_in() || $directaccesskey == $directaccess ) {
                } else {
                    $redirect_to = user_admin_url();
                    wp_safe_redirect($redirect_to);
                }

                $geoiploaded = '';

                if (! ( extension_loaded('geoip') ) ) {
                    $geoiploaded = 'No';
                } else {
                    $geoiploaded = 'Yes';
                }

                $ziploaded = '';

                if (! ( extension_loaded('zip') ) ) {
                    $ziploaded = 'No';
                } else {
                    $ziploaded = 'Yes';
                }

                $php_version = phpversion();

                $server_ip = isset($_SERVER['SERVER_ADDR']) ? sanitize_text_field($_SERVER['SERVER_ADDR']) : '';

                $servername = isset($_SERVER['SERVER_NAME']) ? sanitize_text_field($_SERVER['SERVER_NAME']) : '';

                $upload_max_filesize = ini_get('upload_max_filesize');

                $post_max_size = ini_get('post_max_size');

                $short_open_tag = ini_get('short_open_tag');

                $max_input_vars = ini_get('max_input_vars');

                if ($short_open_tag == 1 ) {
                    $short_open_tag = 'Yes';
                } else {
                    $short_open_tag = 'No';
                }
                if (ini_get('safe_mode') ) {
                    $safe_mode = 'On';
                } else {
                    $safe_mode = 'Off';
                }

                $memory_limit = ini_get('memory_limit');

                $apache_version = '';

                $server_software = isset($_SERVER['SERVER_SOFTWARE']) ? sanitize_text_field($_SERVER['SERVER_SOFTWARE']) : '';
                $server_signature  = isset($_SERVER['SERVER_SIGNATURE']) ? sanitize_text_field($_SERVER['SERVER_SIGNATURE']) : '';

                if (function_exists('apache_get_version') ) {
                    $apache_version = apache_get_version();
                } else {
                    $apache_version = $server_software . '( ' . $server_signature . ' )';
                }

                $system_info = php_uname();

                global $wpdb;
                $mysql_server_version = $wpdb->db_version();

                // WordPress details

                $wordpress_version = get_bloginfo('version');

                $wordpress_sitename = get_bloginfo('name');

                $wordpress_sitedesc = get_bloginfo('description');

                $wordpress_wpurl = site_url();

                $wordpress_url = home_url();

                $wordpress_admin_email = get_bloginfo('admin_email');

                $wordpress_language = get_bloginfo('language');

                $wordpress_timezone = wp_timezone_string();

                $wordpress_date_format = get_option('date_format');

                $wordpress_time_format = get_option('time_format');

                $my_theme                      = wp_get_theme();
                $wordpress_templateurl         = $my_theme->get('Name');
                $wordpress_templateurl_version = $my_theme->get('Version');

                $wordpress_charset = get_bloginfo('charset');

                $wordpress_debug = WP_DEBUG;

                if ($wordpress_debug == true ) {
                    $wordpress_debug = 'On';
                } else {
                    $wordpress_debug = 'Off';
                }

                if (is_multisite() ) {
                    $wordpress_multisite = 'Yes';
                } else {
                    ( $wordpress_multisite = 'No' );
                }

                $plugin_dir_path      = WP_PLUGIN_DIR;
                $upload_dir_path      = wp_upload_dir();
                $bookingpress_active  = 'Deactive';
                $bookingpress_version = '';
                if (is_plugin_active('bookingpress-appointment-booking/bookingpress-appointment-booking.php') ) {
                    $bookingpress_active  = 'Active';
                    $bookingpress_version = get_option('bookingpress_version');
                }

                $folderpermission = substr(sprintf('%o', fileperms($upload_dir_path['basedir'])), -4);

                $folderlogpermission = substr(sprintf('%o', fileperms($plugin_dir_path . '/bookingpress-appointment-booking/log/')), -4);

                if (file_exists($plugin_dir_path . '/bookingpress-appointment-booking/log/response.txt') ) {
                    $folderlogfilepermission = substr(sprintf('%o', fileperms($plugin_dir_path . '/bookingpress-appointment-booking/log/response.txt')), -4);
                }

                $plugin_list    = get_plugins();
                $plugin_detail         = array();
                $active_plugins = get_option('active_plugins');

                foreach ( $plugin_list as $key => $plugin_detail ) {
                    $is_active = in_array($key, $active_plugins);
                    // filter for only gravityforms ones, may get some others if using our naming convention
                    if ($is_active == 1 ) {
                        $name      = substr($key, 0, strpos($key, '/'));
                        $plugins_main_arr[] = array(
                        'name'      => $plugin_detail['Name'],
                        'version'   => $plugin_detail['Version'],
                        'is_active' => $is_active,
                        );
                    }
                }

                ?>

                <style type="text/css">
                table
                {
                    border:2px solid #cccccc;
                    width:900px;
                    font-family:Verdana, Arial, Helvetica, sans-serif;
                    font-size:12px;
                }
                .title
                {
                    border-bottom:2px solid #cccccc; padding:5px 0px 5px 15px; font-weight:bold;
                }
                .leftrowtitle
                {
                    border-bottom:2px solid #cccccc; border-right:2px solid #cccccc; padding:5px 0px 5px 15px; width:250px; background-color:#333333; color:#FFFFFF; font-weight:bold;
                }
                .rightrowtitle
                {
                    border-bottom:2px solid #cccccc; padding:5px 0px 5px 15px; width:650px; background-color:#333333;  color:#FFFFFF; font-weight:bold;
                }
                .leftrowdetails
                {
                    border-bottom:2px solid #cccccc; border-right:2px solid #cccccc; padding:5px 0px 5px 15px; width:250px;
                }
                .rightrowdetails
                {
                    border-bottom:2px solid #cccccc; padding:5px 0px 5px 15px; width:650px;
                }    
                </style>


                <table border="0" cellpadding="0" cellspacing="0">
                <tr>
                    <td colspan="2" class="title">Php Details</td>
                </tr>
                <tr>
                    <td class="leftrowtitle">Variable Name</td>
                    <td class="rightrowtitle">Details</td>
                </tr>
                <tr>
                    <td class="leftrowdetails">PHP Version</td>
                    <td class="rightrowdetails"><?php echo esc_html($php_version); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">System</td>
                    <td class="rightrowdetails"><?php echo esc_html($system_info); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Apache Version</td>
                    <td class="rightrowdetails"><?php echo esc_html($apache_version); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Server Ip</td>
                    <td class="rightrowdetails"><?php echo esc_html($server_ip); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Server Name</td>
                    <td class="rightrowdetails"><?php echo esc_html($servername); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Upload Max Filesize</td>
                    <td class="rightrowdetails"><?php echo esc_html($upload_max_filesize); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Post Max Size</td>
                    <td class="rightrowdetails"><?php echo esc_html($post_max_size); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Max Input Vars</td>
                    <td class="rightrowdetails"><?php echo esc_html($max_input_vars); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Short Tag</td>
                    <td class="rightrowdetails"><?php echo esc_html($short_open_tag); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Safe Mode</td>
                    <td class="rightrowdetails"><?php echo esc_html($safe_mode); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Memory Limit</td>
                    <td class="rightrowdetails"><?php echo esc_html($memory_limit); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">MySql Version</td>
                    <td class="rightrowdetails"><?php echo esc_html($mysql_server_version); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Geo IP</td>
                    <td class="rightrowdetails"><?php echo esc_html($geoiploaded); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Zip</td>
                    <td class="rightrowdetails"><?php echo esc_html($ziploaded); ?></td>
                </tr>
                <tr>
                    <td colspan="2" style="border-bottom:2px solid #cccccc;">&nbsp;</td>
                </tr>
                <tr>
                    <td colspan="2" class="title">WordPress Details</td>
                </tr>
                <tr>
                    <td class="leftrowtitle">Variable Name</td>
                    <td class="rightrowtitle">Details</td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Site Title</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_sitename); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Tagline</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_sitedesc); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Version</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_version); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">WordPress address (URL)</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_wpurl); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Site address (URL)</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_url); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Admin Email</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_admin_email); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Charset</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_charset); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Language</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_language); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Active theme</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_templateurl) . ' (' . esc_html($wordpress_templateurl_version) . ')'; ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Debug Mode</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_debug); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Multisite Enable</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_multisite); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Timezone</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_timezone); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Date Format</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_date_format); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Time Format</td>
                    <td class="rightrowdetails"><?php echo esc_html($wordpress_time_format); ?></td>
                </tr>
                <tr>
                    <td colspan="2" style="border-bottom:2px solid #cccccc;">&nbsp;</td>
                </tr>
                <tr>
                    <td colspan="2" class="title">Bookingpress Details</td>
                </tr>
                <tr>
                    <td class="leftrowtitle">Variable Name</td>
                    <td class="rightrowtitle">Details</td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Bookingpress Status</td>
                    <td class="rightrowdetails"><?php echo esc_html($bookingpress_active); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Bookingpress Version</td>
                    <td class="rightrowdetails"><?php echo esc_html($bookingpress_version); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Upload Basedir</td>
                    <td class="rightrowdetails"><?php echo esc_html($upload_dir_path['basedir']); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Upload Baseurl</td>
                    <td class="rightrowdetails"><?php echo esc_url($upload_dir_path['baseurl']); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Upload Folder Permission</td>
                    <td class="rightrowdetails"><?php echo esc_html($folderpermission); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Bookingpress Log Folder Permission</td>
                    <td class="rightrowdetails"><?php echo esc_html($folderlogpermission); ?></td>
                </tr>
                <tr>
                    <td class="leftrowdetails">Bookingpress Log File Permission</td>
                    <td class="rightrowdetails"><?php echo esc_html($folderlogfilepermission); ?></td>
                </tr>

                <tr>
                    <td colspan="2" class="title">Active Plugin List</td>
                </tr>
                
                <?php
                foreach ( $plugins_main_arr as $myplugin ) {
                    ?>
                    <tr>
                        <td class="leftrowdetails"><?php echo esc_html($myplugin['name']); ?></td>
                        <td class="rightrowdetails">
                     <?php
                        if ($myplugin['is_active'] == 1 ) {
                            echo 'ACTIVE';
                        } else {
                            echo 'INACTIVE';
                        }
                        ?>
                          <?php echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(' . esc_html($myplugin['version']) . ')'; ?></td>
                    </tr>
                    <?php
                }
                ?>
                    
                    
                    
                <tr>
                    <td colspan="2">&nbsp;</td>
                </tr>
                </table>
                <?php
                exit;
            }
        }

        function get_bookingpress_customersmeta( $bookingpress_customer_id, $bookingpress_user_metakey )
        {
            global $wpdb, $tbl_bookingpress_customers, $tbl_bookingpress_customers_meta;
            $bookingpress_customersmeta_value = '';
            // phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared -- Reason: $tbl_bookingpress_customers_meta is table name defined globally. False Positive alarm
            $bookingpress_customersmeta_details = $wpdb->get_row($wpdb->prepare('SELECT * FROM ' . $tbl_bookingpress_customers_meta . ' WHERE bookingpress_customer_id = %d AND bookingpress_customersmeta_key = %s', $bookingpress_customer_id, $bookingpress_user_metakey), ARRAY_A);
            if (! empty($bookingpress_customersmeta_details) ) {
                $bookingpress_customersmeta_value = $bookingpress_customersmeta_details['bookingpress_customersmeta_value'];
            }

            return $bookingpress_customersmeta_value;
        }

        function update_bookingpress_customersmeta( $bookingpress_customer_id, $bookingpress_user_metakey, $bookingpress_user_metavalue )
        {
            global $wpdb, $tbl_bookingpress_customers, $tbl_bookingpress_customers_meta;
            // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers_meta is table name defined globally. False Positive alarm
            $bookingpress_exist_meta_count = $wpdb->get_var($wpdb->prepare("SELECT COUNT(bookingpress_customermeta_id) as total FROM {$tbl_bookingpress_customers_meta} WHERE bookingpress_customer_id = %d AND bookingpress_customersmeta_key = %s", $bookingpress_customer_id, $bookingpress_user_metakey));
            if ($bookingpress_exist_meta_count > 0 ) {
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers_meta is table name defined globally. False Positive alarm
                $bookingpress_exist_meta_details = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_customers_meta} WHERE bookingpress_customer_id = %d AND bookingpress_customersmeta_key = %s", $bookingpress_customer_id, $bookingpress_user_metakey), ARRAY_A);
                $bookingpress_customermeta_id    = $bookingpress_exist_meta_details['bookingpress_customermeta_id'];

                $bookingpress_user_meta_details = array(
                'bookingpress_customer_id'         => $bookingpress_customer_id,
                'bookingpress_customersmeta_key'   => $bookingpress_user_metakey,
                'bookingpress_customersmeta_value' => $bookingpress_user_metavalue,
                );

                $bookingpress_update_where_condition = array(
                'bookingpress_customermeta_id' => $bookingpress_customermeta_id,
                );

                $wpdb->update($tbl_bookingpress_customers_meta, $bookingpress_user_meta_details, $bookingpress_update_where_condition);
            } else {
                $bookingpress_user_meta_details = array(
                'bookingpress_customer_id'         => $bookingpress_customer_id,
                'bookingpress_customersmeta_key'   => $bookingpress_user_metakey,
                'bookingpress_customersmeta_value' => $bookingpress_user_metavalue,
                );

                $wpdb->insert($tbl_bookingpress_customers_meta, $bookingpress_user_meta_details);
            }
            return 1;
        }

        function delete_bookingpress_customersmeta( $bookingpress_customer_id, $bookingpress_user_metakey )
        {
            global $wpdb, $tbl_bookingpress_customers, $tbl_bookingpress_customers_meta;
            if (! empty($bookingpress_customer_id) && ! empty($bookingpress_user_metakey) ) {
                $wpdb->delete(
                    $tbl_bookingpress_customers_meta,
                    array(
                    'bookingpress_customer_id'       => $bookingpress_customer_id,
                    'bookingpress_customersmeta_key' => $bookingpress_user_metakey,
                    )
                );
            }
            return 1;
        }

        function bookingpress_lite_deactivate_plugin_func()
        {
            global $wpdb;
            check_ajax_referer('bookingpress_lite_deactivate_plugin', 'security');
            if (! empty($_POST['bpalite_reason']) && isset($_POST['bpalite_details']) ) {
                $bpalite_anonymous               = isset($_POST['bpalite_anonymous']) && sanitize_text_field($_POST['bpalite_anonymous']);
                $args                            = $_POST;
                $data                            = array(
                'option_name'  => 'bpa_deactivation_feedback',
                'option_value' => serialize($args),
                );
                $args['bpalite_site_url']        = BOOKINGPRESS_HOME_URL;
                $args['bpalite_site_ip_address'] = isset($_SERVER['REMOTE_ADDR']) ? sanitize_text_field($_SERVER['REMOTE_ADDR']) : '';
                if (! $bpalite_anonymous ) {
                    $args['bpa_lite_site_email'] = get_option('admin_email');
                }

                $url = 'https://www.bookingpressplugin.com/bpa_misc/bpalite_feedback.php';

                $response = wp_remote_post(
                    $url,
                    array(
                    'timeout' => 500,
                    'body'    => $args,
                    )
                );
            }
            echo json_encode(
                array(
                'status' => 'OK',
                )
            );
            die();
        }
        function bookingpress_plugin_action_links( $links, $file )
        {
            global $wp, $wpdb;
            if ($file == 'bookingpress-appointment-booking/bookingpress-appointment-booking.php' ) {
                if (isset($links['deactivate']) ) {
                    $deactivation_link = $links['deactivate'];
                    // Insert an onClick action to allow form before deactivating
                    $deactivation_link   = str_replace(
                        '<a',
                        '<div class="bpalite-deactivate-form-wrapper">
	                         <span class="bpalite-deactivate-form" id="bpa-deactivate-form-' . esc_attr('BookingPressLite') . '"></span>
	                     </div><a id="bpa-deactivate-link-' . esc_attr('BookingPressLite') . '"',
                        $deactivation_link
                    );
                       $links['deactivate'] = $deactivation_link;
                }
            }
            return $links;
        }
        function bookingpress_deactivate_feedback_popup()
        {
            ?>
                 <style type="text/css" id="bookingpress_deactivate_popup_css">
                    .bpa-deactivate-btn{display: inline-block;font-weight: 400;text-align: center;white-space;vertical-align: nowrap;user-select: none;border: 1px solid transparent;padding: .375rem .75rem;font-size:1rem;line-height:1.5;border-radius:0.25rem;transition:color .15s }
                    .bpa-deactivate-btn-primary{
                        color: #fff;
                        background-color: #12D488;
                        border-color:none !important;
                    }
                    .bpa-deactivate-btn:hover
                    {
                        color: white;
                    }
                    .bpalite-deactivate-form-active .bpalite-deactivate-form-bg {background: rgba( 0, 0, 0, .5 );position: fixed;top: 0;left: 0;width: 100%;height: 100%;}
                    .bpalite-deactivate-form-wrapper {position: relative;z-index: 999;display: none; }
                    .bpalite-deactivate-form-active .bpalite-deactivate-form-wrapper {display: inline-block;}
                    .bpalite-deactivate-form {display: none;}
                    .bpalite-deactivate-form-active .bpalite-deactivate-form {position: absolute;bottom: 30px;left: 0;max-width: 500px;min-width: 360px;background: #fff;white-space: normal;}
                    .bpalite-deactivate-form-head {background: #12D488;color: #fff;padding: 8px 18px;}
                    .bpalite-deactivate-form-body {padding: 8px 18px 0;color: #444;}
                    .bpalite-deactivate-form-body label[for="bpalite-remove-settings"] {font-weight: bold;}
                    .deactivating-spinner {display: none;}
                    .deactivating-spinner .spinner {float: none;margin: 4px 4px 0 18px;vertical-align: bottom;visibility: visible;}
                    .bpalite-deactivate-form-footer {padding: 0 18px 8px;}
                    .bpalite-deactivate-form-footer label[for="bpalite_anonymous"] {visibility: hidden;}
                    .bpalite-deactivate-form-footer p {display: flex;align-items: center;justify-content: space-between;margin: 0;}
                    #bpalite-deactivate-submit-form span {display: none;}
                    .bpalite-deactivate-form.process-response .bpalite-deactivate-form-body,.bpalite-deactivate-form.process-response .bpalite-deactivate-form-footer {position: relative;}
                    .bpalite-deactivate-form.process-response .bpalite-deactivate-form-body:after,.bpalite-deactivate-form.process-response .bpalite-deactivate-form-footer:after {content: "";display: block;position: absolute;top: 0;left: 0;width: 100%;height: 100%;background-color: rgba( 255, 255, 255, .5 );}
                </style>
            <?php
            $question_options                      = array();
            $question_options['list_data_options'] = array(
            'setup-difficult'  => __('Set up is too difficult', 'bookingpress-appointment-booking'),
            'docs-improvement' => __('Lack of documentation', 'bookingpress-appointment-booking'),
            'features'         => __('Not the features I wanted', 'bookingpress-appointment-booking'),
            'better-plugin'    => __('Found a better plugin', 'bookingpress-appointment-booking'),
            'incompatibility'  => __('Incompatible with theme or plugin', 'bookingpress-appointment-booking'),
            'bought-premium'   => __('I bought premium version of BookingPressLite', 'bookingpress-appointment-booking'),
            'maintenance'      => __('Other', 'bookingpress-appointment-booking'),
            );

            $html                                  = '<div class="bpalite-deactivate-form-head"><strong>' . esc_html(__('Bookingpress Lite - Sorry to see you go', 'bookingpress-appointment-booking')) . '</strong></div>';
            $html                                 .= '<div class="bpalite-deactivate-form-body">';

            if (is_array($question_options['list_data_options']) ) {
                $html .= '<div class="bpalite-deactivate-options">';
                $html .= '<p><strong>' . esc_html(__('Before you deactivate the Bookingpress Lite plugin, would you quickly give us your reason for doing so?', 'bookingpress-appointment-booking')) . '</strong></p><p>';

                foreach ( $question_options['list_data_options'] as $key => $option ) {
                    $html .= '<input type="radio" name="bpalite-deactivate-reason" id="' . esc_attr($key) . '" value="' . esc_attr($key) . '"> <label for="' . esc_attr($key) . '">' . esc_attr($option) . '</label><br>';
                }
                $html .= '</p><label id="bpalite-deactivate-details-label" for="bpalite-deactivate-reasons"><strong>' . esc_html(__('How could we improve ?', 'bookingpress-appointment-booking')) . '</strong></label><textarea name="bpalite-deactivate-details" id="bpalite-deactivate-details" rows="2" style="width:100%"></textarea>';

                $html .= '</div>';
            }
                $html .= '<hr/>';

                $html .= '</div>';
                $html .= '<p class="deactivating-spinner"><span class="spinner"></span> ' . __('Submitting form', 'bookingpress-appointment-booking') . '</p>';
                $html .= '<div class="bpalite-deactivate-form-footer"><p>';
                $html .= '<label for="bpalite_anonymous" title="'
                    . __('If you UNCHECK this then your email address will be sent along with your feedback. This can be used by bookingpresslite to get back to you for more info or a solution.', 'bookingpress-appointment-booking')
                    . '"><input type="checkbox" name="bpalite-deactivate-tracking" id="bpalite_anonymous"> ' . esc_html__('Send anonymous', 'bookingpress-appointment-booking') . '</label><br>';
                $html .= '<a id="bpalite-deactivate-submit-form"  class="bpa-deactivate-btn bpa-deactivate-btn-primary" href="#">'
                    . __('<span>Submit&nbsp;and&nbsp;</span>Deactivate', 'bookingpress-appointment-booking')
                    . '</a>';
                $html .= '</p></div>';
            ?>
                <div class="bpalite-deactivate-form-bg"></div>
               
                <script type="text/javascript">
                    jQuery(document).ready(function($){
                        var bpalite_deactivateURL = $("#bpa-deactivate-link-<?php echo esc_attr('BookingPressLite'); ?>")
                            bpalite_formContainer = $('#bpa-deactivate-form-<?php echo esc_attr('BookingPressLite'); ?>'),
                            bpalite_deactivated = true,
                            bpalite_detailsStrings = {
                                'setup-difficult' : '<?php echo esc_html__('What was the dificult part?', 'bookingpress-appointment-booking'); ?>',
                                'docs-improvement' : '<?php echo esc_html__('What can we describe more?', 'bookingpress-appointment-booking'); ?>',
                                'features' : '<?php echo esc_html__('How could we improve?', 'bookingpress-appointment-booking'); ?>',
                                'better-plugin' : '<?php echo esc_html__('Can you mention it?', 'bookingpress-appointment-booking'); ?>',
                                'incompatibility' : '<?php echo esc_html__('With what plugin or theme is incompatible?', 'bookingpress-appointment-booking'); ?>',
                                'bought-premium' : '<?php echo esc_html__('Please specify experience', 'bookingpress-appointment-booking'); ?>',
                                'maintenance' : '<?php echo esc_html__('Please specify', 'bookingpress-appointment-booking'); ?>',
                            };

                        jQuery( bpalite_deactivateURL).attr('onclick', "javascript:event.preventDefault();");
                        jQuery( bpalite_deactivateURL ).on("click", function(){

                            function BPALiteSubmitData(bpalite_data, bpalite_formContainer)
                            {
                                bpalite_data['action']          = 'bookingpress_lite_deactivate_plugin';
                                bpalite_data['security']        = '<?php echo esc_html(wp_create_nonce('bookingpress_lite_deactivate_plugin')); ?>';
                                bpalite_data['dataType']        = 'json';
                                bpalite_formContainer.addClass( 'process-response' );
                                bpalite_formContainer.find(".deactivating-spinner").show();
                                jQuery.post(ajaxurl,bpalite_data,function(response)
                                {
                                    window.location.href = bpalite_url;
                                });
                            }
                            var bpalite_url = bpalite_deactivateURL.attr( 'href' );
                            jQuery('body').toggleClass('bpalite-deactivate-form-active');
                            bpalite_formContainer.show({complete: function(){
                                var offset = bpalite_formContainer.offset();
                                if( offset.top < 50) {
                                    $(this).parent().css('top', (50 - offset.top) + 'px')
                                }
                                jQuery('html,body').animate({ scrollTop: Math.max(0, offset.top - 50) });
                            }});
          <?php  // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Reason: output is properly escaped or hardcoded ?>
                            bpalite_formContainer.html( '<?php echo $html; ?>');
                            bpalite_formContainer.on( 'change', 'input[type=radio]', function()
                            {
                                var bpalite_detailsLabel = bpalite_formContainer.find( '#bpalite-deactivate-details-label strong' );
                                var bpalite_anonymousLabel = bpalite_formContainer.find( 'label[for="bpalite_anonymous"]' )[0];
                                var bpalite_submitSpan = bpalite_formContainer.find( '#bpalite-deactivate-submit-form span' )[0];
                                var bpalite_value = bpalite_formContainer.find( 'input[name="bpalite-deactivate-reason"]:checked' ).val();

                                bpalite_detailsLabel.text( bpalite_detailsStrings[ bpalite_value ] );
                                bpalite_anonymousLabel.style.visibility = "visible";
                                bpalite_submitSpan.style.display = "inline-block";
                                if(bpalite_deactivated)
                                {
                                    bpalite_deactivated = false;
                                    jQuery('#bpalite-deactivate-submit-form').removeAttr("disabled");
                                    bpalite_formContainer.off('click', '#bpalite-deactivate-submit-form');
                                    bpalite_formContainer.on('click', '#bpalite-deactivate-submit-form', function(e){
                                        e.preventDefault();
                                        var data = {
                                            bpalite_reason: bpalite_formContainer.find('input[name="bpalite-deactivate-reason"]:checked').val(),
                                            bpalite_details: bpalite_formContainer.find('#bpalite-deactivate-details').val(),
                                            bpalite_anonymous: bpalite_formContainer.find('#bpalite_anonymous:checked').length,
                                        };
                                        BPALiteSubmitData(data, bpalite_formContainer);
                                    });
                                }
                            });
                            bpalite_formContainer.on('click', '#bpalite-deactivate-submit-form', function(e){
                                e.preventDefault();
                                BPALiteSubmitData({}, bpalite_formContainer);
                            });
                            $('.bpalite-deactivate-form-bg').on('click',function(){
                                bpalite_formContainer.fadeOut();
                                $('body').removeClass('bpalite-deactivate-form-active');
                            });
                        });
                    });
                </script>
            <?php
        }
        function upgrade_data()
        {
            global $bookingpress_version;
            $bookingpress_old_version = get_option('bookingpress_version', true);
            if (version_compare($bookingpress_old_version, '1.0.24', '<') ) {
                $bookingpress_load_upgrade_file = BOOKINGPRESS_VIEWS_DIR . '/upgrade_latest_data.php';
                include $bookingpress_load_upgrade_file;
            }
        }

        function bookingpress_hide_admin_notices()
        {
            if (! empty($_GET['page']) && ( $_GET['page'] == 'bookingpress' ) ) {
                remove_all_actions('network_admin_notices', 100);
                remove_all_actions('user_admin_notices', 100);
                remove_all_actions('admin_notices', 100);
                remove_all_actions('all_admin_notices', 100);
            }
        }

        function bookingpress_admin_notices()
        {
            global $bookingpress_version;
            $bookingpress_get_php_version = ( function_exists('phpversion') ) ? phpversion() : 0;
            $notice_html                  = '';
            if (version_compare($GLOBALS['wp_version'], '4.5', '<') ) {
                $notice_html .= '<div class="bpa-notice bpa-notice-error" style="display: block !important; position: relative !important; z-index: 9999 !important;">';
                $notice_html .= '<p>' . esc_html__('BookingPress - WordPress Appointment Booking Plugin requires a minimum WordPress version of 4.5.', 'bookingpress-appointment-booking') . '</p>';
                $notice_html .= '</div>';
             // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Reason: output is properly escaped or hardcoded
                echo $notice_html;
            }

            $bookingpress_old_version = get_option('bookingpress_version', true);
            if(($bookingpress_version <= "1.0.24") && !empty($bookingpress_old_version)){
                $bookingpress_get_customize_notice = get_option('bookingpress_customize_changes_notice');

                if(empty($bookingpress_get_customize_notice) || $bookingpress_get_customize_notice == 0){
                    $notice_html .= '<div class="notice notice-error is-dismissible bpa_customize_error_notice" style="display: block !important; position: relative !important; z-index: 9999 !important; background-color: #ea8182; color: #fff; font-weight: 600;" data-bookingpress_confirm="'.__('Are you sure you have confirm the changes?', 'bookingpress-appointment-booking').'">';
                    $bookingpress_notice_msg = esc_html__('Please save your customization changes once from BookingPress -> Customize -> Forms.', 'bookingpress-appointment-booking')." ";
                    //$bookingpress_notice_msg .= esc_html__('So please visit BookingPress "Customize" page once.', 'bookingpress-appointment-booking');
                    $notice_html .= '<p>' . $bookingpress_notice_msg . '</p>';
                    $notice_html .= '</div>';

                    echo $notice_html;
                }
            }
        }

        function bookingpress_admin_footer_func()
        {
            global $bookingpress_global_options;
            $bookingpress_global_details  = $bookingpress_global_options->bookingpress_global_options();
            $bpa_time_format_for_timeslot = $bookingpress_global_details['bpa_time_format_for_timeslot'];

            $bookingpress_site_current_language = $bookingpress_global_options->bookingpress_get_site_current_language();

            $requested_module = ! empty($_REQUEST['page']) ? sanitize_text_field($_REQUEST['page']) : 'dashboard';
            if (strpos($requested_module, 'bookingpress_') !== false || $requested_module == 'bookingpress' ) {
                $requested_module = ( ! empty($_REQUEST['page']) && ( $_REQUEST['page'] != 'bookingpress' ) ) ? sanitize_text_field(str_replace('bookingpress_', '', sanitize_text_field($_REQUEST['page']))) : 'dashboard';
                ?>
                <script>
                    var bookingpress_requested_module = '<?php echo esc_html($requested_module); ?>';
                <?php do_action('bookingpress_' . $requested_module . '_dynamic_helper_vars'); ?>
                    var app = new Vue({
                        el: '#root_app',
                        directives: { <?php do_action('bookingpress_' . $requested_module . '_dynamic_directives'); ?> },
                        components: { <?php do_action('bookingpress_' . $requested_module . '_dynamic_components'); ?> },
                        data() {
                <?php do_action('bookingpress_' . $requested_module . '_dynamic_data_fields_vars'); ?>

                            var bookingpress_return_data = <?php do_action('bookingpress_' . $requested_module . '_dynamic_data_fields'); ?>;
                            bookingpress_return_data['needHelpDrawer'] = false;
                            bookingpress_return_data['needHelpDrawerDirection'] = 'rtl';
                            bookingpress_return_data['needHelpDrawer_add'] = false;
                            bookingpress_return_data['add_needHelpDrawerDirection'] = 'rtl';
                            bookingpress_return_data['helpDrawerData'] = '';
                            bookingpress_return_data['close_modal_on_esc'] = false;
                            bookingpress_return_data['jsCurrentDate'] = new Date();        
                            bookingpress_return_data['is_display_drawer_loader'] = '0';
                            bookingpress_return_data['requested_module'] = bookingpress_requested_module;
                            bookingpress_return_data['site_locale'] = '<?php echo esc_html($bookingpress_site_current_language); ?>';

                <?php do_action('bookingpress_admin_vue_data_variables_script'); ?>

                <?php
                if (( isset($_REQUEST['page']) && $_REQUEST['page'] == 'bookingpress' ) || $requested_module == 'appointments' || $requested_module == 'calendar' || $requested_module == 'services' || $requested_module == 'staff_members' || $requested_module == 'settings' || $requested_module == 'timesheet' ) {
                    ?>
                                bookingpress_return_data['pickerOptions'] = {                                         
                                    disabledDate(Time) {                        
                                        var dd = String(Time.getDate()).padStart(2, '0');
                                        var mm = String(Time.getMonth() + 1).padStart(2, '0'); //January is 0!
                                        var yyyy = Time.getFullYear();
                                        var time = yyyy+ '-' + mm + '-' + dd ;                        
                                        var disable_date= bookingpress_return_data['disabledDates'].indexOf(time)>-1;                        
                                        var date = new Date();
                                         date.setDate(date.getDate()-1);
                                        var disable_past_date = Time.getTime() < date.getTime();
                                        if(disable_date == true) {
                                            return disable_date; 
                                        } else {
                                            return disable_past_date;
                                        }
                                      },                                         
                                },
				bookingpress_return_data['disablePastDates'] = {
					disabledDate(Time) {						
						var dd = String(Time.getDate()).padStart(2, '0');
						var mm = String(Time.getMonth() + 1).padStart(2, '0'); //January is 0!
						var yyyy = Time.getFullYear();
						var time = yyyy+ '-' + mm + '-' + dd ;
						var disable_date = bookingpress_return_data['disabledOtherDates'].indexOf(time)>-1;
						var date = new Date();
						date.setDate(date.getDate()-1);
						var disable_past_date = Time.getTime() < date.getTime();
						if(disable_date == true) {
							return disable_date; 
						} else {
							return disable_past_date;
						}
					},
				}
                    <?php
                }
                ?>
                            return bookingpress_return_data;            
                        },
                        computed: {
                <?php do_action('bookingpress_' . $requested_module . '_dynamic_computed_methods'); ?>
                        },
                        filters: {
                            bookingpress_format_time: function(value){
                                var default_time_format = '<?php echo esc_html($bpa_time_format_for_timeslot); ?>';
                                return moment(String(value), "HH:mm:ss").format(default_time_format)
                            },
                            <?php do_action('bookingpress_admin_view_filter'); ?>                           
                        },
                        mounted() {
                            <?php do_action('bookingpress_admin_vue_on_load_script'); ?>
                            document.onreadystatechange = () => { 
                                if (document.readyState == "complete") {
                                    setTimeout(function(){
                                        document.getElementById('bpa-page-loading-loader').remove();
                                        document.getElementById('bpa-main-container').style.display = 'block';
                                        if(document.getElementById('bpa-page-loading-loader-2') != null){
                                            document.getElementById('bpa-page-loading-loader-2').remove();
                                        }                                            
                                        if(document.getElementById('bpa-main-container-2') != null){
                                            document.getElementById('bpa-main-container-2').style.display = 'block';
                                        }
                                        if(document.getElementById('bpa-main-container-3') != null){
                                            document.getElementById('bpa-page-loading-loader-3').remove();
                                            document.getElementById('bpa-main-container-3').style.display = 'block';
                                        }
                                        jQuery("#bpa-loader-div").show();
                                    }, 2000);
                                } 
                              }
                            this.responsiveMenu();
                            if(bookingpress_requested_module == "settings"){
                                this.loadCalendarDates();
                            }

                            <?php do_action('bookingpress_' . $requested_module . '_dynamic_on_load_methods'); ?>
                        },
                        methods: {
                            async loadCalendarDates(selected_year = new Date().getFullYear()){
                                const vm = this
                                for(var i=0; i<=11; i++){
                                    var bookingpress_calendar_start_date = new Date();
                                    bookingpress_calendar_start_date.setFullYear(selected_year, i, 1);

                                    var bookingpress_calendar_end_date = new Date();
                                    bookingpress_calendar_end_date.setFullYear(selected_year, i+1, 0);

                                    var calendar_name = 'calendar_'+i;
                                    var bookingpress_calendar_obj = vm.$refs[calendar_name];
                                    await bookingpress_calendar_obj.move(bookingpress_calendar_start_date)
                                }
                            },
                            bookingpress_enable_modal(){
                                document.body.style.overflow = 'hidden';
                            },
                            bookingpress_disable_modal(){
                                if(document.body.classList.contains("el-popup-parent--hidden")){
                                    document.body.classList.remove("el-popup-parent--hidden");
                                    document.body.style.paddingRight = "0px";
                                }
                                document.body.style.overflow = 'auto';
                            },
                            openNeedHelper(page_name = '', module_name = '', module_title = ''){
                                const vm = this
                                vm.helpDrawerData = ''
                                vm.is_display_drawer_loader = '1'
                                vm.needHelpDrawer = !this.needHelpDrawer
                                var help_page_name = 'list_'+'<?php echo esc_html($requested_module); ?>';
                                if(page_name != ''){
                                    help_page_name = page_name
                                }
                                var help_module_name = '<?php echo esc_html($requested_module); ?>';
                                if(module_name != ''){
                                    help_module_name = module_name
                                }
                                if(module_title != ''){
                                    this.requested_module = module_title
                                }
                                
                                var postData = { action:'bookingpress_get_help_data',  module: help_module_name, page: help_page_name, type: 'list',_wpnonce:'<?php echo esc_html(wp_create_nonce('bpa_wp_nonce')); ?>' };
                                axios.post( appoint_ajax_obj.ajax_url, Qs.stringify( postData ) )
                                .then( function (response) {
                                    vm.is_display_drawer_loader = '0'
                                    vm.helpDrawerData = response.data;
                                }.bind(vm) )
                                .catch( function (error) {
                                    console.log(error);
                                });
                            },            
                            openNeedHelper_add(page_name = '', module_name = '', module_title = ''){
                                const vm = this
                                vm.helpDrawerData = ''
                                vm.is_display_drawer_loader = '1'
                                this.needHelpDrawer_add = !this.needHelpDrawer_add
                                var help_page_name = 'add_'+'<?php echo esc_html($requested_module); ?>';
                                if(page_name != ''){
                                    help_page_name = page_name
                                }
                                var help_module_name = '<?php echo esc_html($requested_module); ?>';
                                if(module_name != ''){
                                    help_module_name = module_name
                                }
                                if(module_title != ''){
                                    this.requested_module = module_title
                                }
                                var postData = { action:'bookingpress_get_help_data',  module: help_module_name, page: help_page_name, type: 'add',_wpnonce:'<?php echo esc_html(wp_create_nonce('bpa_wp_nonce')); ?>'  };
                                axios.post( appoint_ajax_obj.ajax_url, Qs.stringify( postData ) )
                                .then( function (response) {
                                    vm.is_display_drawer_loader = '0'
                                    vm.helpDrawerData = response.data;
                                }.bind(this) )
                                .catch( function (error) {
                                    console.log(error);
                                });
                            },
                            responsiveMenu(){
                                window.onload = function(){
                                    (function() {
                                       document.getElementById("bpa-mobile-menu").onclick = function() {responsiveMenuFunc()};
                                    })();
                                    function responsiveMenuFunc() {
                                        var element = document.getElementById("bpa-navbar-nav");
                                        element.classList.toggle("bpa-mobile-nav");
                                        var element2 = document.getElementById("bpa-mob-nav-overlay");
                                        element2.classList.toggle("is-visible");
                                        var element3 = document.getElementById("bpa-mobile-menu");
                                        element3.classList.toggle("is-active");
                                    }    
                                }
                            },
                            open_feature_request_url(){
                                window.open('https://www.facebook.com/groups/bookingpress', '_blank');
                            },
                <?php do_action('bookingpress_' . $requested_module . '_dynamic_vue_methods'); ?>
                        },
                    });
                </script>
                <?php
            }
        }

        function bookingpress_is_front_page()
        {
            global $wp, $wpdb, $wp_query, $post;
            if (! is_admin() ) {
                $found_matches = array();
                $pattern       = '\[(\[?)(bookingpress_.*)(?![\w-])([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
                $posts         = $wp_query->posts;
                if (is_array($posts) ) {
                    foreach ( $posts as $mypost ) {
                        if (preg_match_all('/' . $pattern . '/s', $mypost->post_content, $matches) > 0 ) {
                               $found_matches[] = $matches;
                        }
                    }
                }
                /* Remove empty array values. */
                $found_matches = $this->bpa_array_trim($found_matches);
                if (! empty($found_matches) && count($found_matches) > 0 ) {
                    return true;
                }
            }
        }

        function bpa_array_trim( $array )
        {
            if (is_array($array) ) {
                foreach ( $array as $key => $value ) {
                    if (is_array($value) ) {
                        $array[ $key ] = $this->bpa_array_trim($value);
                    } else {
                        $array[ $key ] = trim($value);
                    }
                    if (empty($array[ $key ]) ) {
                           unset($array[ $key ]);
                    }
                }
            } else {
                $array = trim($array);
            }
            return $array;
        }

        function bookingpress_get_help_data_func()
        {
            $response              = array();
            $wpnonce               = isset($_REQUEST['_wpnonce']) ? sanitize_text_field($_REQUEST['_wpnonce']) : '';
            $bpa_verify_nonce_flag = wp_verify_nonce($wpnonce, 'bpa_wp_nonce');
            if (! $bpa_verify_nonce_flag ) {
                $response['variant'] = 'error';
                $response['title']   = esc_html__('Error', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Sorry, Your request can not process due to security reason.', 'bookingpress-appointment-booking');
                wp_send_json($response);
                die();
            }
            $bookingpress_documentation_content = '';
            if (! empty($_POST['action']) && ! empty($_POST['module']) && ! empty($_POST['page']) && ! empty($_POST['type']) ) {
                $help_module = sanitize_text_field($_POST['module']);
                $help_page   = sanitize_text_field($_POST['page']);
                $help_type   = sanitize_text_field($_POST['type']);

                $bookingpress_remote_url = 'https://www.bookingpressplugin.com/';

                if ($help_type == 'list' ) {
                    $bookingpress_remote_params = array(
                    'method'  => 'POST',
                    'body'    => array(
                    'action' => 'get_documentation',
                    'module' => $help_module,
                    'page'   => 'list_' . $help_module,
                    ),
                    'timeout' => 45,
                    );

                    $bookingpress_documentation_res = wp_remote_post($bookingpress_remote_url, $bookingpress_remote_params);
                    if (! is_wp_error($bookingpress_documentation_res) ) {
                        $bookingpress_documentation_content = ! empty($bookingpress_documentation_res['body']) ? $bookingpress_documentation_res['body'] : '';
                    } else {
                        $bookingpress_documentation_content = $bookingpress_documentation_res->get_error_message();
                    }
                } elseif ($help_type == 'add' ) {
                    $bookingpress_remote_params = array(
                    'method'  => 'POST',
                    'body'    => array(
                    'action' => 'get_documentation',
                    'module' => $help_module,
                    'page'   => 'list_' . $help_module,
                    ),
                    'timeout' => 45,
                    );

                    $bookingpress_documentation_res = wp_remote_post($bookingpress_remote_url, $bookingpress_remote_params);
                    if (! is_wp_error($bookingpress_documentation_res) ) {
                        $bookingpress_documentation_content = ! empty($bookingpress_documentation_res['body']) ? $bookingpress_documentation_res['body'] : '';
                    } else {
                        $bookingpress_documentation_content = $bookingpress_documentation_res->get_error_message();
                    }
                }
            }
         // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Reason: output is properly escaped or hardcoded
            echo $bookingpress_documentation_content;
            exit();
        }

        function bookingpress_after_deleted_user_action( $user_id, $reassign = 1 )
        {
            global $wpdb, $tbl_bookingpress_customers;
            $wpdb->delete($tbl_bookingpress_customers, array( 'bookingpress_wpuser_id' => $user_id ), array( '%d' ));
        }

        /* Setting Capabilities for user */
        function bookingpress_capabilities()
        {
            $cap = array(
            'bookingpress'               => '',
            'bookingpress_calendar'      => esc_html__('Calendar', 'bookingpress-appointment-booking'),
            'bookingpress_appointments'  => esc_html__('Appointments', 'bookingpress-appointment-booking'),
            'bookingpress_payments'      => esc_html__('Payments', 'bookingpress-appointment-booking'),
            'bookingpress_customers'     => esc_html__('Customers', 'bookingpress-appointment-booking'),
            'bookingpress_services'      => esc_html__('Services', 'bookingpress-appointment-booking'),
            'bookingpress_notifications' => esc_html__('Notifications', 'bookingpress-appointment-booking'),
            'bookingpress_customize'     => esc_html__('Customize', 'bookingpress-appointment-booking'),
            'bookingpress_settings'      => esc_html__('Settings', 'bookingpress-appointment-booking'),
            );
            return $cap;
        }

        function bookingpress_prevent_rocket_loader_script( $tag, $handle )
        {
            $script   = htmlspecialchars($tag);
            $pattern2 = '/\/(wp\-content\/plugins\/bookingpress)|(wp\-includes\/js)/';
            preg_match($pattern2, $script, $match_script);

            /* Check if current script is loaded from bookingpress only */
            if (! isset($match_script[0]) || $match_script[0] == '' ) {
                return $tag;
            }

            $pattern = '/(.*?)(data\-cfasync\=)(.*?)/';
            preg_match_all($pattern, $tag, $matches);
            if (! is_array($matches) ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } elseif (! empty($matches) && ! empty($matches[2]) && ! empty($matches[2][0]) && strtolower(trim($matches[2][0])) != 'data-cfasync=' ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } elseif (! empty($matches) && empty($matches[2]) ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } else {
                return $tag;
            }
        }

        function bookingpress_prevent_rocket_loader_script_clf( $tag, $handle )
        {
            $script   = htmlspecialchars($tag);
            $pattern2 = '/\/(wp\-content\/plugins\/bookingpress)|(wp\-includes\/js)/';
            preg_match($pattern2, $script, $match_script);

            /* Check if current script is loaded from bookingpress only */
            if (! isset($match_script[0]) || $match_script[0] == '' ) {
                return $tag;
            }

            $pattern = '/(.*?)(data\-cfasync\=)(.*?)/';
            preg_match_all($pattern, $tag, $matches);

            $pattern3 = '/type\=(\'|")[a-zA-Z0-9]+\-(text\/javascript)(\'|")/';
            preg_match_all($pattern3, $tag, $match_tag);

            if (! isset($match_tag[0]) || '' == $match_tag[0] ) {
                return $tag;
            }

            if (! is_array($matches) ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } elseif (! empty($matches) && ! empty($matches[2]) && ! empty($matches[2][0]) && strtolower(trim($matches[2][0])) != 'data-cfasync=' ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } elseif (! empty($matches) && empty($matches[2]) ) {
                return str_replace(' src', ' data-cfasync="false" src', $tag);
            } else {
                return $tag;
            }
        }

        /**
         * Restrict Network Activation
         */
        public static function bookingpress_check_network_activation( $network_wide )
        {
            if (! $network_wide ) {
                return;
            }

            deactivate_plugins(plugin_basename(BOOKINGPRESS_DIR . '/bookingpress.php'), true, true);

            header('Location: ' . network_admin_url('plugins.php?deactivate=true'));
            exit;
        }

        public static function install()
        {
            global $BookingPress, $bookingpress_version;

            $_version = get_option('bookingpress_version');
            if (empty($_version) || $_version == '' ) {
                $bookingpress_custom_css_key = uniqid();
                update_option('bookingpress_custom_css_key', $bookingpress_custom_css_key);

                include_once ABSPATH . 'wp-admin/includes/upgrade.php';
                @set_time_limit(0);
                global $wpdb, $bookingpress_version;

                $charset_collate = '';
                if ($wpdb->has_cap('collation') ) {
                    if (! empty($wpdb->charset) ) {
                        $charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
                    }
                    if (! empty($wpdb->collate) ) {
                        $charset_collate .= " COLLATE $wpdb->collate";
                    }
                }

                update_option('bookingpress_version', $bookingpress_version);
                update_option('bookingpress_plugin_activated', 1);

                $bookingpress_dbtbl_create = array();
                /* Table structure for `Members activity` */
                global $tbl_bookingpress_categories, $tbl_bookingpress_services, $tbl_bookingpress_servicesmeta, $tbl_bookingpress_customers, $tbl_bookingpress_settings, $tbl_bookingpress_default_workhours, $tbl_bookingpress_default_daysoff, $tbl_bookingpress_notifications, $tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_entries, $tbl_bookingpress_form_fields, $tbl_bookingpress_customize_settings,$tbl_bookingpress_debug_payment_log, $tbl_bookingpress_customers_meta, $tbl_bookingpress_other_debug_logs;

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_categories}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_categories}`(
					`bookingpress_category_id` SMALLINT NOT NULL AUTO_INCREMENT,
					`bookingpress_category_name` VARCHAR(255) NOT NULL,
					`bookingpress_category_position` SMALLINT NOT NULL,
					`bookingpress_categorydate_created` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_category_id`)
				) {$charset_collate};";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_categories ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_services}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_services}`(
					`bookingpress_service_id` INT(11) NOT NULL AUTO_INCREMENT, 
					`bookingpress_category_id` SMALLINT NOT NULL,
					`bookingpress_service_name` VARCHAR(255) NOT NULL,
					`bookingpress_service_price` float NOT NULL,
					`bookingpress_service_duration_val` INT(11) NOT NULL,
					`bookingpress_service_duration_unit` VARCHAR(1) NOT NULL,
					`bookingpress_service_description` TEXT NOT NULL,
					`bookingpress_service_position` INT(11) NOT NULL,
					`bookingpress_servicedate_created` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_service_id`)
				) {$charset_collate};";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_services ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_servicesmeta}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_servicesmeta}`(
					`bookingpress_servicemeta_id` INT(11) NOT NULL AUTO_INCREMENT, 
					`bookingpress_service_id` INT(11) NOT NULL,					
					`bookingpress_servicemeta_name` VARCHAR(255) NOT NULL,
					`bookingpress_servicemeta_value` TEXT NOT NULL,
					`bookingpress_servicemetadate_created` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_servicemeta_id`)
				) {$charset_collate};";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_servicesmeta ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_customers}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_customers}`(
					`bookingpress_customer_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_wpuser_id` bigint(11) DEFAULT NULL,
					`bookingpress_user_login` VARCHAR(60) NOT NULL DEFAULT '',
					`bookingpress_user_status` INT(1) NOT NULL,
					`bookingpress_user_type` INT(1) DEFAULT 0,
					`bookingpress_user_firstname` VARCHAR(255) NOT NULL,
					`bookingpress_user_lastname` VARCHAR(255) NOT NULL,
					`bookingpress_user_email` VARCHAR(255) NOT NULL,
					`bookingpress_user_phone` VARCHAR(63) DEFAULT NULL,
					`bookingpress_user_country_phone` VARCHAR(60) DEFAULT NULL,
					`bookingpress_created_at` INT(1) NOT NULL DEFAULT 0,
					`bookingpress_created_by` INT(11) NOT NULL DEFAULT 0,
					`bookingpress_user_created` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_customer_id`)
				) {$charset_collate};";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_customers ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_settings}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_settings}`(
					`setting_id` int(11) NOT NULL AUTO_INCREMENT,
					`setting_name` varchar(255) NOT NULL,
					`setting_value` TEXT DEFAULT NULL,
					`setting_type` varchar(255) DEFAULT NULL,
					`updated_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`setting_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_settings ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_default_workhours}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_default_workhours}`(
					`bookingpress_workhours_id` smallint NOT NULL AUTO_INCREMENT,
					`bookingpress_workday_key` varchar(11) NOT NULL,
					`bookingpress_start_time` time DEFAULT NULL,
					`bookingpress_end_time` time DEFAULT NULL,
					`bookingpress_is_break` TINYINT(1) DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_workhours_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_default_workhours ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_default_daysoff}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_default_daysoff}`(
					`bookingpress_dayoff_id` smallint NOT NULL AUTO_INCREMENT,
					`bookingpress_name` varchar(255) NOT NULL,
					`bookingpress_dayoff_date` datetime DEFAULT NULL,
					`bookingpress_repeat` TINYINT(1) DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_dayoff_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_default_daysoff ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_notifications}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_notifications}`(
					`bookingpress_notification_id` smallint NOT NULL AUTO_INCREMENT,
					`bookingpress_notification_receiver_type` varchar(11) DEFAULT 'customer',
					`bookingpress_notification_is_custom` TINYINT(1) DEFAULT 0,
					`bookingpress_notification_name` varchar(255) NOT NULL,
					`bookingpress_notification_execution_type` varchar(11) DEFAULT 'action',
					`bookingpress_notification_status` TINYINT(1) DEFAULT 0,
					`bookingpress_notification_type` varchar(255) DEFAULT 'appointment',
					`bookingpress_notification_appointment_status` varchar(255) DEFAULT 'approved',
					`bookingpress_notification_event_action` varchar(255) DEFAULT 'booked',
					`bookingpress_notification_send_only_this` TINYINT(1) DEFAULT 0,
					`bookingpress_notification_subject` varchar(255) DEFAULT NULL,
					`bookingpress_notification_message` TEXT DEFAULT NULL,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					`bookingpress_updated_at` datetime DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_notification_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_notifications ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_appointment_bookings}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_appointment_bookings}`(
					`bookingpress_appointment_booking_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_entry_id` bigint(11) DEFAULT NULL,
                    `bookingpress_payment_id` bigint(11) DEFAULT 0,
					`bookingpress_customer_id` bigint(11) NOT NULL,
                     `bookingpress_customer_name` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_phone` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_firstname` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_lastname` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_country` VARCHAR(60) DEFAULT NULL,
                    `bookingpress_customer_email` varchar(255) DEFAULT NULL,
					`bookingpress_staff_member_id` smallint DEFAULT NULL,
					`bookingpress_service_id` INT(11) NOT NULL,
					`bookingpress_service_name` varchar(255) NOT NULL,
					`bookingpress_service_price` float NOT NULL,
					`bookingpress_service_currency` varchar(100) NOT NULL,
					`bookingpress_service_duration_val` INT(11) NOT NULL,
					`bookingpress_service_duration_unit` VARCHAR(1) NOT NULL,
					`bookingpress_appointment_date` DATE NOT NULL,
					`bookingpress_appointment_time` TIME NOT NULL,
                    `bookingpress_appointment_end_time` TIME NOT NULL,
					`bookingpress_appointment_internal_note` TEXT DEFAULT NULL,
					`bookingpress_appointment_send_notification` TINYINT(1) DEFAULT 0,
					`bookingpress_appointment_status` varchar(20) NOT NULL,	
                    `bookingpress_paid_amount` float DEFAULT 0,
                    `bookingpress_due_amount` float DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_appointment_booking_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_appointment_bookings ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_payment_logs}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_payment_logs}`(
					`bookingpress_payment_log_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_invoice_id` bigint(11) DEFAULT 0,
					`bookingpress_appointment_booking_ref` bigint(11) DEFAULT NULL,
					`bookingpress_customer_id` bigint(11) NOT NULL,
                    `bookingpress_customer_name` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_phone` varchar(255) DEFAULT NULL,
					`bookingpress_customer_firstname` varchar(255) DEFAULT NULL,
					`bookingpress_customer_lastname` varchar(255) DEFAULT NULL,
                    `bookingpress_customer_country` VARCHAR(60) DEFAULT NULL,
					`bookingpress_customer_email` varchar(255) DEFAULT NULL,
					`bookingpress_staff_member_id` smallint DEFAULT NULL,
					`bookingpress_service_id` INT(11) NOT NULL,
					`bookingpress_service_name` varchar(255) NOT NULL,
					`bookingpress_service_price` float NOT NULL,
					`bookingpress_service_duration_val` INT(11) NOT NULL,
					`bookingpress_service_duration_unit` VARCHAR(1) NOT NULL,
					`bookingpress_appointment_date` DATE NOT NULL,
					`bookingpress_appointment_start_time` TIME NOT NULL,
					`bookingpress_appointment_end_time` TIME NOT NULL,
					`bookingpress_payment_gateway` varchar(255) DEFAULT NULL,
					`bookingpress_payer_email` varchar(255) DEFAULT NULL,
					`bookingpress_transaction_id` varchar(255) DEFAULT NULL,
					`bookingpress_payment_date_time` datetime DEFAULT '1970-01-01 00:00:00',
					`bookingpress_payment_status` varchar(20) DEFAULT NULL,
					`bookingpress_payment_amount` FLOAT(8, 2) DEFAULT 0,
					`bookingpress_payment_currency` varchar(100) DEFAULT NULL,
					`bookingpress_payment_type` varchar(20) DEFAULT NULL,
					`bookingpress_payment_response` TEXT DEFAULT NULL,
					`bookingpress_additional_info` TEXT DEFAULT NULL,
                    `bookingpress_paid_amount` float DEFAULT 0,
                    `bookingpress_due_amount` float DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_payment_log_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_payment_logs ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_entries}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_entries}`(
					`bookingpress_entry_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_customer_id` bigint(11) DEFAULT NULL,
					`bookingpress_customer_name` varchar(255) DEFAULT NULL,
					`bookingpress_customer_phone` varchar(255) DEFAULT NULL,
					`bookingpress_customer_firstname` varchar(255) DEFAULT NULL,
					`bookingpress_customer_lastname` varchar(255) DEFAULT NULL,
					`bookingpress_customer_country` VARCHAR(60) DEFAULT NULL,
					`bookingpress_customer_email` varchar(255) DEFAULT NULL,
					`bookingpress_service_id` INT(11) NOT NULL,
					`bookingpress_service_name` varchar(255) NOT NULL,
					`bookingpress_service_price` float NOT NULL,
					`bookingpress_service_currency` varchar(100) NOT NULL,
					`bookingpress_service_duration_val` INT(11) NOT NULL,
					`bookingpress_service_duration_unit` VARCHAR(1) NOT NULL,
					`bookingpress_payment_gateway` VARCHAR(255) DEFAULT NULL,
					`bookingpress_appointment_date` DATE NOT NULL,
					`bookingpress_appointment_time` TIME NOT NULL,
                    `bookingpress_appointment_end_time` TIME NOT NULL,
					`bookingpress_appointment_internal_note` TEXT DEFAULT NULL,
					`bookingpress_appointment_send_notifications` TINYINT(1) DEFAULT 0,
					`bookingpress_appointment_status` varchar(20) NOT NULL,	
                    `bookingpress_paid_amount` float DEFAULT 0,
                    `bookingpress_due_amount` float DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_entry_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_entries ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_form_fields}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_form_fields}`(
					`bookingpress_form_field_id` SMALLINT NOT NULL AUTO_INCREMENT,
					`bookingpress_form_field_name` varchar(255) NOT NULL,
					`bookingpress_field_required` TINYINT(1) DEFAULT 0,
					`bookingpress_field_label` TEXT NOT NULL,
					`bookingpress_field_placeholder` TEXT DEFAULT NULL,
					`bookingpress_field_error_message` VARCHAR(255) DEFAULT NULL,
					`bookingpress_field_is_hide` TINYINT(1) DEFAULT 0,
					`bookingpress_field_position` FLOAT DEFAULT 0,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_form_field_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_form_fields ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_customize_settings}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_customize_settings}`(
					`bookingpress_setting_id` int(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_setting_name` varchar(255) NOT NULL,
					`bookingpress_setting_value` TEXT NOT NULL,
					`bookingpress_setting_type` varchar(255) NOT NULL,
					`bookingpress_created_at` timestamp DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_setting_id`)
				) {$charset_collate}";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_customize_settings ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_debug_payment_log}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_debug_payment_log}`(
					`bookingpress_payment_log_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_payment_log_ref_id` bigint(11) NOT NULL DEFAULT '0',
					`bookingpress_payment_log_gateway` varchar(255) DEFAULT NULL,
					`bookingpress_payment_log_event` varchar(255) DEFAULT NULL,
					`bookingpress_payment_log_event_from` varchar(255) DEFAULT NULL,
					`bookingpress_payment_log_status` TINYINT(1) DEFAULT '1',
					`bookingpress_payment_log_raw_data` TEXT,
					`bookingpress_payment_log_added_date` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
					PRIMARY KEY (`bookingpress_payment_log_id`)
				) {$charset_collate};";
                $bookingpress_dbtbl_create[ $tbl_bookingpress_debug_payment_log ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_customers_meta}`;
				CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_customers_meta}`(
					`bookingpress_customermeta_id` bigint(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_customer_id` bigint(11) NOT NULL,
					`bookingpress_customersmeta_key` TEXT NOT NULL,
					`bookingpress_customersmeta_value` TEXT DEFAULT NULL,
					`bookingpress_customersmeta_created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (`bookingpress_customermeta_id`)
				) {$charset_collate};";

                $bookingpress_dbtbl_create[ $tbl_bookingpress_customers_meta ] = dbDelta($sql_table);

                $sql_table = "DROP TABLE IF EXISTS `{$tbl_bookingpress_other_debug_logs}`;
			    CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_other_debug_logs}`(
			        `bookingpress_other_log_id` int(11) NOT NULL AUTO_INCREMENT,
					`bookingpress_other_log_ref_id` int(11) NOT NULL,
					`bookingpress_other_log_type` varchar(255) DEFAULT NULL,
					`bookingpress_other_log_event` varchar(255) DEFAULT NULL,
					`bookingpress_other_log_event_from` varchar(255) DEFAULT NULL,
					`bookingpress_other_log_raw_data` TEXT DEFAULT NULL,		
			        `bookingpress_other_log_added_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			        PRIMARY KEY (`bookingpress_other_log_id`)
			    ) {$charset_collate};";

                $bookingpress_dbtbl_create[ $tbl_bookingpress_other_debug_logs ] = dbDelta($sql_table);

                $BookingPress->bookingpress_add_user_role_and_capabilities();

                $BookingPress->bookingpress_install_default_notification_data();

                $BookingPress->bookingpress_install_default_general_settings_data();

                $BookingPress->bookingpress_install_default_pages();

                $BookingPress->bookingpress_install_default_customize_settings_data();

                /* Plugin Action Hook After Install Process */
                do_action('bookingpress_after_activation_hook');
                do_action('bookingpress_after_install');

            } else {
                do_action('bookingpress_reactivate_plugin');
            }

            $args  = array(
            'role'   => 'administrator',
            'fields' => 'id',
            );
            $users = get_users($args);

            if (count($users) > 0 ) {
                foreach ( $users as $key => $user_id ) {
                    $bookingpressroles = $BookingPress->bookingpress_capabilities();
                    $userObj           = new WP_User($user_id);
                    foreach ( $bookingpressroles as $bookingpressrole => $bookingpress_roledescription ) {
                        $userObj->add_cap($bookingpressrole);
                    }
                    unset($bookingpressrole);
                    unset($bookingpressroles);
                    unset($bookingpress_roledescription);
                }
            }
        }

        public static function uninstall()
        {
            global $wp, $wpdb, $tbl_bookingpress_categories, $tbl_bookingpress_services, $tbl_bookingpress_servicesmeta, $tbl_bookingpress_customers, $tbl_bookingpress_customers_meta, $tbl_bookingpress_settings, $tbl_bookingpress_default_workhours, $tbl_bookingpress_default_daysoff, $tbl_bookingpress_notifications,$tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_entries, $tbl_bookingpress_form_fields, $tbl_bookingpress_customize_settings, $tbl_bookingpress_debug_payment_log,$bookingpress_capabilities_global,$BookingPress,$tbl_bookingpress_other_debug_logs;
            /**
             * Delete Meta Values
             */
            $wpdb->query('DELETE FROM `' . $wpdb->options . "` WHERE  `option_name` LIKE  '%bookingpress\_%' AND `option_name` NOT LIKE  '%bookingpress_pro\_%'");
            /**
             * Delete Plugin DB Tables
             */
            $bookingpress_tables = array(
            $tbl_bookingpress_categories,
            $tbl_bookingpress_services,
            $tbl_bookingpress_servicesmeta,
            $tbl_bookingpress_customers,
            $tbl_bookingpress_customers_meta,
            $tbl_bookingpress_settings,
            $tbl_bookingpress_default_workhours,
            $tbl_bookingpress_default_daysoff,
            $tbl_bookingpress_notifications,
            $tbl_bookingpress_appointment_bookings,
            $tbl_bookingpress_payment_logs,
            $tbl_bookingpress_entries,
            $tbl_bookingpress_form_fields,
            $tbl_bookingpress_customize_settings,
            $tbl_bookingpress_debug_payment_log,
            $tbl_bookingpress_other_debug_logs,
            );
            foreach ( $bookingpress_tables as $table ) {
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $table is table name defined globally. False Positive alarm
                $wpdb->query("DROP TABLE IF EXISTS $table ");
            }

            //Remove all capabilities assigned to administrator
            $args  = array(
                'role'   => 'administrator',
                'fields' => 'id',
            );
            $users = get_users($args);
            if (count($users) > 0 ) {
                foreach ( $users as $key => $user_id ) {
                    $bookingpressroles = $BookingPress->bookingpress_capabilities();
                    $userObj           = new WP_User($user_id);
                    foreach ( $bookingpressroles as $bookingpressrole => $bookingpress_roledescription ) {
                        if($userObj->has_cap($bookingpressrole)){
                            $userObj->remove_cap($bookingpressrole, true);
                        }
                    }
                }
            }

            $args  = array(
                'role'   => 'bookingpress-customer',
                'fields' => 'id',
            );
            $users = get_users($args);
            if (count($users) > 0 ) {
                foreach ( $users as $key => $user_id ) {
                    $bookingpressroles = $BookingPress->bookingpress_capabilities();
                    $userObj           = new WP_User($user_id);
                    foreach ( $bookingpressroles as $bookingpressrole => $bookingpress_roledescription ) {
                        if($userObj->has_cap($bookingpressrole)){
                            $userObj->remove_cap($bookingpressrole, true);
                        }
                    }
                }
            }

            // remove capabilities
            $customer = get_role('bookingpress-customer');
            if(!empty($customer)){
                $customer->remove_cap('bookingpress-customer', true);
            }

            // remove role
            $wp_roles = new WP_Roles();
            $wp_roles->remove_role('bookingpress-customer');
            /* Plugin Action Hook After Uninstall Process */
            do_action('bookingpress_after_uninstall');
        }

        function bookingpress_menu()
        {
            global $bookingpress_slugs;

            $place = $this->get_free_menu_position(26.1, 0.3);

            $bookingpress_menu_hook = add_menu_page(esc_html__('BookingPress', 'bookingpress-appointment-booking'), esc_html__('BookingPress', 'bookingpress-appointment-booking'), 'bookingpress', $bookingpress_slugs->bookingpress, array( $this, 'route' ), BOOKINGPRESS_IMAGES_URL . '/bookingpress_menu_icon.png', $place);

            add_submenu_page($bookingpress_slugs->bookingpress, __('Dashboard', 'bookingpress-appointment-booking'), __('Dashboard', 'bookingpress-appointment-booking'), 'bookingpress', $bookingpress_slugs->bookingpress);

            add_submenu_page($bookingpress_slugs->bookingpress, __('Calendar', 'bookingpress-appointment-booking'), __('Calendar', 'bookingpress-appointment-booking'), 'bookingpress_calendar', $bookingpress_slugs->bookingpress_calendar, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Appointments', 'bookingpress-appointment-booking'), __('Appointments', 'bookingpress-appointment-booking'), 'bookingpress_appointments', $bookingpress_slugs->bookingpress_appointments, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Payments', 'bookingpress-appointment-booking'), __('Payments', 'bookingpress-appointment-booking'), 'bookingpress_payments', $bookingpress_slugs->bookingpress_payments, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Customers', 'bookingpress-appointment-booking'), __('Customers', 'bookingpress-appointment-booking'), 'bookingpress_customers', $bookingpress_slugs->bookingpress_customers, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Services', 'bookingpress-appointment-booking'), __('Services', 'bookingpress-appointment-booking'), 'bookingpress_services', $bookingpress_slugs->bookingpress_services, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Notifications', 'bookingpress-appointment-booking'), __('Notifications', 'bookingpress-appointment-booking'), 'bookingpress_notifications', $bookingpress_slugs->bookingpress_notifications, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Customize', 'bookingpress-appointment-booking'), __('Customize', 'bookingpress-appointment-booking'), 'bookingpress_customize', $bookingpress_slugs->bookingpress_customize, array( $this, 'route' ));

            add_submenu_page($bookingpress_slugs->bookingpress, __('Settings', 'bookingpress-appointment-booking'), __('Settings', 'bookingpress-appointment-booking'), 'bookingpress_settings', $bookingpress_slugs->bookingpress_settings, array( $this, 'route' ));
        }

        function bookingpress_page_slugs()
        {
            global $bookingpress_slugs;
            $bookingpress_slugs = new stdClass();
            /* Admin-Pages-Slug */

            $bookingpress_slugs->bookingpress               = 'bookingpress';
            $bookingpress_slugs->bookingpress_calendar      = 'bookingpress_calendar';
            $bookingpress_slugs->bookingpress_appointments  = 'bookingpress_appointments';
            $bookingpress_slugs->bookingpress_payments      = 'bookingpress_payments';
            $bookingpress_slugs->bookingpress_customers     = 'bookingpress_customers';
            $bookingpress_slugs->bookingpress_services      = 'bookingpress_services';
            $bookingpress_slugs->bookingpress_notifications = 'bookingpress_notifications';
            $bookingpress_slugs->bookingpress_customize     = 'bookingpress_customize';
            $bookingpress_slugs->bookingpress_settings      = 'bookingpress_settings';

            return $bookingpress_slugs;
        }

        function get_free_menu_position( $start, $increment = 0.1 )
        {
            foreach ( $GLOBALS['menu'] as $key => $menu ) {
                $menus_positions[] = floatval($key);
            }
            if (! in_array($start, $menus_positions) ) {
                $start = strval($start);
                return $start;
            } else {
                $start += $increment;
            }
            /* the position is already reserved find the closet one */
            while ( in_array($start, $menus_positions) ) {
                $start += $increment;
            }
            $start = strval($start);
            return $start;
        }

        function route()
        {
            global $bookingpress_slugs;
            if (isset($_REQUEST['page']) ) {
                $pageWrapperClass = '';
                if (is_rtl() ) {
                    $pageWrapperClass = 'bookingpress_page_rtl';
                }
                echo '<div class="bookingpress_page_wrapper ' . esc_html($pageWrapperClass) . '" id="root_app">';
                $requested_page = sanitize_text_field($_REQUEST['page']);
                do_action('bookingpress_admin_messages', $requested_page);

                if (file_exists(BOOKINGPRESS_VIEWS_DIR . '/bookingpress_main.php') ) {
                    include BOOKINGPRESS_VIEWS_DIR . '/bookingpress_main.php';
                }
                echo '</div>';
            }
        }

        /* Setting Admin CSS  */
        function set_css()
        {
            global $bookingpress_slugs;

            echo "<style type='text/css'>#toplevel_page_bookingpress .wp-menu-image img{ padding: 0 !important; opacity: 1 !important; }</style>";

            /* Plugin Style */
            wp_register_style('bookingpress_element_css', BOOKINGPRESS_URL . '/css/bookingpress_element_theme.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_fonts_css', BOOKINGPRESS_URL . '/css/fonts/fonts.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_calendar_css', BOOKINGPRESS_URL . '/css/bookingpress_vue_calendar.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_root_variables_css', BOOKINGPRESS_URL . '/css/bookingpress_variables.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_components_css', BOOKINGPRESS_URL . '/css/bookingpress_admin_components.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_admin_css', BOOKINGPRESS_URL . '/css/bookingpress_admin.css', array( 'bookingpress_root_variables_css' ), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_admin_rtl_css', BOOKINGPRESS_URL . '/css/bookingpress_admin_rtl.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_tel_input', BOOKINGPRESS_URL . '/css/bookingpress_tel_input.css', array(), BOOKINGPRESS_VERSION);

            /* Add CSS file only for plugin pages. */
            if (isset($_REQUEST['page']) && in_array(sanitize_text_field($_REQUEST['page']), (array) $bookingpress_slugs) ) {
                wp_enqueue_style('bookingpress_element_css');
                wp_enqueue_style('bookingpress_fonts_css');

                if (! empty($_REQUEST['page']) && ( sanitize_text_field($_REQUEST['page']) == 'bookingpress_calendar' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_customize' ) ) {
                    wp_enqueue_style('bookingpress_calendar_css');
                }

                wp_enqueue_style('bookingpress_root_variables_css');
                wp_enqueue_style('bookingpress_components_css');
                wp_enqueue_style('bookingpress_admin_css');
                if (is_rtl() ) {
                    wp_enqueue_style('bookingpress_admin_rtl_css');
                }

                if (! empty($_REQUEST['page']) && ( sanitize_text_field($_REQUEST['page']) == 'bookingpress_customers' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_customize' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_settings' || $_REQUEST['page'] == 'bookingpress_myprofile' ) ) {
                    wp_enqueue_style('bookingpress_tel_input');
                }
            }
        }


        /* Setting Front CSS */
        function set_front_css( $force_enqueue = 0 )
        {
            global $wpdb, $tbl_bookingpress_form_fields;
            wp_register_style('bookingpress_element_css', BOOKINGPRESS_URL . '/css/bookingpress_element_theme.css', array(), BOOKINGPRESS_VERSION);

            wp_register_style('bookingpress_fonts_css', BOOKINGPRESS_URL . '/css/fonts/fonts.css', array(), BOOKINGPRESS_VERSION);
            wp_register_style('bookingpress_front_css', BOOKINGPRESS_URL . '/css/bookingpress_front.css', array(), BOOKINGPRESS_VERSION);
            wp_register_style('bookingpress_front_rtl_css', BOOKINGPRESS_URL . '/css/bookingpress_front_rtl.css', array(), BOOKINGPRESS_VERSION);
            wp_register_style('bookingpress_calendar_css', BOOKINGPRESS_URL . '/css/bookingpress_vue_calendar.css', array(), BOOKINGPRESS_VERSION);
            wp_register_style('bookingpress_tel_input', BOOKINGPRESS_URL . '/css/bookingpress_tel_input.css', array(), BOOKINGPRESS_VERSION);

            $bookingress_load_js_css_all_pages = $this->bookingpress_get_settings('load_js_css_all_pages', 'general_setting');

            $bookingpress_after_approved_payment_page_id = $this->bookingpress_get_settings('after_appointment_approved_fixed_redirection_val', 'redirection_rule_setting_form');
            $bookingpress_after_pending_payment_page_id = $this->bookingpress_get_settings('after_appointment_pending_fixed_redirection_val', 'redirection_rule_setting_form');
            $bookingpress_after_canceled_payment_page_id = $this->bookingpress_get_settings('after_appointment_canceled_fixed_redirection_val', 'redirection_rule_setting_form');

            $bookingpress_current_page_id = get_the_ID();

            if ($this->bookingpress_is_front_page() || ( $bookingress_load_js_css_all_pages == 'true' ) || ( $force_enqueue == 1 ) || ($bookingpress_after_approved_payment_page_id == $bookingpress_current_page_id) || ($bookingpress_after_pending_payment_page_id == $bookingpress_current_page_id) || ($bookingpress_after_canceled_payment_page_id == $bookingpress_current_page_id) ) {
                wp_enqueue_style('bookingpress_element_css');
                wp_enqueue_style('bookingpress_fonts_css');
                wp_enqueue_style('bookingpress_front_css');
                
                $bpa_phone_number_field_detail = wp_cache_get( 'bookingpress_phone_field_data' );
                if( false === $bpa_phone_number_field_detail ){
                    $bookingpress_form_field_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_form_fields} WHERE bookingpress_form_field_name = %s", 'phone_number'), ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_form_fields is table name defined globally. False Positive alarm
                    wp_cache_set( 'bookingpress_phone_field_data', $bookingpress_form_field_data );
                } else {
                    $bookingpress_form_field_data = $bpa_phone_number_field_detail;
                }
                    
                $bookingpress_is_field_hide = isset($bookingpress_form_field_data['bookingpress_field_is_hide']) ? intval($bookingpress_form_field_data['bookingpress_field_is_hide']) : 1;
                if ($bookingpress_is_field_hide == 0 ) {
                    wp_enqueue_style('bookingpress_tel_input');
                }

                if (is_rtl() ) {
                    wp_enqueue_style('bookingpress_front_rtl_css');
                }

                $bookingpress_customize_css_key = get_option('bookingpress_custom_css_key', true);

                if (file_exists(BOOKINGPRESS_UPLOAD_DIR . '/bookingpress_front_custom_' . $bookingpress_customize_css_key . '.css') ) {
                    wp_register_style('bookingpress_front_custom_css', BOOKINGPRESS_UPLOAD_URL . '/bookingpress_front_custom_' . $bookingpress_customize_css_key . '.css', array( 'bookingpress_front_css' ), BOOKINGPRESS_VERSION);
                    wp_enqueue_style('bookingpress_front_custom_css');

                    $bookingpress_fonts            = array();
                    $bookingform_title_font_family = $this->bookingpress_get_customize_settings('title_font_family', 'booking_form');
                    if (! empty($bookingform_title_font_family) && ! in_array($bookingform_title_font_family, $bookingpress_fonts) ) {
                        array_push($bookingpress_fonts, $bookingform_title_font_family);
                    }

                    $bookingform_content_font_family = $this->bookingpress_get_customize_settings('content_font_family', 'booking_form');
                    if (! empty($bookingform_content_font_family) && ! in_array($bookingform_content_font_family, $bookingpress_fonts) ) {
                        array_push($bookingpress_fonts, $bookingform_content_font_family);
                    }

                    $mybooking_title_font_family = $this->bookingpress_get_customize_settings('title_font_family', 'booking_my_booking');
                    if (! empty($mybooking_title_font_family) && ! in_array($mybooking_title_font_family, $bookingpress_fonts) ) {
                        array_push($bookingpress_fonts, $mybooking_title_font_family);
                    }

                    $mybooking_content_font_family = $this->bookingpress_get_customize_settings('content_font_family', 'booking_my_booking');
                    if (! empty($mybooking_content_font_family) && ! in_array($mybooking_content_font_family, $bookingpress_fonts) ) {
                        array_push($bookingpress_fonts, $mybooking_content_font_family);
                    }

                    if (! empty($bookingpress_fonts) && is_array($bookingpress_fonts) ) {
                        foreach ( $bookingpress_fonts as $bookingpress_font_key => $bookingpress_font_val ) {
                            wp_register_style('bookingpress_front_font_css_' . $bookingpress_font_val, 'https://fonts.googleapis.com/css2?family=' . $bookingpress_font_val . '&display=swap', array(), BOOKINGPRESS_VERSION);
                            wp_enqueue_style('bookingpress_front_font_css_' . $bookingpress_font_val);
                        }
                    }
                }

                if (file_exists(BOOKINGPRESS_UPLOAD_DIR . '/bookingpress_front_mybookings_custom_' . $bookingpress_customize_css_key . '.css') ) {
                    wp_register_style('bookingpress_front_mybookings_custom_css', BOOKINGPRESS_UPLOAD_URL . '/bookingpress_front_mybookings_custom_' . $bookingpress_customize_css_key . '.css', array( 'bookingpress_front_css' ), BOOKINGPRESS_VERSION);
                    wp_enqueue_style('bookingpress_front_mybookings_custom_css');
                }

                wp_enqueue_style('bookingpress_calendar_css');

                do_action('bookingpress_add_frontend_css');                
            }
        }

        /* Setting Front JS */
        function set_front_js( $force_enqueue = 0 )
        {
            global $wpdb, $tbl_bookingpress_form_fields;

            wp_register_script('bookingpress_vue_js', BOOKINGPRESS_URL . '/js/bookingpress_vue.min.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_axios_js', BOOKINGPRESS_URL . '/js/bookingpress_axios.min.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_element_js', BOOKINGPRESS_URL . '/js/bookingpress_element.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_wordpress_vue_helper_js', BOOKINGPRESS_URL . '/js/bookingpress_wordpress_vue_qs_helper.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_calendar_js', BOOKINGPRESS_URL . '/js/bookingpress_vue_calendar.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_moment_js', BOOKINGPRESS_URL . '/js/bookingpress_moment.min.js', array(), BOOKINGPRESS_VERSION, true);

            wp_register_script('bookingpress_tel_input_js', BOOKINGPRESS_URL . '/js/bookingpress_tel_input.js', array(), BOOKINGPRESS_VERSION, true);

            $bookingress_load_js_css_all_pages = $this->bookingpress_get_settings('load_js_css_all_pages', 'general_setting');

            if ($this->bookingpress_is_front_page() || ( $bookingress_load_js_css_all_pages == 'true' ) || ( $force_enqueue == 1 ) ) {
                $get_already_loaded_vue_setting_val = $this->bookingpress_get_settings('use_already_loaded_vue', 'general_setting');
                if (! $get_already_loaded_vue_setting_val || $get_already_loaded_vue_setting_val == 'false' ) {
                    wp_enqueue_script('bookingpress_vue_js');
                }
                wp_enqueue_script('bookingpress_axios_js');
                wp_enqueue_script('bookingpress_wordpress_vue_helper_js');
                wp_enqueue_script('bookingpress_element_js');
                wp_enqueue_script('bookingpress_calendar_js');
                wp_enqueue_script('bookingpress_moment_js');

                $bpa_phone_number_field_detail = wp_cache_get( 'bookingpress_phone_field_data' );
                if( false === $bpa_phone_number_field_detail ){
                    $bookingpress_form_field_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_form_fields} WHERE bookingpress_form_field_name = %s", 'phone_number'), ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_form_fields is table name defined globally. False alarm
                    wp_cache_set( 'bookingpress_phone_field_data', $bookingpress_form_field_data );
                } else {
                    $bookingpress_form_field_data = $bpa_phone_number_field_detail;
                }

                $bookingpress_is_field_hide = isset($bookingpress_form_field_data['bookingpress_field_is_hide']) ? intval($bookingpress_form_field_data['bookingpress_field_is_hide']) : 1;
                if ($bookingpress_is_field_hide == 0 ) {
                    wp_enqueue_script('bookingpress_tel_input_js');
                }

                global $bookingpress_global_options;
                $bookingpress_site_current_language = $bookingpress_global_options->bookingpress_get_site_current_language();

                if ($bookingpress_site_current_language != 'en' ) {
                    wp_register_script('bookingpress_vue_cal_locale', BOOKINGPRESS_URL . '/js/locales/' . $bookingpress_site_current_language . '.js', array(), BOOKINGPRESS_VERSION, true);
                    wp_enqueue_script('bookingpress_vue_cal_locale');

                    wp_register_script('bookingpress_elements_locale', BOOKINGPRESS_URL . '/js/elements_locale/' . $bookingpress_site_current_language . '.js', array(), BOOKINGPRESS_VERSION, true);
                    wp_enqueue_script('bookingpress_elements_locale');
                } else {
                    wp_register_script('bookingpress_elements_locale', BOOKINGPRESS_URL . '/js/bookingpress_element_en.js', array(), BOOKINGPRESS_VERSION, true);
                    wp_enqueue_script('bookingpress_elements_locale');
                }

                wp_localize_script('bookingpress_vue_js', 'appoint_ajax_obj', array( 'ajax_url' => admin_url('admin-ajax.php') ));

                do_action('bookingpress_add_frontend_js');
            }
        }

        /* Setting Admin JavaScript */
        function set_js()
        {
            global $bookingpress_slugs, $bookingpress_global_options;

            $bookingpress_site_current_language = $bookingpress_global_options->bookingpress_get_site_current_language();

            /* Plugin Scripts */
            wp_register_script('bookingpress_admin_custom_js', BOOKINGPRESS_URL . '/js/bookingpress_admin_custom.js', array(), BOOKINGPRESS_VERSION);
            wp_enqueue_script('bookingpress_admin_custom_js');
            
            wp_register_script('bookingpress_admin_js', BOOKINGPRESS_URL . '/js/bookingpress_vue.min.js', array(), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_axios_js', BOOKINGPRESS_URL . '/js/bookingpress_axios.min.js', array(), BOOKINGPRESS_VERSION);
            wp_register_script('bookingpress_sortable_js', BOOKINGPRESS_URL . '/js/bookingpress_Sortable.min.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);
            wp_register_script('bookingpress_draggable_js', BOOKINGPRESS_URL . '/js/bookingpress_draggable.min.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_element_js', BOOKINGPRESS_URL . '/js/bookingpress_element.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);

            if ($bookingpress_site_current_language == 'en' ) {
                wp_register_script('bookingpress_element_en_js', BOOKINGPRESS_URL . '/js/bookingpress_element_en.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);
            }

            wp_register_script('bookingpress_wordpress_vue_helper_js', BOOKINGPRESS_URL . '/js/bookingpress_wordpress_vue_qs_helper.js', array(), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_calendar_js', BOOKINGPRESS_URL . '/js/bookingpress_vue_calendar.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_v-calendar_js', BOOKINGPRESS_URL . '/js/bookingpress_v-calendar.js', array( 'bookingpress_admin_js' ), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_moment_js', BOOKINGPRESS_URL . '/js/bookingpress_moment.min.js', array(), BOOKINGPRESS_VERSION);

            wp_register_script('bookingpress_tel_input_js', BOOKINGPRESS_URL . '/js/bookingpress_tel_input.js', array(), BOOKINGPRESS_VERSION);

            /* Add JS file only for plugin pages. */
            if (isset($_REQUEST['page']) && ( sanitize_text_field($_REQUEST['page']) == 'bookingpress_services' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_customize' ) ) {
                wp_enqueue_script('bookingpress_sortable_js');
                wp_enqueue_script('bookingpress_draggable_js');
            }

            if (isset($_REQUEST['page']) && in_array(sanitize_text_field($_REQUEST['page']), (array) $bookingpress_slugs) ) {
                wp_enqueue_script('bookingpress_admin_js');
                wp_enqueue_script('bookingpress_axios_js');
                wp_enqueue_script('bookingpress_wordpress_vue_helper_js');
                wp_enqueue_script('bookingpress_element_js');
                wp_enqueue_script('bookingpress_moment_js');
                if ($bookingpress_site_current_language == 'en' ) {
                    wp_enqueue_script('bookingpress_element_en_js');
                }

                if ($bookingpress_site_current_language != 'en' ) {
                    wp_register_script('bookingpress_elements_locale', BOOKINGPRESS_URL . '/js/elements_locale/' . $bookingpress_site_current_language . '.js', array( 'bookingpress_element_js' ), BOOKINGPRESS_VERSION);
                    wp_enqueue_script('bookingpress_elements_locale');
                }

                if (! empty($_REQUEST['page']) && ( sanitize_text_field($_REQUEST['page']) == 'bookingpress_customers' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_customize' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_settings' || ( $_REQUEST['page'] == 'bookingpress_myprofile' ) ) ) {
                    wp_enqueue_script('bookingpress_tel_input_js');
                }
            }

            if (isset($_REQUEST['page']) && ( sanitize_text_field($_REQUEST['page']) == 'bookingpress_calendar' || sanitize_text_field($_REQUEST['page']) == 'bookingpress_customize' ) ) {
                wp_enqueue_script('bookingpress_calendar_js');

                if ($bookingpress_site_current_language != 'en' ) {
                    wp_register_script('bookingpress_vue_cal_locale', BOOKINGPRESS_URL . '/js/locales/' . $bookingpress_site_current_language . '.js', array(), BOOKINGPRESS_VERSION);
                    wp_enqueue_script('bookingpress_vue_cal_locale');
                }
            }

            if (isset($_REQUEST['page']) && sanitize_text_field($_REQUEST['page']) == 'bookingpress_settings' ) {
                wp_enqueue_script('bookingpress_v-calendar_js');
            }

            if (isset($_REQUEST['page']) && ( isset($_REQUEST['page']) && sanitize_text_field($_REQUEST['page']) == 'bookingpress' ) ) {
                wp_register_script('bookingpress_charts_js', BOOKINGPRESS_URL . '/js/bookingpress_chart.min.js', array(), BOOKINGPRESS_VERSION);
                wp_enqueue_script('bookingpress_charts_js');
            }

            wp_localize_script('bookingpress_admin_custom_js', 'appoint_ajax_obj', array( 'ajax_url' => admin_url('admin-ajax.php') ));
        }
        function set_global_javascript_variables()
        {
            echo '<script type="text/javascript" data-cfasync="false">';
            echo '__BOOKINGPRESSIMAGEURL = "' . esc_url(BOOKINGPRESS_IMAGES_URL) . '";';
            echo '</script>';
        }
        /**
         * Hide WordPress Update Notifications In Plugin's Pages
         */
        function bookingpress_hide_update_notice()
        {
            global $bookingpress_slugs;
            if (isset($_REQUEST['page']) && in_array(sanitize_text_field($_REQUEST['page']), (array) $bookingpress_slugs) ) {
                remove_action('admin_notices', 'update_nag', 3);
                remove_action('network_admin_notices', 'update_nag', 3);
                remove_action('admin_notices', 'maintenance_nag');
                remove_action('network_admin_notices', 'maintenance_nag');
                remove_action('admin_notices', 'site_admin_notice');
                remove_action('network_admin_notices', 'site_admin_notice');
                remove_action('load-update-core.php', 'wp_update_plugins');
                add_filter('pre_site_transient_update_core', array( $this, 'bookingpress_remove_core_updates' ));
                add_filter('pre_site_transient_update_plugins', array( $this, 'bookingpress_remove_core_updates' ));
                add_filter('pre_site_transient_update_themes', array( $this, 'bookingpress_remove_core_updates' ));
            }
        }

        function bookingpress_remove_core_updates()
        {
            global $wp_version;
            return (object) array(
            'last_checked'    => time(),
            'version_checked' => $wp_version,
            );
        }

        function bookingpress_add_user_role_and_capabilities()
        {
            global $wp_roles;
            $role_name  = 'BookingPress Customer';
            $role_slug  = sanitize_title($role_name);
            $basic_caps = array(
            $role_slug => true,
            'read'     => true,
            'level_0'  => true,
            );

            $wp_roles->add_role($role_slug, $role_name, $basic_caps);
        }


        function bookingpress_validate_username( $user_login, $invalid_username = '' )
        {
            $sanitized_user_login = sanitize_user($user_login);
            $err                  = '';
            // Check the username
            if ($sanitized_user_login == '' ) {
                $err = esc_html__('Please enter a username.', 'bookingpress-appointment-booking');
            } elseif (! validate_username($user_login) ) {
                if ($invalid_username == '' ) {
                    $err_msg = esc_html__('This username is invalid because it uses illegal characters. Please enter a valid username.', 'bookingpress-appointment-booking');
                } else {
                    $err_msg = $invalid_username;
                }
                $err = ( ! empty($err_msg) ) ? $err_msg : esc_html__('This username is invalid because it uses illegal characters. Please enter a valid username.', 'bookingpress-appointment-booking');
            } elseif (username_exists($sanitized_user_login) ) {
                $err = esc_html__('This username is already registered, please choose another one.', 'bookingpress-appointment-booking');
            }
            return $err;
        }


        function bookingpress_validate_email( $user_email, $invalid_email = '' )
        {
            $err = '';
            // Check the username
            if ('' == $user_email ) {
                $err = esc_html__('Please type your e-mail address.', 'bookingpress-appointment-booking');
            } elseif (! is_email($user_email) ) {
                if ($invalid_email == '' ) {
                    $err_msg = esc_html__('Please enter valid email address.', 'bookingpress-appointment-booking');
                } else {
                    $err_msg = $invalid_email;
                }
                $err = ( ! empty($err_msg) ) ? $err_msg : esc_html__('Please enter valid email address.', 'bookingpress-appointment-booking');
            } elseif (email_exists($user_email) ) {
                $err = esc_html__('This email is already registered, please choose another one.', 'bookingpress-appointment-booking');
            }
            return $err;
        }

        function bookingpress_user_update_meta_details( $user_ID, $posted_data = array() )
        {
            if (! empty($user_ID) && ! empty($posted_data) ) {
                $user = new WP_User($user_ID);
                foreach ( $posted_data as $key => $val ) {
                    if ($key == 'first_name' || $key == 'last_name' ) {
                        $val = trim(sanitize_text_field($val));
                    } elseif ($key == 'role' || $key == 'roles' ) {
                        if (isset($val) && is_array($val) && ! empty($val) ) {
                            $count = 0;
                            foreach ( $val as $v ) {
                                if ($count == 0 ) {
                                    $user->set_role($v);
                                } else {
                                    $user->add_role($v);
                                }
                                $count++;
                            }
                        } else {
                            $user->add_role($val);
                        }
                    }
                    update_user_meta($user_ID, $key, $val);
                }
            }
        }

        function bookingpress_file_upload_function( $source, $destination )
        {
            if (empty($source) || empty($destination) ) {
                return false;
            }

            if (! function_exists('WP_Filesystem') ) {
                include_once ABSPATH . 'wp-admin/includes/file.php';
            }

            WP_Filesystem();
            global $wp_filesystem;

            $file_content = $wp_filesystem->get_contents($source);

            $result = $wp_filesystem->put_contents($destination, $file_content, 0777);

            return $result;
        }


        function bookingpress_remove_uploaded_file()
        {
            global $wpdb;
            $response              = array();
            $wpnonce               = isset($_REQUEST['_wpnonce']) ? sanitize_text_field($_REQUEST['_wpnonce']) : '';
            $bpa_verify_nonce_flag = wp_verify_nonce($wpnonce, 'bpa_wp_nonce');
            if (! $bpa_verify_nonce_flag ) {
                $response['variant'] = 'error';
                $response['title']   = esc_html__('Error', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Sorry, Your request can not process due to security reason.', 'bookingpress-appointment-booking');
                wp_send_json($response);
                die();
            }
            if (! empty($_POST) && ! empty($_POST['upload_file_url']) ) {
                $bookingpress_uploaded_avatar_url = esc_url_raw($_POST['upload_file_url']);
                $bookingpress_file_name_arr       = explode('/', $bookingpress_uploaded_avatar_url);
                $bookingpress_file_name           = $bookingpress_file_name_arr[ count($bookingpress_file_name_arr) - 1 ];
                unlink(BOOKINGPRESS_TMP_IMAGES_DIR . '/' . $bookingpress_file_name);
            }
        }


        public function bookingpress_update_settings( $setting_name, $setting_type, $setting_value = '' )
        {
            global $wpdb, $tbl_bookingpress_settings;
            if (! empty($setting_name) ) {
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
                $bookingpress_check_record_existance = $wpdb->get_var($wpdb->prepare("SELECT COUNT(setting_id) FROM `{$tbl_bookingpress_settings}` WHERE setting_name = %s AND setting_type = %s", $setting_name, $setting_type));

                if ($bookingpress_check_record_existance > 0 ) {
                    // If record already exists then update data.
                    $bookingpress_update_data = array(
                     'setting_value' => ( ! empty($setting_value) && gettype($setting_value) === 'boolean' ) ? $setting_value : sanitize_text_field($setting_value),
                     'setting_type'  => $setting_type,
                     'updated_at'    => current_time('mysql'),
                    );

                    $bpa_update_where_condition = array(
                     'setting_name' => $setting_name,
                     'setting_type' => $setting_type,
                    );

                    $bpa_update_affected_rows = $wpdb->update($tbl_bookingpress_settings, $bookingpress_update_data, $bpa_update_where_condition);
                    if ($bpa_update_affected_rows > 0 ) {
                        wp_cache_delete($setting_name);
                        wp_cache_set($setting_name, $setting_value);
                        return 1;
                    }
                } else {
                    // If record not exists hen insert data.

                    $bookingpress_insert_data = array(
                    'setting_name'  => $setting_name,
                    'setting_value' => ( ! empty($setting_value) && gettype($setting_value) === 'boolean' ) ? $setting_value : sanitize_text_field($setting_value),
                    'setting_type'  => $setting_type,
                    'updated_at'    => current_time('mysql'),
                    );

                    $bookingpress_inserted_id = $wpdb->insert($tbl_bookingpress_settings, $bookingpress_insert_data);
                    if ($bookingpress_inserted_id > 0 ) {
                        wp_cache_delete($setting_name);
                        wp_cache_set($setting_name, $setting_value);
                        return 1;
                    }
                }
            }

            return 0;
        }

        public function bookingpress_get_customize_settings( $setting_names, $setting_type ){

            if( empty( $setting_names ) ){
                return '';
            }

            global $wpdb, $tbl_bookingpress_customize_settings;

            if( is_array( $setting_names ) ){
                $settings_placeholders = 'bookingpress_setting_name IN (';
                $settings_placeholders .= rtrim( str_repeat( '%s,', count( $setting_names ) ), ',' );
                $settings_placeholders .= ')';
                
                array_unshift( $setting_names, $settings_placeholders );
                $settings_query_where = call_user_func_array(array( $wpdb, 'prepare' ), $setting_names );

                $bookingpress_get_setting  = $wpdb->get_results( $wpdb->prepare( "SELECT bookingpress_setting_name,bookingpress_setting_value FROM `{$tbl_bookingpress_customize_settings}` WHERE {$settings_query_where} AND bookingpress_setting_type = %s", $setting_type ), ARRAY_A ); //phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared --Reason $tbl_bookingpress_customize_settings is a table query and $settings_query_where is already passed through wpdb->prepare function

                if( !empty( $bookingpress_get_setting ) ){
                    $bookingpress_setting_value = array();
                    foreach( $bookingpress_get_setting as $bookingpress_setting ){
                        $bookingpress_setting_value[ $bookingpress_setting['bookingpress_setting_name'] ] = $bookingpress_setting['bookingpress_setting_value'];
                    }
                    return $bookingpress_setting_value;
                } else {
                    return array();
                }

            } else {
                $bookingpress_setting_value = '';
                
                $bookingpress_setting_cache_value = wp_cache_get( $setting_names."_".$setting_type );
                if( false === $bookingpress_setting_cache_value || empty($bookingpress_setting_cache_value) ){
                    $bookingpress_get_setting   = $wpdb->get_row($wpdb->prepare("SELECT bookingpress_setting_value FROM `{$tbl_bookingpress_customize_settings}` WHERE bookingpress_setting_name = %s AND bookingpress_setting_type = %s", $setting_names, $setting_type), ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customize_settings is table name defined globally. False alarm

                    if( !empty( $bookingpress_get_setting ) ){
                        $bookingpress_setting_value = $bookingpress_get_setting['bookingpress_setting_value'];
                        wp_cache_set( $setting_names."_".$setting_type, $bookingpress_setting_value );
                    }
                } else {
                    $bookingpress_setting_value = $bookingpress_setting_cache_value;
                }

                return $bookingpress_setting_value;
            }

        }


        public function bookingpress_get_settings( $setting_name, $setting_type )
        {
            global $wpdb, $tbl_bookingpress_settings;
            $bookingpress_setting_value = '';
            if (! empty($setting_name) ) {
                if ( false !== wp_cache_get($setting_name) ) {
                    $bookingpress_setting_value = wp_cache_get($setting_name);
                } else {

                    $bookingpress_get_setting   = $wpdb->get_row($wpdb->prepare("SELECT setting_value FROM `{$tbl_bookingpress_settings}` WHERE setting_name = %s AND setting_type = %s", $setting_name, $setting_type), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm

                    if( !empty( $bookingpress_get_setting ) ){
                        $bookingpress_setting_value = $bookingpress_get_setting['setting_value'];
                        wp_cache_set($setting_name, $bookingpress_setting_value);
                    }
                }
            }

            return $bookingpress_setting_value;
        }


        public function bookingpress_get_currency_symbol( $currency_name )
        {
            if (! empty($currency_name) ) {
                global $bookingpress_global_options;
                $bookingpress_options                    = $bookingpress_global_options->bookingpress_global_options();
                $bookingpress_countries_currency_details = json_decode($bookingpress_options['countries_json_details']);

                $bookingpress_currency_symbol = '';

                foreach ( $bookingpress_countries_currency_details as $currency_key => $currency_val ) {
                    if ($currency_val->name == $currency_name ) {
                        $bookingpress_currency_symbol = $currency_val->symbol;
                        break;
                    }
                }

                return $bookingpress_currency_symbol;
            }

            return '';
        }

        public function bookingpress_get_currency_code( $currency_name )
        {
            if (! empty($currency_name) ) {
                global $bookingpress_global_options;
                $bookingpress_options                    = $bookingpress_global_options->bookingpress_global_options();
                $bookingpress_countries_currency_details = json_decode($bookingpress_options['countries_json_details']);

                $bookingpress_currency_code = '';

                foreach ( $bookingpress_countries_currency_details as $currency_key => $currency_val ) {
                    if ($currency_val->name == $currency_name ) {
                        $bookingpress_currency_code = $currency_val->code;
                        break;
                    }
                }

                return $bookingpress_currency_code;
            }

            return '';
        }

        public function bookingpress_price_formatter_with_currency_symbol( $price, $currency_symbol = '' )
        {
            $bookingpress_decimal_points = $this->bookingpress_get_settings('price_number_of_decimals', 'payment_setting');
            if (gettype($price) == 'string' ) {
                $price = floatval($price);
            }
            $bookingpress_price_separator_pos = $this->bookingpress_get_settings('price_separator', 'payment_setting');
            if ($bookingpress_price_separator_pos == 'comma-dot' ) {
                $price = number_format($price, $bookingpress_decimal_points, '.', ',');
            } elseif ($bookingpress_price_separator_pos == 'dot-comma' ) {
                $price = number_format($price, $bookingpress_decimal_points, ',', '.');
            } elseif ($bookingpress_price_separator_pos == 'space-dot' ) {
                $price = number_format($price, $bookingpress_decimal_points, '.', ' ');
            } elseif ($bookingpress_price_separator_pos == 'space-comma' ) {
                $price = number_format($price, $bookingpress_decimal_points, ',', ' ');
            } elseif ($bookingpress_price_separator_pos == 'Custom' ) {
                $bookingpress_comma_separator = $this->bookingpress_get_settings('custom_comma_separator', 'payment_setting');
                $bookingpress_dot_separator   = $this->bookingpress_get_settings('custom_dot_separator', 'payment_setting');
                $price                        = number_format($price, $bookingpress_decimal_points, $bookingpress_dot_separator, $bookingpress_comma_separator);
            }
            if (empty($currency_symbol) ) {
                $bookingpress_currency_name = $this->bookingpress_get_settings('payment_default_currency', 'payment_setting');
                $currency_symbol            = ! empty($bookingpress_currency_name) ? $this->bookingpress_get_currency_symbol($bookingpress_currency_name) : '';
            }

            $bookingpress_price_symbol_position = $this->bookingpress_get_settings('price_symbol_position', 'payment_setting');

            $bookingpress_price_with_symbol = $currency_symbol . $price;

            if ($bookingpress_price_symbol_position == 'before' ) {
                $bookingpress_price_with_symbol = $currency_symbol . $price;
            } elseif ($bookingpress_price_symbol_position == 'before_with_space' ) {
                $bookingpress_price_with_symbol = $currency_symbol . ' ' . $price;
            } elseif ($bookingpress_price_symbol_position == 'after' ) {
                $bookingpress_price_with_symbol = $price . $currency_symbol;
            } elseif ($bookingpress_price_symbol_position == 'after_with_space' ) {
                $bookingpress_price_with_symbol = $price . ' ' . $currency_symbol;
            }

            return $bookingpress_price_with_symbol;
        }

        public function bookingpress_get_service_end_time( $service_id, $service_start_time, $service_duration_val = '', $service_duration_unit = '' )
        {
            global $wpdb, $tbl_bookingpress_services;
            if (! empty($service_id) ) {
                $service_duration      = ! empty($service_duration_val) ? $service_duration_val : '';
                $service_unit_duration = ! empty($service_duration_unit) ? $service_duration_unit : '';
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_services is table name defined globally. False Positive alarm
                $service_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_services} WHERE bookingpress_service_id = %d", $service_id), ARRAY_A);

                if (empty($service_duration) && empty($service_unit_duration) && ! empty($service_data) ) {
                    $service_duration      = $service_data['bookingpress_service_duration_val'];
                    $service_unit_duration = $service_data['bookingpress_service_duration_unit'];
                }

                $service_mins = $service_duration;
                if ($service_unit_duration == 'h' ) {
                    $service_mins = $service_duration * 60;
                }

                $service_end_time_obj = new DateTime($service_start_time);
                $service_end_time_obj->add(new DateInterval('PT' . $service_mins . 'M'));
                $service_end_time = $service_end_time_obj->format('H:i');

                return array(
                'service_start_time' => $service_start_time,
                'service_end_time'   => $service_end_time,
                );

            }

            return array();
        }


        public function bookingpress_get_default_timeslot_data()
        {

            $bookingpress_default_timeslot_data = esc_html($this->bookingpress_get_settings('default_time_slot_step', 'general_setting'));
            $bookingpress_default_timeslot_data = ! empty($bookingpress_default_timeslot_data) ? esc_html($bookingpress_default_timeslot_data) : 60;
            $time_duration  = $bookingpress_time_duration= $bookingpress_default_timeslot_data;
            $time_unit = 'm';
            
            if ($time_duration >= 60 ) {
                $time_duration = ( $time_duration / 60 );                
                if(is_int($time_duration) == false) {
                    $time_duration = $bookingpress_time_duration;
                } else {               
                    $time_unit     = 'h';
                }    
            }
            return array(
            'time_duration'    => $time_duration,
            'time_unit'        => $time_unit,
            'default_timeslot' => $bookingpress_default_timeslot_data,
            );
        }

        public function bookingpress_get_default_dayoff_dates($booking_date = '', $booking_time = '')
        {
            global $wpdb, $tbl_bookingpress_default_daysoff, $tbl_bookingpress_default_workhours;

            $bpa_default_hours_with_nobreak = wp_cache_get( 'bookingpress_default_workhours_without_break' );
            if( false === $bpa_default_hours_with_nobreak ){
                $bookingpress_workhours_data = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_default_workhours} WHERE bookingpress_is_break = 0", ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False alarm
                wp_cache_set( 'bookingpress_default_workhours_without_break', $bookingpress_workhours_data );
            } else {
                $bookingpress_workhours_data = $bpa_default_hours_with_nobreak;
            }
            
            $is_monday_break             = 0;
            $is_tuesday_break            = 0;
            $is_wednesday_break          = 0;
            $is_thursday_break           = 0;
            $is_friday_break             = 0;
            $is_saturday_break           = 0;
            $is_sunday_break             = 0;

            foreach ( $bookingpress_workhours_data as $workhour_key => $workhour_val ) {
                $bookingpress_start_time = $workhour_val['bookingpress_start_time'];
                $bookingpress_end_time   = $workhour_val['bookingpress_end_time'];
                if ($workhour_val['bookingpress_workday_key'] == 'monday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_monday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'tuesday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_tuesday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'wednesday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_wednesday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'thursday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_thursday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'friday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_friday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'saturday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_saturday_break = 1;
                } elseif ($workhour_val['bookingpress_workday_key'] == 'sunday' && ( $bookingpress_start_time == null || $bookingpress_end_time == null ) ) {
                    $is_sunday_break = 1;
                }
            }

            $default_year            = date('Y', current_time('timestamp'));
            $default_daysoff_details = array();

            $calendar_start_date = $calendar_next_date = date('Y-m-d', current_time('timestamp'));
            $calendar_end_date   = date('Y-m-d', strtotime('+1 year', current_time('timestamp')));
            for ( $i = 1; $i <= 730; $i++ ) {
                $current_day_name = date('l', strtotime($calendar_next_date));
                if ($current_day_name == 'Monday' && $is_monday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Tuesday' && $is_tuesday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Wednesday' && $is_wednesday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Thursday' && $is_thursday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Friday' && $is_friday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Saturday' && $is_saturday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                } elseif ($current_day_name == 'Sunday' && $is_sunday_break == 1 ) {
                    $daysoff_tmp_date = date('Y-m-d', strtotime($calendar_next_date));
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_tmp_date)));
                }

                $calendar_next_date = date('Y-m-d', strtotime($calendar_next_date . ' +1 days'));
            }
            $bpa_default_daysoff = wp_cache_get( 'bookingpress_default_daysoff' );
            if( false === $bpa_default_daysoff ){
                $daysoff_details = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_default_daysoff}", ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_daysoff is table name defined globally. False alarm
                wp_cache_set( 'bookingpress_default_daysoff', $daysoff_details );
            } else {
                $daysoff_details = $bpa_default_daysoff;
            }
            foreach ( $daysoff_details as $daysoff_details_key => $daysoff_details_val ) {
                $daysoff_date = esc_html($daysoff_details_val['bookingpress_dayoff_date']);

                $dayoff_year = date('Y', strtotime($daysoff_date));

                if (empty($daysoff_details_val['bookingpress_repeat']) ) {
                    array_push($default_daysoff_details, date('c', strtotime($daysoff_date)));
                } elseif (! empty($daysoff_details_val['bookingpress_repeat']) ) {
                    for ( $i = $default_year; $i <= 2035; $i++ ) {
                        $daysoff_new_date_month = $i . '-' . date('m-d', strtotime($daysoff_date));
                        array_push($default_daysoff_details, date('c', strtotime($daysoff_new_date_month)));
                    }
                }
            }

			$default_daysoff_details = apply_filters('bookingpress_modify_default_daysoff_details', $default_daysoff_details, $booking_date, $booking_time);

			return $default_daysoff_details;
		}

		public function bookingpress_is_appointment_booked($service_id, $booking_date, $booking_start_time, $booking_end_time){
			global $wpdb, $tbl_bookingpress_default_workhours, $tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_services;

			$is_appointment_booked = 0;

            if($booking_end_time == "00:00"){
                $booking_end_time = "24:00:00";
            }

			//Check shared service timeslot switch enabled or not
			$bookingpress_shared_service_timeslot = $this->bookingpress_get_settings('share_timeslot_between_services', 'general_setting');

			if($bookingpress_shared_service_timeslot == 'true'){
				//$is_appointment_booked = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(bookingpress_payment_log_id) as total FROM {$tbl_bookingpress_payment_logs} WHERE bookingpress_appointment_date LIKE %s AND ((bookingpress_appointment_start_time >= %s AND bookingpress_appointment_start_time < %s) OR (bookingpress_appointment_start_time < %s AND bookingpress_appointment_end_time > %s ) )", "%{$booking_date}%", $booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ) );
                $is_appointment_booked = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(bookingpress_appointment_booking_id) as total FROM {$tbl_bookingpress_appointment_bookings} WHERE bookingpress_appointment_date LIKE %s AND ((bookingpress_appointment_time >= %s AND bookingpress_appointment_time < %s) OR (bookingpress_appointment_time < %s AND bookingpress_appointment_end_time > %s ) )", "%{$booking_date}%", $booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ) ); //phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared --Reason: $tbl_bookingpress_appointment_bookings is table name
			}else{
				//$is_appointment_booked = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(bookingpress_payment_log_id) as total FROM {$tbl_bookingpress_payment_logs} WHERE bookingpress_appointment_date LIKE %s AND bookingpress_service_id = %d AND ((bookingpress_appointment_start_time >= %s AND bookingpress_appointment_start_time < %s) OR (bookingpress_appointment_start_time < %s AND bookingpress_appointment_end_time > %s ) )", "%{$booking_date}%", $service_id, $booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ) );
                $is_appointment_booked = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(bookingpress_appointment_booking_id) as total FROM {$tbl_bookingpress_appointment_bookings} WHERE bookingpress_appointment_date LIKE %s AND bookingpress_service_id = %d AND ((bookingpress_appointment_time >= %s AND bookingpress_appointment_time < %s) OR (bookingpress_appointment_time < %s AND bookingpress_appointment_end_time > %s ) )", "%{$booking_date}%", $service_id, $booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ) ); //phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared $tbl_bookingpress_appointment_bookings is a table name
			}

            $bookingpress_is_appointment_cancelled = $this->bookingpress_is_appointment_cancelled_or_rejected($service_id, $booking_date, $booking_start_time, $booking_end_time);
            if($bookingpress_is_appointment_cancelled){
                $is_appointment_booked = 0;
            }

			return $is_appointment_booked;
		}

        public function bookingpress_is_appointment_cancelled_or_rejected($service_id, $booking_date, $booking_start_time, $booking_end_time){
            global $wpdb, $tbl_bookingpress_default_workhours, $tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_services;
            $bookingpress_shared_service_timeslot = $this->bookingpress_get_settings('share_timeslot_between_services', 'general_setting');                        

            $bookingpress_is_appointment_canceled = 0;

			if($bookingpress_shared_service_timeslot == 'true'){                
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
                $check_timeslot_canceled_data = $wpdb->get_row($wpdb->prepare("SELECT `bookingpress_appointment_booking_ref` FROM {$tbl_bookingpress_payment_logs} WHERE bookingpress_appointment_date LIKE %s AND ((bookingpress_appointment_start_time >= %s AND bookingpress_appointment_start_time < %s) OR (bookingpress_appointment_start_time < %s AND bookingpress_appointment_end_time > %s ) ) ORDER BY bookingpress_appointment_booking_ref DESC", "%{$booking_date}%", $booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ),ARRAY_A); 
            } else {                
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
                $check_timeslot_canceled_data = $wpdb->get_row($wpdb->prepare("SELECT `bookingpress_appointment_booking_ref` FROM {$tbl_bookingpress_payment_logs} WHERE bookingpress_appointment_date LIKE %s AND bookingpress_service_id = %d AND ((bookingpress_appointment_start_time >= %s  AND bookingpress_appointment_start_time < %s) OR (bookingpress_appointment_start_time < %s AND bookingpress_appointment_end_time > %s ) ) ORDER BY bookingpress_appointment_booking_ref DESC", "%{$booking_date}%",$service_id,$booking_start_time, $booking_end_time, $booking_end_time, $booking_start_time ),ARRAY_A ); 
            }     
            if (! empty($check_timeslot_canceled_data) ) {
                $appointment_id                = $check_timeslot_canceled_data['bookingpress_appointment_booking_ref'];
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm
                $bookingpress_appointment_data = $wpdb->get_var($wpdb->prepare("SELECT COUNT(bookingpress_appointment_booking_id) as total FROM {$tbl_bookingpress_appointment_bookings} WHERE bookingpress_appointment_booking_id = %d AND ( bookingpress_appointment_status = 'Cancelled')", $appointment_id));
                if ($bookingpress_appointment_data > 0 ) {
                    $bookingpress_is_appointment_canceled = 1;
                }
            }

            return $bookingpress_is_appointment_canceled;
        }

		public function bookingpress_get_service_available_time( $service_id = 0, $selected_date = '', $bookingpress_timezone = '' ) {
			global $wpdb, $tbl_bookingpress_default_workhours, $tbl_bookingpress_appointment_bookings, $tbl_bookingpress_payment_logs, $tbl_bookingpress_services;
			
			if(!empty($bookingpress_timezone)){
				date_default_timezone_set($bookingpress_timezone);
			}
			
			$bookingpress_hide_already_booked_slot = $this->bookingpress_get_customize_settings( 'hide_already_booked_slot', 'booking_form' );
			$bookingpress_hide_already_booked_slot = ( $bookingpress_hide_already_booked_slot == 'true' ) ? 1 : 0;

			$current_day  = ! empty( $selected_date ) ? strtolower( date( 'l', strtotime( $selected_date ) ) ) : strtolower( date( 'l', current_time( 'timestamp' ) ) );
            $current_date = ! empty($selected_date) ? date('Y-m-d', strtotime($selected_date)) : date('Y-m-d', current_time('timestamp'));

			$bpa_current_date = date('Y-m-d', strtotime(current_time('mysql')));

			if(empty($bookingpress_timezone)){
		    	$bpa_current_time = date( 'H:i',strtotime(current_time('mysql')));
			}else{
				$bpa_current_time = date('H:i');
			}

			$default_daysoff_details = $this->bookingpress_get_default_dayoff_dates();
			if ( ! empty( $default_daysoff_details ) ) {
				foreach ( $default_daysoff_details as $key => $value ) {
					if ( date( 'Y-m-d', strtotime( $value ) ) == $current_date ) {
						return '';
						exit;
					}
				}
			}

			$service_time_duration     = $this->bookingpress_get_default_timeslot_data();
			$default_timeslot_step = $service_step_duration_val = $service_time_duration['default_timeslot'];
            
            $service_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_services} WHERE bookingpress_service_id = %d", $service_id), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared --Reason $tbl_bookingpress_services is a table name
            if (! empty($service_data) ) {
                $service_time_duration      = esc_html($service_data['bookingpress_service_duration_val']);
                $service_time_duration_unit = esc_html($service_data['bookingpress_service_duration_unit']);
                if ($service_time_duration_unit == 'h' ) {
                    $service_time_duration = $service_time_duration * 60;
                } elseif($service_time_duration_unit == 'd') {           
                    $service_time_duration = $service_time_duration * 24 * 60;
                }
                $default_timeslot_step = $service_step_duration_val = $service_time_duration;
            }

            $bookingpress_show_time_as_per_service_duration = $this->bookingpress_get_settings( 'show_time_as_per_service_duration', 'general_setting' );
            if ( ! empty( $bookingpress_show_time_as_per_service_duration ) && $bookingpress_show_time_as_per_service_duration == 'false' ) {
				$bookingpress_default_time_slot = $this->bookingpress_get_settings( 'default_time_slot', 'general_setting' );
				$default_timeslot_step      = $bookingpress_default_time_slot;
			}
            
            $service_step_duration_val = apply_filters( 'bookingpress_modify_service_timeslot', $service_step_duration_val, $service_id, $service_time_duration_unit );

			//Check shared service timeslot switch enabled or not
			//$bookingpress_shared_service_timeslot = $this->bookingpress_get_settings('share_timeslot_between_services', 'general_setting');

            $already_booked_time_arr = $workhour_data = $break_hour_arr = array();
            // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False Positive alarm
            $get_default_work_hours_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_default_workhours} WHERE bookingpress_workday_key = %s AND bookingpress_is_break = 0", $current_day), ARRAY_A);
            if (! empty($get_default_work_hours_data) ) {
                $service_current_time = $service_start_time = apply_filters( 'bookingpress_modify_service_start_time', date('H:i', strtotime($get_default_work_hours_data['bookingpress_start_time'])), $service_id );
                $service_end_time     = apply_filters( 'bookingpress_modify_service_end_time', date('H:i', strtotime($get_default_work_hours_data['bookingpress_end_time'])), $service_id );

                if($service_end_time == "00:00"){
                    $service_end_time = "24:00";
                }

                if ($service_start_time != null && $service_end_time != null ) {
                    while ( $service_current_time <= $service_end_time ) {
                        if ($service_current_time > $service_end_time ) {
                            break;
                        }
                        $service_tmp_current_time = $service_current_time;
                        if ($service_current_time == '00:00' ) {
                            $service_current_time = date('H:i', strtotime($service_current_time) + ( $service_step_duration_val * 60 ));
                        } else {
                            $service_tmp_time_obj = new DateTime($service_current_time);
                            $service_tmp_time_obj->add(new DateInterval('PT' . $service_step_duration_val . 'M'));
                            $service_current_time = $service_tmp_time_obj->format('H:i');
                        }

                        $break_start_time      = '';
                        $break_end_time        = '';
                        // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False Positive alarm
                        $check_break_existance = $wpdb->get_var($wpdb->prepare("SELECT COUNT(bookingpress_workhours_id) as total FROM {$tbl_bookingpress_default_workhours} WHERE bookingpress_workday_key = %s AND bookingpress_is_break = 1 AND (bookingpress_start_time BETWEEN %s AND %s)", $current_day, $service_tmp_current_time, $service_current_time));

                        if ($check_break_existance > 0 ) {
                            // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False Positive alarm
                            $get_break_workhours = $wpdb->get_row($wpdb->prepare("SELECT TIMEDIFF(bookingpress_end_time, bookingpress_start_time) as time_diff, bookingpress_start_time, bookingpress_end_time FROM {$tbl_bookingpress_default_workhours} WHERE bookingpress_workday_key = %s AND bookingpress_is_break = 1 AND (bookingpress_start_time BETWEEN %s AND %s )", $current_day, $service_tmp_current_time, $service_current_time), ARRAY_A);
                            $time_difference     = date('H:i', strtotime($get_break_workhours['time_diff']));

                            $break_start_time     = date('H:i', strtotime($get_break_workhours['bookingpress_start_time']));
                            $break_end_time       = date('H:i', strtotime($get_break_workhours['bookingpress_end_time']));
                            $service_current_time = $break_start_time;
                        }

                        $is_appointment_booked = $this->bookingpress_is_appointment_booked($service_id, $current_date, $service_tmp_current_time, $service_current_time);
						
                        $is_already_booked = ( $is_appointment_booked > 0 ) ? 1 : 0;                       
                        if ($service_current_time < $service_start_time || $service_current_time == $service_start_time ) {
                            $service_current_time = $service_end_time;
                        }

                        $bookingpress_timediff_in_minutes = round(abs(strtotime($service_current_time) - strtotime($service_tmp_current_time)) / 60, 2);

                        if ($is_already_booked == 1 && $bookingpress_hide_already_booked_slot == 1 ) {
                                  continue;
                        } else {
                            if ($break_start_time != $service_tmp_current_time && ($bookingpress_timediff_in_minutes >= $service_step_duration_val) && $service_current_time <= $service_end_time ) {
                                if ($bpa_current_date == $current_date ) {
                                    if ($service_tmp_current_time > $bpa_current_time ) {
                                        $workhour_data[] = array(
                                        'start_time' => $service_tmp_current_time,
                                        'end_time'   => $service_current_time,
                                        'break_start_time' => $break_start_time,
                                        'break_end_time' => $break_end_time,
                                        'is_booked'  => $is_already_booked,
                                        );
                                    } else {
                                        /* $workhour_data[] = array(
                                        'start_time' => $service_tmp_current_time,
                                        'end_time'   => $service_current_time,
                                        'break_start_time' => $break_start_time,
                                        'break_end_time' => $break_end_time,
                                        'is_booked'  => 1,
                                        ); */
                                    }
                                } else {
                                    $workhour_data[] = array(
                                    'start_time'       => $service_tmp_current_time,
                                    'end_time'         => $service_current_time,
                                    'break_start_time' => $break_start_time,
                                    'break_end_time'   => $break_end_time,
                                    'is_booked'        => $is_already_booked,
                                    );
                                }
                            }else{
                                if($service_current_time >= $service_end_time){
                                    break;
                                }
                            }
                        }

                        if (! empty($break_end_time) ) {
                            $service_current_time = $break_end_time;
                        }

                        if ($service_current_time == $service_end_time ) {
                            break;
                        }

                        if($default_timeslot_step != $service_step_duration_val && empty($break_start_time)){
                            $service_tmp_time_obj = new DateTime($service_tmp_current_time);
                            $service_tmp_time_obj->add(new DateInterval('PT' . $default_timeslot_step . 'M'));
                            $service_current_time = $service_tmp_time_obj->format('H:i');
                        }
                    }
                }
            }

			$workhour_data = apply_filters( 'bookingpress_modify_service_time', $workhour_data, $current_date, $current_day, $service_id, $selected_date, $bookingpress_timezone );

			return $workhour_data;
		}

		public function bookingpress_get_daily_timeslots( $appointment_time_slot = array() ) {
			global $bookingpress_global_options;

			$bookingpress_global_details      = $bookingpress_global_options->bookingpress_global_options();
			$bookingpress_default_time_format = $bookingpress_global_details['wp_default_time_format'];
            $bookingpress_default_time_format = apply_filters('bookingpress_change_time_slot_format',$bookingpress_default_time_format);
            $morning_time   = array();
            $afternoon_time = array();
            $evening_time   = array();
            $night_time     = array();

            $bookingpress_service_slot_details = array();
            if (! empty($appointment_time_slot) ) {
                foreach ( $appointment_time_slot as $key => $value ) {

                    $service_start_time = date('H', strtotime($value['start_time']));
                    $service_end_time   = date('H', strtotime($value['end_time']));

                    if ($service_start_time >= 0 && $service_start_time < 12 ) {
                        $morning_time[] = array(
                        'start_time'  => $value['start_time'],
							'start_time_format' => date( $bookingpress_default_time_format, strtotime( $value['start_time'] ) ),
                        'end_time'    => $value['end_time'],
							'end_time_format'   => date( $bookingpress_default_time_format, strtotime( $value['end_time'] ) ),
                        'is_disabled' => ( $value['is_booked'] == 1 ) ? true : false,
                        );
                    } elseif ($service_start_time >= 12 && $service_start_time < 16 ) {
                        $afternoon_time[] = array(
                        'start_time'  => $value['start_time'],
							'start_time_format' => date( $bookingpress_default_time_format, strtotime( $value['start_time'] ) ),
                        'end_time'    => $value['end_time'],
							'end_time_format'   => date( $bookingpress_default_time_format, strtotime( $value['end_time'] ) ),
                        'is_disabled' => ( $value['is_booked'] == 1 ) ? true : false,
                        );
                    } elseif ($service_start_time >= 16 && $service_start_time < 20 ) {
                        $evening_time[] = array(
                        'start_time'  => $value['start_time'],
							'start_time_format' => date( $bookingpress_default_time_format, strtotime( $value['start_time'] ) ),
							'end_time'          => $value['end_time'],
							'end_time_format'   => date( $bookingpress_default_time_format, strtotime( $value['end_time'] ) ),
                        'is_disabled' => ( $value['is_booked'] == 1 ) ? true : false,
                        );
                    } else {
                        $night_time[] = array(
                        'start_time'  => $value['start_time'],
							'start_time_format' => date( $bookingpress_default_time_format, strtotime( $value['start_time'] ) ),
                        'end_time'    => $value['end_time'],
							'end_time_format'   => date( $bookingpress_default_time_format, strtotime( $value['end_time'] ) ),
                        'is_disabled' => ( $value['is_booked'] == 1 ) ? true : false,
                        );
                    }
                }
            }

            $bookingpress_service_slot_details['morning_time']   = array(
            'timeslot_label' => __('Morning', 'bookingpress-appointment-booking'),
            'timeslots'      => $morning_time,
            );
            $bookingpress_service_slot_details['afternoon_time'] = array(
            'timeslot_label' => __('Afternoon', 'bookingpress-appointment-booking'),
            'timeslots'      => $afternoon_time,
            );
            $bookingpress_service_slot_details['evening_time']   = array(
            'timeslot_label' => __('Evening', 'bookingpress-appointment-booking'),
            'timeslots'      => $evening_time,
            );
            $bookingpress_service_slot_details['night_time']     = array(
            'timeslot_label' => __('Night', 'bookingpress-appointment-booking'),
            'timeslots'      => $night_time,
            );

            return $bookingpress_service_slot_details;
        }


        public function get_weekstart_date_end_date( $week_number, $year )
        {
            $dto = new DateTime();
            $dto->setISODate($year, $week_number);
            $ret['week_start'] = $dto->format('Y-m-d');
            $dto->modify('+6 days');
            $ret['week_end'] = $dto->format('Y-m-d');
            return $ret;
        }

        public function get_monthstart_date_end_date()
        {
            $month_start_date = date('Y-m-01');
            $month_end_date   = date('Y-m-t');
            return array(
            'start_date' => $month_start_date,
            'end_date'   => $month_end_date,
            );
        }


        public function get_bookingpress_service_data_group_with_category()
        {
            global $wpdb, $tbl_bookingpress_categories, $tbl_bookingpress_services;

            $bookingpress_currency_name   = $this->bookingpress_get_settings('payment_default_currency', 'payment_setting');
            $bookingpress_currency_symbol = ! empty($bookingpress_currency_name) ? $this->bookingpress_get_currency_symbol($bookingpress_currency_name) : '';

            $bookingpress_services_details   = array();
            $bookingpress_service_categories = $wpdb->get_results('SELECT * FROM ' . $tbl_bookingpress_categories . ' ORDER BY bookingpress_category_position ASC', ARRAY_A);// phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared -- Reason: $tbl_bookingpress_categories is table name defined globally. False alarm
            foreach ( $bookingpress_service_categories as $bookingpress_service_cat_key => $bookingpress_service_cat_val ) {
                $bookingpress_cat_id       = $bookingpress_service_cat_val['bookingpress_category_id'];
                $bookingpress_tmp_services = array();
                $bpa_category_data = wp_cache_get( 'bookingpress_category_data_' . $bookingpress_cat_id );
                if( false === $bpa_category_data ){
                    $bookingpress_services     = $wpdb->get_results($wpdb->prepare('SELECT * FROM ' . $tbl_bookingpress_services . ' WHERE bookingpress_category_id = %d', $bookingpress_cat_id), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared -- Reason: $tbl_bookingpress_services is table name defined globally. False alarm
                    wp_cache_set( 'bookingpress_category_data_' . $bookingpress_cat_id, $bookingpress_services );
                } else {
                    $bookingpress_services = $bpa_category_data;
                }
                foreach ( $bookingpress_services as $bookingpress_service_key => $bookingpress_service_val ) {
                    $bookingpress_service_price = $this->bookingpress_price_formatter_with_currency_symbol($bookingpress_service_val['bookingpress_service_price'], $bookingpress_currency_symbol);

                    $bookingpress_tmp_services[] = array(
                     'service_id'                     => $bookingpress_service_val['bookingpress_service_id'],
                     'service_name'                   => stripslashes_deep($bookingpress_service_val['bookingpress_service_name']),
                     'service_price'                  => $bookingpress_service_price,
                     'service_price_without_currency' => $bookingpress_service_val['bookingpress_service_price'],
                     'service_price_currency'         => $bookingpress_currency_symbol,
                    );
                }

                if (! empty($bookingpress_tmp_services) ) {
                    $bookingpress_services_details[] = array(
                    'category_id'       => $bookingpress_cat_id,
                    'category_name'     => stripslashes_deep($bookingpress_service_cat_val['bookingpress_category_name']),
                    'category_services' => $bookingpress_tmp_services,
                    );
                }
            }

            return $bookingpress_services_details;
        }

        function bookingpress_insert_appointment_logs( $appointment_booking_data = array() )
        {
            global $wpdb, $tbl_bookingpress_appointment_bookings;
            $appointment_inserted_id = 0;
            if (! empty($appointment_booking_data) ) {
                $wpdb->insert($tbl_bookingpress_appointment_bookings, $appointment_booking_data);
                $appointment_inserted_id = $wpdb->insert_id;
                do_action('bookingpress_after_insert_appointment', $appointment_inserted_id);
            }
            return $appointment_inserted_id;
        }


        function bookingpress_insert_payment_logs( $payment_log_data = array() )
        {
            global $wpdb, $tbl_bookingpress_payment_logs;
            $payment_log_id = 0;
            if (! empty($payment_log_data) ) {
                $wpdb->insert($tbl_bookingpress_payment_logs, $payment_log_data);
                $payment_log_id = $wpdb->insert_id;
            }

            return $payment_log_id;
        }


        function get_service_by_id( $service_id )
        {
            global $wpdb, $tbl_bookingpress_services;
            $service_data = array();
            if (! empty($service_id) ) {
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_services is table name defined globally. False Positive alarm
                $service_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_services} WHERE bookingpress_service_id = %d", $service_id), ARRAY_A);
            }
            return $service_data;
        }


        function get_customer_details( $customer_id )
        {
            global $wpdb, $tbl_bookingpress_customers;
            $customer_data = array();
            if (! empty($customer_id) ) {
                // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers is table name defined globally. False Positive alarm
                $customer_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_customers} WHERE bookingpress_customer_id =%d", $customer_id), ARRAY_A);
            }
            return $customer_data;
        }

        function bookingpress_install_default_notification_data()
        {
            global $wpdb, $tbl_bookingpress_notifications;

            $bookingpress_default_notifications_name_arr = array( 'Appointment Approved', 'Appointment Pending', 'Appointment Rejected', 'Appointment Canceled' );

            $bookingpress_default_notifications_message_arr = array(
            'Appointment Approved' => 'Dear %customer_full_name%,<br>You have successfully scheduled appointment.<br>Thank you for choosing us,<br>%company_name%',
            'Appointment Pending'  => 'Dear %customer_full_name%,<br>The %service_name% appointment is scheduled and it\'s waiting for a confirmation.<br>Thank you for choosing us,<br>%company_name%',
            'Appointment Rejected' => 'Dear %customer_full_name%,<br>The %service_name% appointment, has been rejected.<br>Thank you for choosing us,<br>%company_name%',
            'Appointment Canceled' => 'Dear %customer_full_name%,<br>The %service_name% appointment, has been canceled.<br>Thank you for choosing us,<br>%company_name%',
            );

            foreach ( $bookingpress_default_notifications_name_arr as $bookingpress_default_notification_key => $bookingpress_default_notification_val ) {
                $bookingpress_customer_notification_data = array(
                'bookingpress_notification_name'    => $bookingpress_default_notification_val,
                'bookingpress_notification_receiver_type' => 'customer',
                'bookingpress_notification_status'  => 1,
                'bookingpress_notification_type'    => 'default',
                'bookingpress_notification_subject' => $bookingpress_default_notification_val,
                'bookingpress_notification_message' => $bookingpress_default_notifications_message_arr[ $bookingpress_default_notification_val ],
                'bookingpress_created_at'           => current_time('mysql'),
                );

                $wpdb->insert($tbl_bookingpress_notifications, $bookingpress_customer_notification_data);
            }

            $bookingpress_default_notifications_arr2 = array(
            'Appointment Approved' => 'Hi administrator,<br>You have one confirmed %service_name% appointment. The appointment is added to your schedule.<br>Thank you,<br>%company_name%',
            'Appointment Pending'  => 'Hi administrator,<br>You have new appointment in %service_name%. The appointment is waiting for a confirmation.<br>Thank you,<br>%company_name%',
            'Appointment Rejected' => 'Hi administrator,<br>Your %service_name% appointment, has been rejected.<br>Thank you,<br>%company_name%',
            'Appointment Canceled' => 'Hi administrator,<br>Your %service_name% appointment, has been canceled.<br>Thank you,<br>%company_name%',
            );

            foreach ( $bookingpress_default_notifications_name_arr as $bookingpress_default_notification_key => $bookingpress_default_notification_val ) {
                $bookingpress_employee_notification_data = array(
                'bookingpress_notification_name'    => $bookingpress_default_notification_val,
                'bookingpress_notification_receiver_type' => 'employee',
                'bookingpress_notification_status'  => 1,
                'bookingpress_notification_type'    => 'default',
                'bookingpress_notification_subject' => $bookingpress_default_notification_val,
                'bookingpress_notification_message' => $bookingpress_default_notifications_arr2[ $bookingpress_default_notification_val ],
                'bookingpress_created_at'           => current_time('mysql'),
                );

                $wpdb->insert($tbl_bookingpress_notifications, $bookingpress_employee_notification_data);
            }
        }


        function bookingpress_install_default_general_settings_data()
        {   
            $default_date_format = get_option('date_format');
            if($default_date_format != 'F j, Y' && $default_date_format != 'd/m/Y'  && $default_date_format != 'm/d/Y'  && $default_date_format != 'Y-m-d' && $default_date_format != 'd.m.Y' && $default_date_format != 'd-m-Y' ) {
                $default_date_format = 'F j, Y';
            } 
            $bookingpress_general_setting_form_default_data = array(
            'default_time_slot_step'              => '30',
            'appointment_status'                  => 'Approved',
            'onsite_appointment_status'           => 'Pending',
            'default_phone_country_code'          => 'us',
            'per_page_item'                       => '20',
            'redirect_url_after_booking_approved' => '',
            'redirect_url_after_booking_pending'  => '',
            'redirect_url_after_booking_canceled' => '',
            'phone_number_mandatory'              => false,
            'share_timeslot_between_services'     => false,
            'use_already_loaded_vue'              => false,
            'load_js_css_all_pages'               => false,
            'show_time_as_per_service_duration'   => 'true',
            'default_time_slot'                   => '30',
                'default_date_format'                => $default_date_format,
            );

            $bookingpress_company_setting_form_default_data      = array(
            'company_avatar_img'    => '',
            'company_avatar_url'    => '',
            'company_avatar_list'   => array(),
            'company_name'          => get_option('blogname'),
            'company_address'       => '',
            'company_website'       => '',
            'company_phone_country' => 'us',
            'company_phone_number'  => '',
            );
            $bookingpress_notification_setting_form_default_data = array(
            'selected_mail_service' => 'php_mail',
            'sender_name'           => get_option('blogname'),
            'sender_email'          => get_option('admin_email'),
            'admin_email'           => get_option('admin_email'),
            'success_url'           => '',
            'cancel_url'            => '',
            'smtp_host'             => '',
            'smtp_port'             => '',
            'smtp_secure'           => 'Disabled',
            'smtp_username'         => '',
            'smtp_password'         => '',
            );
            $bookingpress_payment_setting_form_default_data      = array(
            'payment_default_currency' => 'US Dollar',
            'price_symbol_position'    => 'before',
            'price_separator'          => 'comma-dot',
            'price_number_of_decimals' => 2,
            'on_site_payment'          => true,
            'paypal_payment'           => false,
            'paypal_cancel_url'        => BOOKINGPRESS_HOME_URL,
            'paypal_payment_mode'      => 'sandbox',
            );
            $bookingpress_message_setting_form_default_data      = array(
            'confirmation_message_for_the_cancel_appointment' => 'Are you sure you want to cancel this appointment?',
            'appointment_booked_successfully'       => 'Appointment has been booked successfully.',
            'appointment_cancelled_successfully'    => 'Appointment has been cancelled successfully.',
            'duplidate_appointment_time_slot_found' => 'I am sorry! Another appointment is already booked with this time slot. Please select another time slot which suits you the best.',
            'unsupported_currecy_selected_for_the_payment' => 'I am sorry! The selected currency is not supported by selected payment gateway. Please proceed with another available payment method.',
            'duplicate_email_address_found'         => 'It seems that you are already registered with us! Please login to continue to book an appointment.',
            'no_payment_method_is_selected_for_the_booking' => 'Please select a payment method to proceed with the booking.',
            'no_appointment_time_selected_for_the_booking' => 'Please select a time slot to proceed with the booking.',
            'no_appointment_date_selected_for_the_booking' => 'Please select appointment date to proceed with the booking.',
            'no_service_selected_for_the_booking'   => 'Please select any service to book the appointment.',
            'no_payment_method_available'  => 'Oops! There is no payment method available.',                                           
            );
            $bookingpress_customer_setting_form_default_data     = array(
            'allow_wp_user_create' => 'false',
            );
            $bookingpress_invoice_setting_default_data           = array(
            'bookingpress_last_invoice_id' => 0,
            );        
            $bookingpress_install_default_data                   = array(
            'general_setting'               => $bookingpress_general_setting_form_default_data,
            'company_setting'               => $bookingpress_company_setting_form_default_data,
            'notification_setting'          => $bookingpress_notification_setting_form_default_data,
            'payment_setting'               => $bookingpress_payment_setting_form_default_data,
            'message_setting'               => $bookingpress_message_setting_form_default_data,
            'customer_setting'              => $bookingpress_customer_setting_form_default_data,
            'invoice_Setting'               => $bookingpress_invoice_setting_default_data,
            );

            foreach ( $bookingpress_install_default_data as $bookingpress_default_data_key => $bookingpress_default_data_val ) {
                $bookingpress_setting_type = $bookingpress_default_data_key;
                foreach ( $bookingpress_default_data_val as $bookingpress_default_data_val_key => $bookingpress_default_data_val2 ) {
                    $this->bookingpress_update_settings($bookingpress_default_data_val_key, $bookingpress_setting_type, $bookingpress_default_data_val2);
                }
            }

            global $tbl_bookingpress_default_workhours, $wpdb;

            // Install default workhours data
            $bookingpress_default_days = array( 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday' );
            foreach ( $bookingpress_default_days as $bookingpress_default_day_key => $bookingpress_default_day_val ) {
                $default_start_time = '09:00';
                $default_end_time   = '17:00';

                $default_insert_data = array(
                'bookingpress_workday_key' => $bookingpress_default_day_val,
                );

                if ($bookingpress_default_day_val != 'saturday' && $bookingpress_default_day_val != 'sunday' ) {
                    $default_insert_data['bookingpress_start_time'] = $default_start_time;
                    $default_insert_data['bookingpress_end_time']   = $default_end_time;
                } else {
                    $default_insert_data['bookingpress_start_time'] = null;
                    $default_insert_data['bookingpress_end_time']   = null;
                }

                $wpdb->insert($tbl_bookingpress_default_workhours, $default_insert_data);
            }
        }

        function bookingpress_install_default_customize_settings_data()
        {
            global $wpdb, $tbl_bookingpress_customize_settings, $tbl_bookingpress_form_fields;

            $booking_form_shortcode_default_fields = array(
            'service_title'                   => __('Service', 'bookingpress-appointment-booking'),
            'datetime_title'                  => __('Date & Time', 'bookingpress-appointment-booking'),
            'basic_details_title'             => __('Basic Details', 'bookingpress-appointment-booking'),
            'summary_title'                   => __('Summary', 'bookingpress-appointment-booking'),
            'category_title'                  => __('Select Category', 'bookingpress-appointment-booking'),
            'service_heading_title'           => __('Select Service', 'bookingpress-appointment-booking'),
            'default_image_url'               => BOOKINGPRESS_URL . '/images/placeholder-img.jpg',            
            'timeslot_text'                   => __('Time Slot', 'bookingpress-appointment-booking'),            
            'morning_text'                    => __('Morning', 'bookingpress-appointment-booking'),            
            'afternoon_text'                  => __('Afternoon', 'bookingpress-appointment-booking'),            
            'evening_text'                    => __('Evening', 'bookingpress-appointment-booking'),            
            'night_text'                      => __('Night', 'bookingpress-appointment-booking'),            
            'summary_content_text'            => __('Your appointment booking summary', 'bookingpress-appointment-booking'),
            'payment_method_text'             => __('Select Payment Method', 'bookingpress-appointment-booking'),
            'background_color'                => '#fff',
            'footer_background_color'         => '#f4f7fb',
            'primary_color'                   => '#12D488',
            'primary_background_color'        => '#e2faf1',
            'label_title_color'               => '#202C45',
            'sub_title_color'                 => '#535D71',
            'content_color'                   => '#727E95',
            'custom_css'                      => '',
            'title_font_family'               => 'Poppins',
            'content_font_family'             => 'Poppins',
            'hide_category_service_selection' => 'false',
            'booking_form_tabs_position'      => 'left',
            'hide_next_previous_button'       => 'false',
            'hide_already_booked_slot'        => 'false',
            'display_service_description'     => 'false',
            'goback_button_text'              => __('Go Back', 'bookingpress-appointment-booking'),
            'next_button_text'                => __('Next', 'bookingpress-appointment-booking'),
            'book_appointment_btn_text'       => __('Book Appointment', 'bookingpress-appointment-booking'),          
            'paypal_text'                     => __('PayPal', 'bookingpress-appointment-booking'),
            'locally_text'                    => __('Pay Locally', 'bookingpress-appointment-booking'),
            'total_amount_text'               => __('Total Amount Payable', 'bookingpress-appointment-booking'),
            'service_text'                    => __('Service', 'bookingpress-appointment-booking'),
            'customer_text'                   => __('Customer', 'bookingpress-appointment-booking'),
            'date_time_text'                  => __('Date & Time', 'bookingpress-appointment-booking'),
            'all_category_title'              => 'ALL',
            );

            foreach ( $booking_form_shortcode_default_fields as $booking_form_shortcode_data_key => $booking_form_shortcode_data_val ) {
                $bookingpress_customize_settings_db_fields = array(
                'bookingpress_setting_name'  => $booking_form_shortcode_data_key,
                'bookingpress_setting_value' => $booking_form_shortcode_data_val,
                'bookingpress_setting_type'  => 'booking_form',
                );

                $wpdb->insert($tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields);
            }

            $mybookings_shortcode_default_data = array(
            'mybooking_title_text'        => __('My Bookings', 'bookingpress-appointment-booking'),
            'hide_customer_details'       => 'false',
            'hide_search_bar'             => 'false',
            'allow_to_cancel_appointment' => 'true',
            'reset_button_title'          => __('Reset', 'bookingpress-appointment-booking'),  
            'apply_button_title'          => __('Apply', 'bookingpress-appointment-booking'),  
            'search_appointment_title'    => __('Search appointments', 'bookingpress-appointment-booking'),              
            );

            foreach ( $mybookings_shortcode_default_data as $mybookings_shortcode_data_key => $mybookings_shortcode_data_val ) {
                $bookingpress_customize_settings_db_fields = array(
                'bookingpress_setting_name'  => $mybookings_shortcode_data_key,
                'bookingpress_setting_value' => $mybookings_shortcode_data_val,
                'bookingpress_setting_type'  => 'booking_my_booking',
                );

                $wpdb->insert($tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields);
            }

            $form_fields_default_data = array(
            'fullname'      => array(
            'field_name'     => 'fullname',
            'field_type'     => 'Text',
            'is_edit'        => 0,
            'is_required'    => 0,
            'label'          => __('Fullname', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter your full name', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter your full name', 'bookingpress-appointment-booking'),
            'is_hide'        => 1,
            'field_position' => 1,
            ),
            'firstname'     => array(
            'field_name'     => 'firstname',
            'field_type'     => 'Text',
            'is_edit'        => 0,
            'is_required'    => true,
            'label'          => __('Firstname', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter your firstname', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter your firstname', 'bookingpress-appointment-booking'),
            'is_hide'        => 0,
            'field_position' => 2,
            ),
            'lastname'      => array(
            'field_name'     => 'lastname',
            'field_type'     => 'Text',
            'is_edit'        => 0,
            'is_required'    => true,
            'label'          => __('Lastname', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter your lastname', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter your lastname', 'bookingpress-appointment-booking'),
            'is_hide'        => 0,
            'field_position' => 3,
            ),
            'email_address' => array(
            'field_name'     => 'email_address',
            'field_type'     => 'Email',
            'is_edit'        => 0,
            'is_required'    => true,
            'label'          => __('Email Address', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter your email address', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter your email address', 'bookingpress-appointment-booking'),
            'is_hide'        => 0,
            'field_position' => 4,
            ),
            'phone_number'  => array(
            'field_name'     => 'phone_number',
            'field_type'     => 'Dropdown',
            'is_edit'        => 0,
            'is_required'    => true,
            'label'          => __('Phone Number', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter your phone number', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter your phone number', 'bookingpress-appointment-booking'),
            'is_hide'        => 0,
            'field_position' => 5,
            ),
            'note'          => array(
            'field_name'     => 'note',
            'field_type'     => 'Textarea',
            'is_edit'        => 0,
            'is_required'    => 0,
            'label'          => __('Note', 'bookingpress-appointment-booking'),
            'placeholder'    => __('Enter note details', 'bookingpress-appointment-booking'),
            'error_message'  => __('Please enter appointment note', 'bookingpress-appointment-booking'),
            'is_hide'        => 0,
            'field_position' => 6,
            ),
            );

            foreach ( $form_fields_default_data as $form_field_key => $form_field_val ) {
                $form_field_db_data = array(
                'bookingpress_form_field_name'     => $form_field_val['field_name'],
                'bookingpress_field_required'      => $form_field_val['is_required'],
                'bookingpress_field_label'         => $form_field_val['label'],
                'bookingpress_field_placeholder'   => $form_field_val['placeholder'],
                'bookingpress_field_error_message' => $form_field_val['error_message'],
                'bookingpress_field_is_hide'       => $form_field_val['is_hide'],
                'bookingpress_field_position'      => $form_field_val['field_position'],
                );

                $wpdb->insert($tbl_bookingpress_form_fields, $form_field_db_data);
            }
            $bookingpress_custom_data_arr['action'][] = 'bookingpress_save_my_booking_settings';
            $bookingpress_custom_data_arr['action'][] = 'bookingpress_save_booking_form_settings';           

            $my_booking_form = array(
                'background_color' => $booking_form_shortcode_default_fields['background_color'],
                'row_background_color' => $booking_form_shortcode_default_fields['footer_background_color'],
                'primary_color' => $booking_form_shortcode_default_fields['primary_color'],
                'content_color' => $booking_form_shortcode_default_fields['content_color'],
                'label_title_color'=>$booking_form_shortcode_default_fields['label_title_color'],
                'title_font_family' => $booking_form_shortcode_default_fields['title_font_family'],
                'custom_css'          => '',
                'sub_title_color' => $booking_form_shortcode_default_fields['sub_title_color'],
                'price_button_text_color' => '#fff',
            );        
            $booking_form = array(
                'background_color' => $booking_form_shortcode_default_fields['background_color'],
                'footer_background_color' => $booking_form_shortcode_default_fields['footer_background_color'],
                'primary_color' => $booking_form_shortcode_default_fields['primary_color'],
                'primary_background_color'=> $booking_form_shortcode_default_fields['primary_background_color'],
                'label_title_color' => $booking_form_shortcode_default_fields['label_title_color'],
                'title_font_family' => $booking_form_shortcode_default_fields['title_font_family'],                
                'content_color' => $booking_form_shortcode_default_fields['content_color'],                
                'price_button_text_color' => '#fff',
                'custom_css'          => '',
                'sub_title_color' => $booking_form_shortcode_default_fields['sub_title_color'],
            );        

            $bookingpress_custom_data_arr['booking_form'] = $booking_form;
            $bookingpress_custom_data_arr['my_booking_form'] = $my_booking_form;

            $this->bookingpress_generate_customize_css_func($bookingpress_custom_data_arr);
        }

        function bookingpress_install_default_pages()
        {   global $wpdb,$tbl_bookingpress_customize_settings;
            $bookingpress_thankyoupage_content = '
			<el-row>
				<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
					<div class="bpa-front-module-container bpa-front-module--booking-summary bpa-front-module--confirmation bpa-thankyou--page">
						<div class="bpa-front-module--bs-head">
							<svg width="100" height="100" viewBox="0 0 100 100" fill="none" class="bpa-head__vector--confirmation" xmlns="http://www.w3.org/2000/svg">
								<path fill-rule="evenodd" clip-rule="evenodd" d="M90.7002 85.4607C84.4375 93.0096 72.3956 90.9928 62.8277 93.3708C53.5335 95.6808 44.3866 102.22 35.2915 99.2321C26.2099 96.2486 22.8396 85.5957 16.7964 78.2482C10.8588 71.0289 1.14803 65.6954 0.0978856 56.4421C-0.951171 47.1984 6.67152 39.5219 11.4957 31.5411C15.8676 24.3084 20.1527 17.1387 26.9344 12.0452C34.1982 6.58954 42.3994 1.52524 51.5153 1.4835C60.7 1.44146 68.4886 7.2199 76.4135 11.8187C84.8089 16.6905 95.7104 20.0477 99.0838 29.0875C102.453 38.1169 94.606 47.2495 93.1897 56.7733C91.7484 66.4649 96.9793 77.8921 90.7002 85.4607Z" fill="#F4F7FB"/>
								<path d="M8.13042 32.8242L8.16292 32.9233H8.25556L8.18062 32.9772L8.21164 33.0718L8.13042 33.0133L8.04921 33.0718L8.08023 32.9772L8.00529 32.9233H8.09792L8.13042 32.8242Z" stroke="#12D488" stroke-width="0.758084"/>
								<path d="M98.6324 39.8248L98.6649 39.9239H98.7575L98.6826 39.9778L98.7136 40.0724L98.6324 40.0139L98.5512 40.0724L98.5822 39.9778L98.5072 39.9239H98.5999L98.6324 39.8248Z" stroke="#12D488" stroke-width="0.758084"/>
								<path d="M70.5923 92.4332L70.6248 92.5323H70.7175L70.6425 92.5862L70.6736 92.6808L70.5923 92.6223L70.5111 92.6808L70.5421 92.5862L70.4672 92.5323H70.5598L70.5923 92.4332Z" stroke="#F5AE41" stroke-width="0.758084"/>
								<path d="M47.4169 1.12892C47.4169 1.53965 47.0797 1.8788 46.6561 1.8788C46.2326 1.8788 45.8954 1.53965 45.8954 1.12892C45.8954 0.718185 46.2326 0.379042 46.6561 0.379042C47.0797 0.379042 47.4169 0.718185 47.4169 1.12892Z" stroke="#EE2445" stroke-opacity="0.7" stroke-width="0.758084"/>
								<path d="M94.1486 65.4766C94.1486 65.8873 93.8114 66.2265 93.3878 66.2265C92.9643 66.2265 92.6271 65.8873 92.6271 65.4766C92.6271 65.0658 92.9643 64.7267 93.3878 64.7267C93.8114 64.7267 94.1486 65.0658 94.1486 65.4766Z" stroke="#EE2445" stroke-opacity="0.6" stroke-width="0.758084"/>
								<path d="M2.51086 65.4766C2.51086 65.8873 2.17369 66.2265 1.75013 66.2265C1.32656 66.2265 0.989393 65.8873 0.989393 65.4766C0.989393 65.0658 1.32656 64.7267 1.75013 64.7267C2.17369 64.7267 2.51086 65.0658 2.51086 65.4766Z" stroke="#EE2445" stroke-opacity="0.6" stroke-width="0.758084"/>
								<path d="M78.7639 11.7399H79.1429C79.1429 11.5408 78.9889 11.3756 78.7903 11.3617C78.5916 11.3479 78.4162 11.4901 78.3885 11.6872L78.7639 11.7399ZM77.6621 12.8239V12.4449C77.4602 12.4449 77.2938 12.6031 77.2836 12.8047C77.2733 13.0063 77.4229 13.1806 77.6237 13.201L77.6621 12.8239ZM78.7639 13.9977H78.3848C78.3848 14.2046 78.5508 14.3733 78.7577 14.3767C78.9646 14.3801 79.1359 14.2169 79.1427 14.0101L78.7639 13.9977ZM79.9417 12.8389V13.2179C80.1417 13.2179 80.3073 13.0625 80.3199 12.8628C80.3326 12.6631 80.1879 12.4881 79.9894 12.4629L79.9417 12.8389ZM78.3885 11.6872C78.3704 11.8168 78.3049 12.0223 78.1788 12.186C78.0617 12.3379 77.9023 12.4449 77.6621 12.4449V13.203C78.1818 13.203 78.548 12.9487 78.7791 12.6489C79.0012 12.3608 79.1068 12.0243 79.1393 11.7925L78.3885 11.6872ZM77.6237 13.201C77.7462 13.2135 77.9495 13.2749 78.1136 13.4065C78.2641 13.5273 78.3848 13.7071 78.3848 13.9977H79.1429C79.1429 13.451 78.8964 13.0626 78.5879 12.8151C78.2929 12.5785 77.9453 12.4717 77.7005 12.4468L77.6237 13.201ZM79.1427 14.0101C79.1471 13.8767 79.1964 13.666 79.3201 13.4991C79.4308 13.3498 79.6112 13.2179 79.9417 13.2179V12.4598C79.3603 12.4598 78.9582 12.7142 78.711 13.0478C78.477 13.3637 78.3933 13.7325 78.3851 13.9853L79.1427 14.0101ZM79.9894 12.4629C79.8426 12.4442 79.6106 12.3744 79.4257 12.2425C79.2503 12.1174 79.1429 11.9588 79.1429 11.7399H78.3848C78.3848 12.2686 78.67 12.6346 78.9854 12.8596C79.2913 13.0778 79.6481 13.1837 79.8939 13.2149L79.9894 12.4629Z" fill="#F4B125"/>
								<line x1="78.6483" y1="10.6833" x2="78.6483" y2="10.3125" stroke="#F4B125" stroke-width="0.758084" stroke-linecap="round"/>
								<line x1="78.6483" y1="16.3277" x2="78.6483" y2="15.2796" stroke="#F4B125" stroke-width="0.758084" stroke-linecap="round"/>
								<path d="M80.623 12.8972H81.9908" stroke="#F4B125" stroke-width="0.758084" stroke-linecap="round"/>
								<path d="M75.6084 12.8972H76.4632" stroke="#F4B125" stroke-width="0.758084" stroke-linecap="round"/>
								<path class="bpa-head__vector-item" d="M75.3977 42.9786C74.4164 41.9652 73.4018 40.9175 73.0185 39.9995C72.6662 39.1561 72.6449 37.7592 72.6243 36.4081C72.5859 33.8939 72.5425 31.0443 70.5423 29.0632C68.5422 27.0821 65.6652 27.0391 63.1268 27.0011C61.7627 26.9807 60.3524 26.9595 59.5009 26.6106C58.5743 26.2309 57.5163 25.226 56.4931 24.2541C54.6959 22.5467 52.6584 20.6117 49.9422 20.6117C47.226 20.6117 45.1888 22.5467 43.3913 24.2541C42.3681 25.226 41.3104 26.2309 40.3835 26.6106C39.532 26.9595 38.1217 26.9807 36.7576 27.0011C34.2192 27.0391 31.3422 27.0821 29.3421 29.0632C27.3419 31.0443 27.2985 33.8939 27.2601 36.4081C27.2396 37.7592 27.2182 39.1561 26.8659 39.9995C26.4826 40.9173 25.468 41.9652 24.4868 42.9786C22.763 44.7587 20.8093 46.7768 20.8093 49.4671C20.8093 52.1575 22.763 54.1753 24.4868 55.9556C25.468 56.9691 26.4826 58.0167 26.8659 58.9348C27.2182 59.7782 27.2396 61.1751 27.2601 62.5262C27.2985 65.0404 27.3419 67.89 29.3421 69.8711C31.3422 71.8522 34.2192 71.8952 36.7576 71.9332C38.1217 71.9536 39.532 71.9747 40.3835 72.3237C41.3101 72.7034 42.3681 73.7082 43.3913 74.6802C45.1885 76.3875 47.226 78.3226 49.9422 78.3226C52.6584 78.3226 54.6957 76.3875 56.4931 74.6802C57.5163 73.7083 58.574 72.7034 59.5009 72.3237C60.3524 71.9747 61.7627 71.9536 63.1268 71.9332C65.6652 71.8952 68.5422 71.8522 70.5423 69.8711C72.5425 67.89 72.5859 65.0404 72.6243 62.5262C72.6449 61.1751 72.6662 59.7782 73.0185 58.9348C73.4018 58.017 74.4164 56.9691 75.3977 55.9556C77.1214 54.1756 79.0751 52.1575 79.0751 49.4671C79.0751 46.7768 77.1214 44.759 75.3977 42.9786ZM62.824 44.7748L47.5638 59.2025C47.1767 59.5685 46.6622 59.7727 46.1271 59.7727C45.592 59.7727 45.0775 59.5685 44.6904 59.2025L37.0604 51.9887C36.8626 51.8018 36.7039 51.5782 36.5934 51.3306C36.4829 51.083 36.4227 50.8162 36.4163 50.5456C36.4098 50.2749 36.4573 50.0057 36.556 49.7532C36.6547 49.5007 36.8026 49.27 36.9913 49.0741C37.18 48.8783 37.4058 48.7212 37.6559 48.6118C37.9059 48.5024 38.1752 48.4429 38.4485 48.4366C38.7217 48.4304 38.9936 48.4775 39.2484 48.5753C39.5033 48.6731 39.7362 48.8197 39.9339 49.0067L46.1271 54.8622L59.9505 41.7929C60.1482 41.6059 60.3811 41.4593 60.636 41.3615C60.8908 41.2636 61.1627 41.2165 61.4359 41.2228C61.7092 41.229 61.9785 41.2886 62.2285 41.3979C62.4786 41.5073 62.7044 41.6644 62.8931 41.8603C63.0818 42.0561 63.2298 42.2869 63.3284 42.5393C63.4271 42.7918 63.4746 43.0611 63.4681 43.3317C63.4617 43.6024 63.4015 43.8691 63.291 44.1167C63.1805 44.3643 63.0218 44.588 62.824 44.7748Z" />
							</svg>
							<h4>' . esc_html__('Your Appointment Booked successfully!', 'bookingpress-appointment-booking') . '</h4>
							<p>' . esc_html__('We have sent your booking information to your email address.', 'bookingpress-appointment-booking') . '</p>
						</div>
						<div class="bpa-front-module--bs-summary-content">
							<div class="bpa-front-module--bs-summary-content-item">
								<span>' . esc_html__('Service:', 'bookingpress-appointment-booking') . '</span>
								<h4>[bookingpress_appointment_service]</h4>
							</div>
							<div class="bpa-front-module--bs-summary-content-item">
								<span>' . esc_html__('Date & Time:', 'bookingpress-appointment-booking') . '</span>
								<h4>[bookingpress_appointment_datetime]</h4>
							</div>
							<div class="bpa-front-module--bs-summary-content-item">
								<span>' . esc_html__('Customer Name:', 'bookingpress-appointment-booking') . '</span>
								<h4>[bookingpress_appointment_customername]</h4>
							</div>
						</div>
                        <div class="bpa-front-module--add-to-calendar">	
							<h4 class="bpa-fm--atc__heading">' . esc_html__('Add to Calendar', 'bookingpress-appointment-booking') . '</h4>                            
                            [bookingpress_appointment_calendar_integration]
                        </div>
					</div>
				</el-col>
			</el-row>';

            $bookingpress_thankyou_page_details = array(
            'post_title'   => esc_html__('Thank you page', 'bookingpress-appointment-booking'),
            'post_name'    => 'thank-you',
            'post_content' => $bookingpress_thankyoupage_content,
            'post_status'  => 'publish',
            'post_parent'  => 0,
            'post_author'  => 1,
            'post_type'    => 'page',
            );

            $bookingpress_post_id = wp_insert_post($bookingpress_thankyou_page_details);

            $bookingpress_thankyou_page_url = get_permalink($bookingpress_post_id);
            if (! empty($bookingpress_thankyou_page_url) ) {                
                $booking_form = array(
                    'after_booking_redirection' => $bookingpress_post_id,                    
                    'bookingpress_thankyou_msg' => $bookingpress_thankyoupage_content,
                );		
                foreach($booking_form as $key => $value) {
                    $bookingpress_customize_settings_db_fields = array(
                        'bookingpress_setting_name'  => $key,
                        'bookingpress_setting_value' => $value,
                        'bookingpress_setting_type'  => 'booking_form',
                    );
                    $wpdb->insert( $tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields );
                }
            }

            $bookingpress_cancelpage_content = '		
            <div class="bpa-front-data-empty-view __bpa-is-guest-view">
                <h4>' . esc_html__('Sorry to hear that you have requested for cancel the appointment.', 'bookingpress-appointment-booking') . '</h4><br/>
                <h4>' . esc_html__('We have sent an email notification for cancel appointment. So please click on the button to cancel the appointment.', 'bookingpress-appointment-booking') . '</h4>
            </div>';

            $bookingpress_cancel_page_details = array(
            'post_title'   => esc_html__('Cancel page', 'bookingpress-appointment-booking'),
            'post_name'    => 'cancel-appointment',
            'post_content' => $bookingpress_cancelpage_content,
            'post_status'  => 'publish',
            'post_parent'  => 0,
            'post_author'  => 1,
            'post_type'    => 'page',
            );

            $bookingpress_post_id         = wp_insert_post($bookingpress_cancel_page_details);
            $bookingpress_cancel_page_url = get_permalink($bookingpress_post_id);
            if (! empty($bookingpress_cancel_page_url) ) {
                $my_booking_form = array(
                    'after_cancelled_appointment_redirection'     => $bookingpress_post_id,
                );		    
                foreach($my_booking_form as $key => $value) {
                    $bookingpress_customize_settings_db_fields = array(
                        'bookingpress_setting_name'  => $key,
                        'bookingpress_setting_value' => $value,
                        'bookingpress_setting_type'  => 'booking_my_booking',
                    );
                    $wpdb->insert( $tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields );
                }
            }

            // Cancel payment page
            $bookingpress_cancel_payment_page = '
            <div class="bpa-front-data-empty-view __bpa-is-guest-view">
                <h4>' . esc_html__('Sorry! Something went wrong. Your payment has been failed.', 'bookingpress-appointment-booking') . '</h4>
            </div>';

            $bookingpress_cancel_page_details = array(
            'post_title'   => esc_html__('Cancel Payment page', 'bookingpress-appointment-booking'),
            'post_name'    => 'cancel-payment',
            'post_content' => $bookingpress_cancel_payment_page,
            'post_status'  => 'publish',
            'post_parent'  => 0,
            'post_author'  => 1,
            'post_type'    => 'page',
            );

            $bookingpress_post_id            = wp_insert_post($bookingpress_cancel_page_details);
            $bookingpress_cancel_payment_url = get_permalink($bookingpress_post_id);
            if (! empty($bookingpress_cancel_payment_url) ) {
                $my_booking_form = array(
                    'after_failed_payment_redirection' => $bookingpress_post_id,
                    'bookingpress_failed_payment_msg' => $bookingpress_cancel_payment_page,
                );		    
                foreach($my_booking_form as $key => $value) {
                    $bookingpress_customize_settings_db_fields = array(
                        'bookingpress_setting_name'  => $key,
                        'bookingpress_setting_value' => $value,
                        'bookingpress_setting_type'  => 'booking_form',
                    );
                    $wpdb->insert( $tbl_bookingpress_customize_settings, $bookingpress_customize_settings_db_fields );
                }
            }
        }

        function bookingpress_check_common_date_format( $selected_date_format )
        {
            $return_final_date_format              = '';
            $Bookingpres_elementer_default_formate = array(
            'Y' => 'yyyy',
            'y' => 'yy',
            'F' => 'MMMM',
            'M' => 'MMM',
            'm' => 'MM',
            'n' => 'M',
            'l' => 'dddd',
            'D' => 'ddd',
            'd' => 'dd',
            'j' => 'd',
            );
            $bookingpress_supported_date_formats   = array( 'd', 'D', 'm', 'M', 'y', 'Y', 'F', 'j', 'l', 'n' );

            if ($selected_date_format == 'F j, Y' ) {
                return 'MMMM d, yyyy';
            } elseif (substr_count($selected_date_format, '-') ) {
                $bookingpress_tmp_date_format_arr = explode('-', $selected_date_format);
                if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {

                    $return_final_date_format = '';
                    if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[0] ] . '-';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[1] ] . '-';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[2] ];
                    }
                    return $return_final_date_format;
                } else {
                    return 'MMMM d, yyyy';
                }
            } elseif (substr_count($selected_date_format, '/') ) {
                $bookingpress_tmp_date_format_arr = explode('/', $selected_date_format);

                if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {

                    $return_final_date_format = '';
                    if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[0] ] . '/';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[1] ] . '/';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[2] ];
                    }
                    return $return_final_date_format;
                } else {
                    return 'MMMM d, yyyy';
                }
            } elseif (substr_count($selected_date_format, ' ') ) {

                $bookingpress_tmp_date_format_arr = explode(' ', $selected_date_format);
                $return_final_date_format         = '';

                if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {

                    if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[0] ] . ' ';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[1] ] . ' ';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[2] ];
                    }
                    return $return_final_date_format;

                } else {
                    return 'MMMM d, yyyy';
                }
            } elseif (substr_count($selected_date_format, '.') ) {
                $bookingpress_tmp_date_format_arr = explode('.', $selected_date_format);
                $return_final_date_format         = '';

                if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) && in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {

                    if (in_array($bookingpress_tmp_date_format_arr[0], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[0] ] . '.';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[1], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[1] ] . '.';
                    }
                    if (in_array($bookingpress_tmp_date_format_arr[2], $bookingpress_supported_date_formats) ) {
                        $return_final_date_format = $return_final_date_format . $Bookingpres_elementer_default_formate[ $bookingpress_tmp_date_format_arr[2] ];
                    }
                    return $return_final_date_format;

                } else {
                    return 'MMMM d, yyyy';
                }
            } else {
                return 'MMMM d, yyyy';
            }
        }

	function bookingpress_check_common_time_format( $selected_time_format ) {
		if ( $selected_time_format == 'g:i a' ) {
			return 'h mm a';
		} else if( $selected_time_format == 'g:i A' ) {
			return 'h mm A';
		} else if( $selected_time_format == 'H:i' ) {
			return 'hh mm';
		} else if( $selected_time_format == 'H:i:s' ) {
			return 'hh mm ss';
		} else {
			return 'h mm a';
		}
	}
		
        function bookingpress_write_response( $response_data, $file_name = '' )
        {
            global $wp, $wpdb, $wp_filesystem;
            $file_path = BOOKINGPRESS_DIR . '/log/response.txt';
            if (file_exists(ABSPATH . 'wp-admin/includes/file.php') ) {
                include_once ABSPATH . 'wp-admin/includes/file.php';
                if (false === ( $creds = request_filesystem_credentials($file_path, '', false, false) ) ) {
                    return true;
                }

                if (! WP_Filesystem($creds) ) {
                    request_filesystem_credentials($file_path, $method, true, false);
                    return true;
                }
                @$file_data = $wp_filesystem->get_contents($file_path);
                $file_data .= $response_data;
                $file_data .= "\r\n===========================================================================\r\n";
                $breaks     = array( '<br />', '<br>', '<br/>' );
                $file_data  = str_ireplace($breaks, "\r\n", $file_data);

                @$write_file = $wp_filesystem->put_contents($file_path, $file_data, 0755);
            }
            return;
        }
        function bookingpress_write_payment_log( $bookingpress_log_payment_gateway, $bookingpress_log_event, $bookingpress_log_event_from = 'bookingpress', $bookingpress_payment_log_raw_data = '', $bookingpress_ref_id = 0, $bookingpress_log_status = 1 )
        {

            global $wpdb, $BookingPress,$bookingpress_debug_payment_log_id,$tbl_bookingpress_debug_payment_log;

            $bookingpress_log_payment_setting_name = $bookingpress_log_payment_gateway;
            $bookingpress_active_gateway           = false;
            if (! empty($bookingpress_log_payment_gateway) && $bookingpress_log_payment_gateway == 'on-site' ) {
                $bookingpress_log_payment_setting_name = 'on_site_payment';
            } elseif(!empty($bookingpress_log_payment_gateway)){
                $bookingpress_log_payment_setting_name = $bookingpress_log_payment_gateway.'_payment';
            }
            if (! empty($bookingpress_log_payment_setting_name) ) {
                $bookingpress_active_gateway = $BookingPress->bookingpress_get_settings($bookingpress_log_payment_setting_name, 'debug_log_setting');
            }
            $inserted_id = 0;
            if ($bookingpress_active_gateway == 'true' ) {
                if ($bookingpress_ref_id == null ) {
                    $bookingpress_ref_id = 0;
                }

                $bookingpress_database_log_data = array(
                'bookingpress_payment_log_ref_id'     => sanitize_text_field($bookingpress_ref_id),
                'bookingpress_payment_log_gateway'    => sanitize_text_field($bookingpress_log_payment_gateway),
                'bookingpress_payment_log_event'      => sanitize_text_field($bookingpress_log_event),
                'bookingpress_payment_log_event_from' => sanitize_text_field($bookingpress_log_event_from),
                'bookingpress_payment_log_status'     => sanitize_text_field($bookingpress_log_status),
                'bookingpress_payment_log_raw_data'   => json_encode(stripslashes_deep($bookingpress_payment_log_raw_data)),
                'bookingpress_payment_log_added_date' => current_time('mysql'),
                );

                $wpdb->insert($tbl_bookingpress_debug_payment_log, $bookingpress_database_log_data);
                $inserted_id = $wpdb->insert_id;
                if (empty($bookingpress_ref_id) ) {
                    $bookingpress_ref_id = $inserted_id;
                }
            }
            $bookingpress_debug_payment_log_id = $bookingpress_ref_id;
            return $inserted_id;
        }

        function bookingpress_debug_log_download_file()
        {

            if (! empty($_REQUEST['bookingpress_action']) && 'download_log' == sanitize_text_field($_REQUEST['bookingpress_action']) ) {

                $filename = ! empty($_REQUEST['file']) ? basename(sanitize_file_name($_REQUEST['file'])) : '';
                if (! empty($filename) ) {
                    $file_path = BOOKINGPRESS_UPLOAD_DIR . '/' . $filename;

                    $allowexts = array( 'txt', 'zip' );

                    $file_name_bpa = substr($filename, 0, 3);

                    $checkext = explode('.', $filename);
                    $ext      = strtolower($checkext[ count($checkext) - 1 ]);

                    if (! empty($ext) && in_array($ext, $allowexts) && ! empty($filename) && file_exists($file_path) ) {
                        ignore_user_abort();
                        $now = gmdate('D, d M Y H:i:s');
                        header('Expires: Tue, 03 Jul 2020 06:00:00 GMT');
                        header('Cache-Control: max-age=0, no-cache, must-revalidate, proxy-revalidate');
                        header("Last-Modified: {$now} GMT");
                        header('Content-Type: application/force-download');
                        header('Content-Type: application/octet-stream');
                        header('Content-Type: application/download');
                        header("Content-Disposition: attachment;filename={$filename}");
                        header('Content-Transfer-Encoding: binary');

                        readfile($file_path);

                        unlink($file_path);

                        $bpa_txt_file_name = str_replace('.zip', '.txt', $filename);
                        $bpa_txt_file_path = BOOKINGPRESS_UPLOAD_DIR . '/' . $bpa_txt_file_name;
                        if (file_exists($bpa_txt_file_path) ) {
                               unlink($bpa_txt_file_path);
                        }

                        die;
                    }
                }
            }
        }
        function bookingpress_view_debug_payment_log_func()
        {
            global $wpdb,$tbl_bookingpress_debug_payment_log;
            $response              = array();
            $response['variant']   = 'error';
            $response['title']     = esc_html__('Error', 'bookingpress-appointment-booking');
            $response['msg']       = esc_html__('Something went wrong', 'bookingpress-appointment-booking');
            $wpnonce               = isset($_REQUEST['_wpnonce']) ? sanitize_text_field($_REQUEST['_wpnonce']) : '';
            $bpa_verify_nonce_flag = wp_verify_nonce($wpnonce, 'bpa_wp_nonce');

            $perpage     = isset($_POST['perpage']) ? intval($_POST['perpage']) : 20;
            $currentpage = isset($_POST['currentpage']) ? intval($_POST['currentpage']) : 1;
            $offset      = ( ! empty($currentpage) && $currentpage > 1 ) ? ( ( $currentpage - 1 ) * $perpage ) : 0;

            if (! $bpa_verify_nonce_flag ) {
                $response['variant'] = 'error';
                $response['title']   = esc_html__('Error', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Sorry, Your request can not process due to security reason.', 'bookingpress-appointment-booking');
                wp_send_json($response);
                die();
            }
            $bookingpress_view_log_selector = isset($_REQUEST['bookingpress_debug_log_selector']) ? sanitize_text_field($_REQUEST['bookingpress_debug_log_selector']) : '';

            if (! empty($bookingpress_view_log_selector) ) {
                /* $bookingpress_search_query  = ' WHERE 1=1';
                $bookingpress_search_query .= " AND bookingpress_payment_log_gateway = '{$bookingpress_view_log_selector}'"; */
                $total_payment_debug_logs   = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $tbl_bookingpress_debug_payment_log . " WHERE bookingpress_payment_log_gateway = %s ORDER BY bookingpress_payment_log_id DESC", $bookingpress_view_log_selector ), ARRAY_A); //phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared --Reason $tbl_bookingpress_debug_payment_log is table name
                $payment_debug_logs         = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $tbl_bookingpress_debug_payment_log . " WHERE bookingpress_payment_log_gateway = %s ORDER BY bookingpress_payment_log_id DESC LIMIT %d, %d", $bookingpress_search_query, $offset , $perpage ), ARRAY_A); //phpcs:ignore WordPress.DB.PreparedSQL.NotPrepared --Reason $tbl_bookingpress_debug_payment_log is table name
                $payment_debug_log_data = array();
                if (! empty($payment_debug_logs) ) {
                    $bookingpress_date_format = get_option('date_format');
                    foreach ( $payment_debug_logs as $payment_debug_log_key => $payment_debug_log_val ) {

                        $bookingpress_payment_log_id         = ! empty($payment_debug_log_val['bookingpress_payment_log_id']) ? intval($payment_debug_log_val['bookingpress_payment_log_id']) : '';
                        $bookingpress_payment_log_event      = ! empty($payment_debug_log_val['bookingpress_payment_log_event']) ? esc_html($payment_debug_log_val['bookingpress_payment_log_event']) : '';
                        $bookingpress_payment_log_raw_data   = ! empty($payment_debug_log_val['bookingpress_payment_log_raw_data']) ? $payment_debug_log_val['bookingpress_payment_log_raw_data'] : '';
                        $bookingpress_payment_log_added_date = ! empty($payment_debug_log_val['bookingpress_payment_log_added_date']) ? esc_html($payment_debug_log_val['bookingpress_payment_log_added_date']) : '';

                        $payment_debug_log_data[] = array(
                         'payment_debug_log_id'         => $bookingpress_payment_log_id,
                         'payment_debug_log_name'       => $bookingpress_payment_log_event,
                         'payment_debug_log_data'       => $bookingpress_payment_log_raw_data,
                         'payment_debug_log_added_date' => date($bookingpress_date_format, strtotime($bookingpress_payment_log_added_date)),
                        );
                    }
                }
            }
            $data['items'] = $payment_debug_log_data;
            $data['total'] = count($total_payment_debug_logs);

            // Modify debug logs data
            $data = apply_filters('bookingpress_modify_debug_log_data', $data, $_REQUEST);

            wp_send_json($data);
            exit;
        }
        function bookingpress_clear_debug_payment_log_func()
        {
            global $wpdb,$tbl_bookingpress_debug_payment_log;
            $response              = array();
            $response['variant']   = 'error';
            $response['title']     = esc_html__('Error', 'bookingpress-appointment-booking');
            $response['msg']       = esc_html__('Something went wrong', 'bookingpress-appointment-booking');
            $wpnonce               = isset($_REQUEST['_wpnonce']) ? sanitize_text_field($_REQUEST['_wpnonce']) : '';
            $bpa_verify_nonce_flag = wp_verify_nonce($wpnonce, 'bpa_wp_nonce');
            if (! $bpa_verify_nonce_flag ) {
                $response['variant'] = 'error';
                $response['title']   = esc_html__('Error', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Sorry, Your request can not process due to security reason.', 'bookingpress-appointment-booking');
                wp_send_json($response);
                die();
            }
            $bookingpress_view_log_selector = ! empty($_REQUEST['bookingpress_debug_log_selector']) ? sanitize_text_field($_REQUEST['bookingpress_debug_log_selector']) : '';
            if (! empty($bookingpress_view_log_selector) ) {
                // If data exists into payment debug log table then delete from that table.
                $wpdb->delete($tbl_bookingpress_debug_payment_log, array( 'bookingpress_payment_log_gateway' => $bookingpress_view_log_selector ), array( '%s' ));
                $response['variant'] = 'success';
                $response['title']   = esc_html__('Success', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Debug Logs Cleared Successfully.', 'bookingpress-appointment-booking');
            }

            do_action('bookingpress_delete_debug_log_from_outside', $_POST);

            echo json_encode($response);
            exit();
        }
        function bookingpress_download_payment_log_func()
        {
            global $wpdb,$tbl_bookingpress_debug_payment_log;
            $response              = array();
            $response['variant']   = 'error';
            $response['title']     = esc_html__('Error', 'bookingpress-appointment-booking');
            $response['msg']       = esc_html__('Something went wrong', 'bookingpress-appointment-booking');
            $wpnonce               = isset($_REQUEST['_wpnonce']) ? sanitize_text_field($_REQUEST['_wpnonce']) : '';
            $bpa_verify_nonce_flag = wp_verify_nonce($wpnonce, 'bpa_wp_nonce');
            if (! $bpa_verify_nonce_flag ) {
                $response['variant'] = 'error';
                $response['title']   = esc_html__('Error', 'bookingpress-appointment-booking');
                $response['msg']     = esc_html__('Sorry, Your request can not process due to security reason.', 'bookingpress-appointment-booking');
                wp_send_json($response);
                die();
            }
            $bookingpress_view_log_selector          = ! empty($_REQUEST['bookingpress_debug_log_selector']) ? sanitize_text_field($_REQUEST['bookingpress_debug_log_selector']) : '';
            $bookingpress_selected_download_duration = ! empty($_REQUEST['bookingpress_selected_download_duration']) ? sanitize_text_field($_REQUEST['bookingpress_selected_download_duration']) : 'all';

            if (! empty($bookingpress_view_log_selector) && ! empty($bookingpress_selected_download_duration) ) {

                $bookingpress_debug_payment_log_where_cond = '';
                if (! empty($_REQUEST['bookingpress_selected_download_custom_duration']) && $bookingpress_selected_download_duration == 'custom' ) {
                    $bookingpress_search_date                  = sanitize_text_field($_REQUEST['bookingpress_selected_download_custom_duration']);
                    $bookingpress_start_date                   = date('Y-m-d 00:00:00', strtotime(sanitize_text_field($bookingpress_search_date[0])));
                    $bookingpress_end_date                     = date('Y-m-d 23:59:59', strtotime(sanitize_text_field($bookingpress_search_date[1])));
                    $bookingpress_debug_payment_log_where_cond = $wpdb->prepare(' AND (bookingpress_payment_log_added_date >= %s AND bookingpress_payment_log_added_date <= %s)', $bookingpress_start_date, $bookingpress_end_date);
                } elseif (! empty($bookingpress_view_log_selector) && $bookingpress_view_log_selector != 'custom' ) {

                    $bookingpress_last_selected_days           = date('Y-m-d', strtotime('-' . $bookingpress_selected_download_duration . ' days'));
                    $bookingpress_debug_payment_log_where_cond = $wpdb->prepare(' AND (bookingpress_payment_log_added_date >= %s)', $bookingpress_last_selected_days);
                }
                $bookingpress_debug_payment_log_query = 'SELECT * FROM `' . $tbl_bookingpress_debug_payment_log . "` WHERE `bookingpress_payment_log_gateway` = '" . $bookingpress_view_log_selector . "' AND `bookingpress_payment_log_status` = 1 " . $bookingpress_debug_payment_log_where_cond . ' ORDER BY bookingpress_payment_log_id DESC';

                $bookingpress_debug_payment_log_query = apply_filters('bookingpress_modify_download_debug_log_query', $bookingpress_debug_payment_log_query, $bookingpress_view_log_selector, $_REQUEST);

                $bookingpress_payment_debug_log_data = $wpdb->get_results($bookingpress_debug_payment_log_query, ARRAY_A);

                $bookingpress_download_data = json_encode($bookingpress_payment_debug_log_data);

                if (! function_exists('WP_Filesystem') ) {
                    include_once ABSPATH . 'wp-admin/includes/file.php';
                }
                WP_Filesystem();
                global $wp_filesystem;

                $bookingpresss_debug_log_file_name = 'bookingpress_debug_logs_' . $bookingpress_view_log_selector . '_' . $bookingpress_selected_download_duration;
                $result                            = $wp_filesystem->put_contents(BOOKINGPRESS_UPLOAD_DIR . '/' . $bookingpresss_debug_log_file_name . '.txt', $bookingpress_download_data, 0777);

                $debug_log_file_name = '';

                if (class_exists('ZipArchive') ) {
                    $zip = new ZipArchive();
                    $zip->open(BOOKINGPRESS_UPLOAD_DIR . '/' . $bookingpresss_debug_log_file_name . '.zip', ZipArchive::CREATE);
                    $zip->addFile(BOOKINGPRESS_UPLOAD_DIR . '/' . $bookingpresss_debug_log_file_name . '.txt', $bookingpresss_debug_log_file_name . '.txt');
                    $zip->close();

                    $bookingpress_download_url = BOOKINGPRESS_UPLOAD_URL . '/' . $bookingpresss_debug_log_file_name . '.zip';
                    $debug_log_file_name       = $bookingpresss_debug_log_file_name . '.zip';
                } else {
                    $bookingpress_download_url = BOOKINGPRESS_UPLOAD_URL . '/' . $bookingpresss_debug_log_file_name . '.txt';
                    $debug_log_file_name       = $bookingpresss_debug_log_file_name . '.txt';
                }

                $response['url'] = admin_url('admin.php?page=bookingpress&module=settings&bookingpress_action=download_log&file=' . $debug_log_file_name);
                echo json_encode($response);
                exit();
            }
            echo json_encode($response);
            exit();
        }
        function appointment_sanatize_field( $data_array )
        {
            if (is_array($data_array) ) {
                return array_map(array( $this, __FUNCTION__ ), $data_array);
            } else {
                return sanitize_text_field($data_array);
            }
        }

        function bookingpress_gutenberg_category( $category, $post )
        {
            $new_category     = array(
            array(
            'slug'  => 'bookingpress',
            'title' => 'Bookingpress Blocks',
            ),
            );
            $final_categories = array_merge($category, $new_category);
            return $final_categories;
        }

        function bookingpress_enqueue_gutenberg_assets()
        {
            global $bookingpress_version;
            if (isset($_SERVER['PHP_SELF']) && ! in_array(basename($_SERVER['PHP_SELF']), array( 'site-editor.php' )) ) {
                wp_register_script('bookingpress_gutenberg_script', BOOKINGPRESS_URL . '/js/bookingpress_gutenberg_script.js', array( 'wp-blocks', 'wp-element', 'wp-i18n', 'wp-components' ), $bookingpress_version);
                wp_enqueue_script('bookingpress_gutenberg_script');
            }

        }
        
		function bookingpress_select_date_before_load($date = '',$bookingpress_daysoff_date = array()){
			$bpa_current_date = $bpa_date = !empty($date) ? $date : date('Y-m-d');			
			$bpa_current_date =  date('c',strtotime($bpa_current_date));

            if(empty($bookingpress_daysoff_date)) {
			    $bookingpress_daysoff_date = $this->bookingpress_get_default_dayoff_dates();
            }
			if(!empty($bookingpress_daysoff_date) && is_array($bookingpress_daysoff_date)) {
				foreach($bookingpress_daysoff_date as $k => $v){
					$daysoff_tmp_date = date('Y-m-d', strtotime($v));
					if($daysoff_tmp_date == $bpa_date){
						$bpa_current_date  = date('Y-m-d',strtotime($bpa_date.'+1 Day'));					
						return $this->bookingpress_select_date_before_load($bpa_current_date,$bookingpress_daysoff_date);
					}
				}
				/*$bookingpress_is_exist = array_search($bpa_current_date, $bookingpress_daysoff_date);
				if(in_array($bpa_current_date, $bookingpress_daysoff_date)) {										
					$bpa_current_date  = date('Y-m-d',strtotime($bpa_date.'+1 Day'));					
					return $this->bookingpress_select_date_before_load($bpa_current_date);
				}*/		
			} 
			return $bpa_date;			
		}	

        function bookingpress_get_appointment_customer_list()
        {
            global $wpdb,$tbl_bookingpress_customers;
            $bookingpress_search_query_where = 'WHERE 1=1 ';
            $bookingpress_search_join_query  = '';

            $bookingpress_search_join_query  = apply_filters('bookingpress_appointment_customer_list_join_filter', $bookingpress_search_join_query);
            $bookingpress_search_query_where = apply_filters('bookingpress_appointment_customer_list_filter', $bookingpress_search_query_where);

            $bookingpress_customer_details = $wpdb->get_results('SELECT cs.bookingpress_customer_id,cs.bookingpress_user_firstname,cs.bookingpress_user_lastname,cs.bookingpress_user_email FROM ' . $tbl_bookingpress_customers . ' as cs ' . $bookingpress_search_join_query . ' ' . $bookingpress_search_query_where . ' AND cs.bookingpress_user_type = 2 AND cs.bookingpress_user_status = 1', ARRAY_A);

            $bookingpress_customer_selection_details = array();
            foreach ( $bookingpress_customer_details as $bookingpress_customer_key => $bookingpress_customer_val ) {
                $bookingpress_customer_name = ( $bookingpress_customer_val['bookingpress_user_firstname'] == '' && $bookingpress_customer_val['bookingpress_user_lastname'] == '' ) ? $bookingpress_customer_val['bookingpress_user_email'] : $bookingpress_customer_val['bookingpress_user_firstname'] . ' ' . $bookingpress_customer_val['bookingpress_user_lastname'];

                $bookingpress_customer_selection_details[] = array(
                'text'  => stripslashes_deep($bookingpress_customer_name),
                'value' => $bookingpress_customer_val['bookingpress_customer_id'],
                );
            }
            return $bookingpress_customer_selection_details;
        }

        function bookingpress_get_search_customer_list()
        {
            global $wpdb,$tbl_bookingpress_customers;

            $bookingpress_search_query_where = 'WHERE 1=1 ';
            $bookingpress_search_join_query  = '';

            $bookingpress_search_join_query  = apply_filters('bookingpress_search_customer_list_join_filter', $bookingpress_search_join_query);
            $bookingpress_search_query_where = apply_filters('bookingpress_search_customer_list_filter', $bookingpress_search_query_where);

            $bookingpress_customer_details = $wpdb->get_results('SELECT cs.bookingpress_customer_id,cs.bookingpress_user_firstname,cs.bookingpress_user_lastname,cs.bookingpress_user_email FROM ' . $tbl_bookingpress_customers . ' as cs ' . $bookingpress_search_join_query . ' ' . $bookingpress_search_query_where . ' AND cs.bookingpress_user_type = 2 AND cs.bookingpress_user_status = 1', ARRAY_A);

            $bookingpress_customer_selection_details = array();
            foreach ( $bookingpress_customer_details as $bookingpress_customer_key => $bookingpress_customer_val ) {
                $bookingpress_customer_name = ( $bookingpress_customer_val['bookingpress_user_firstname'] == '' && $bookingpress_customer_val['bookingpress_user_lastname'] == '' ) ? $bookingpress_customer_val['bookingpress_user_email'] : $bookingpress_customer_val['bookingpress_user_firstname'] . ' ' . $bookingpress_customer_val['bookingpress_user_lastname'];

                $bookingpress_customer_selection_details[] = array(
                'text'  => stripslashes_deep($bookingpress_customer_name),
                'value' => $bookingpress_customer_val['bookingpress_customer_id'],
                );
            }

            return $bookingpress_customer_selection_details;
        }

        function bookingpress_generate_customize_css_func($bookingpress_custom_data_arr) {
            global $BookingPress;
            $bookingpress_customize_css_content = '';
            $bookingpress_customize_css_key     = get_option('bookingpress_custom_css_key', true); 

            if(!empty($bookingpress_custom_data_arr['action'])) {
                update_option('bookingpress_customize_changes_notice', 1);

                foreach($bookingpress_custom_data_arr['action'] as $key => $value) {            
                    $bookingpress_customize_css_content = '';
                    if( $value == 'bookingpress_save_my_booking_settings') {
                        $shortcode_background_color = $bookingpress_custom_data_arr['my_booking_form']['background_color'];
                        $raw_background_color       = $bookingpress_custom_data_arr['my_booking_form']['row_background_color'];
                        $primary_color              = $bookingpress_custom_data_arr['my_booking_form']['primary_color'];
                        $label_title_color          = $bookingpress_custom_data_arr['my_booking_form']['label_title_color'];
                        $content_color              = $bookingpress_custom_data_arr['my_booking_form']['content_color'];
                        $sub_title_color            = $bookingpress_custom_data_arr['my_booking_form']['sub_title_color'];
                        $title_font_size            = '18px';
                        $title_font_family          = $bookingpress_custom_data_arr['my_booking_form']['title_font_family'];
                        $price_button_color         = $bookingpress_custom_data_arr['my_booking_form']['price_button_text_color'];                        
                        $content_font_size          = '14px';
                        $sub_title_font_size        = '16px';
                        $hex                        = $primary_color;
                        list($r, $g, $b)            = sscanf($hex, '#%02x%02x%02x');
                        $primary_alpha_color        = "rgba($r,$g,$b,0.06)";

                        $bookingpress_customize_css_content .= '.bpa-front-my-appointments-container,.el-picker-panel.bpa-front--date-range-picker {
                            --bpa-pt-main-green: ' . $primary_color . ' !important;
                            --bpa-pt-main-green-alpha-12: ' . $primary_alpha_color . ' !important;
                        }';
                        $bookingpress_customize_css_content .= '.bpa-front-default-card{
                                background: ' . $shortcode_background_color . ' !important;
                            }
                            .bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card{
                                background: ' . $raw_background_color . '!important;
                                border: 1px solid ' . $raw_background_color . ' !important;
                            }';

                        $bookingpress_customize_css_content .= '
                            .bpa-front-my-appointments-container .bpa-front-module-heading{
                                color: ' . $label_title_color . ' !important;
                                font-size: ' . $title_font_size . ' !important;
                            }';

                        if ($title_font_family != 'Inherit Fonts' ) {
                            $bookingpress_customize_css_content .= '.bpa-front-my-appointments-container .bpa-front-module-heading, .bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__heading h6,.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card p, .bpa-front-my-appointments-container .bpa-front-pill,.bpa-front-my-appointments-container .bpa-front-ma-header__profile-dropdown .bpa-front-ma-header__profile-dropdown--body p,.bpa-front-data-empty-view--my-bookings h4, .bpa-front-ma-lists .bpa-tf-btn-group .bpa-front-btn, .bpa-front-form-control--date-range-picker.el-date-editor, .el-date-range-picker,.bpa-front-form-control--date-range-picker .el-range-input,.bpa-front-my-appointments-container .bpa-front-form-control.el-input .el-input__inner,.bpa-front-my-appointments-container .bpa-front-ma-header__profile-dropdown .bpa-front-ma-header__profile-dropdown--body h4,.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card h4{
                                font-family: ' . $title_font_family . ' !important;
                            }';
                        }

                        $bookingpress_customize_css_content .= '.bpa-front-ma-lists .bpa-tf-btn-group .bpa-front-btn,.bpa-front-my-appointments-container .bpa-front-ma-header__profile-dropdown .bpa-front-ma-header__profile-dropdown--body p,.bpa-front-ma-header__right_content .bpa-front-btn,.bpa-front--date-range-picker .el-date-range-picker__header,.bpa-front--date-range-picker table th,.bpa-front--date-range-picker table tr td.available,.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__heading h6,.bpa-front-my-appointments-container .bpa-front-form-control.el-input .el-input__inner{
                                color: ' . $content_color . ' !important;
                                font-size: ' . $content_font_size . ' !important;               
                            }';

                        $bookingpress_customize_css_content .= '.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card h4{
                            color: ' . $sub_title_color . ' !important;
                        }';
                        $bookingpress_customize_css_content .= '
                        .bpa-tf-btn-group .bpa-front-btn.bpa-front-btn--primary span {
                            color:'.$price_button_color.' !important;
                        }';
                        $bookingpress_customize_css_content .= '
                        .bpa-front-my-appointments-container .bpa-front-ma-header__profile-dropdown .bpa-front-ma-header__profile-dropdown--body h4,.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card p,.bpa-front-my-appointments-container .bpa-front-pill {
                            color: ' . $sub_title_color . ' !important;
                        }';
                        $bookingpress_customize_css_content .= '
                        .bpa-front-my-appointments-container .bpa-front-ma-header__profile-dropdown .bpa-front-ma-header__profile-dropdown--body h4,.bpa-front-my-appointments-container .bpa-front-form-control.el-input .el-input__inner,bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card h4,.bpa-front-my-appointments-container .bpa-front-ma-list--item-row .bpa-front-ma-list--item__item-card p,.bpa-front-form-control--date-range-picker .el-range-input,.bpa-front-form-control--date-range-picker.el-date-editor--daterange .el-range-separator,.bpa-front-my-appointments-container .bpa-front-pill {
                            font-size: ' . $content_font_size . ' !important;               
                        }';
                        $bookingpress_customize_css_content .= '
                        .bpa-front-my-appointments-container .bpa-front-form-control.el-input .el-input__inner,.bpa-front-form-control--date-range-picker .el-range-input,.bpa-front-form-control--date-range-picker.el-date-editor--daterange .el-range-separator{
                            color: ' . $label_title_color . ' !important;
                        }';

                        // Get custom CSS value
                        $bookingpress_customize_css_content .= $bookingpress_custom_data_arr['my_booking_form']['custom_css'];

                        if (! function_exists('WP_Filesystem') ) {
                            include_once ABSPATH . 'wp-admin/includes/file.php';
                        }
                        WP_Filesystem();
                        global $wp_filesystem;
                        $wp_upload_dir = wp_upload_dir();
                        $target_path   = $wp_upload_dir['basedir'] . '/bookingpress/bookingpress_front_mybookings_custom_' . $bookingpress_customize_css_key . '.css';
                        $result        = $wp_filesystem->put_contents($target_path, $bookingpress_customize_css_content, 0777);

                    } else {              
                        $shortcode_background_color        = $bookingpress_custom_data_arr['booking_form']['background_color'];
                        $shortcode_footer_background_color = $bookingpress_custom_data_arr['booking_form']['footer_background_color'];
                        $primary_color                     = $bookingpress_custom_data_arr['booking_form']['primary_color'];
                        $primary_alpha_color               = $bookingpress_custom_data_arr['booking_form']['primary_background_color'];
                        $title_label_color                 = $bookingpress_custom_data_arr['booking_form']['label_title_color'];
                        $title_font_size                   = '18px';
                        $title_font_family                 = $bookingpress_custom_data_arr['booking_form']['title_font_family'];
                        $content_color                     = $bookingpress_custom_data_arr['booking_form']['content_color'];
                        $price_button_text_content_color   = $bookingpress_custom_data_arr['booking_form']['price_button_text_color'];                        
                        $sub_title_font_size               = '16px';
                        $content_font_size                 = '14px';
                        $sub_title_color                   = $bookingpress_custom_data_arr['booking_form']['sub_title_color'];

                        $hex                               = $primary_color;
                        list($r, $g, $b)                   = sscanf($hex, '#%02x%02x%02x');
                        $box_shadow_color                  = "0 4px 8px rgba($r,$g,$b,0.06), 0 8px 16px rgba($r,$g,$b,0.16)";

                        $bookingpress_customize_css_content .= '.bpa-front-tabs {
                                --bpa-pt-main-green: ' . $primary_color . ' !important;
                                --bpa-pt-main-green-darker: ' . $primary_color . ' !important;
                                --bpa-pt-main-green-alpha-12: ' . $primary_alpha_color . ' !important;
                            }
                            .bpa-front-tabs .bpa-front-tab-menu{
                                background-color: ' . $shortcode_background_color . ' !important;
                            }
                            .bpa-front-tabs .bpa-front-default-card{
                                background-color: ' . $shortcode_background_color . ' !important;
                            }
                            .bpa-front-tabs .bpa-front-tabs--foot{
                                background-color: ' . $shortcode_footer_background_color . ' !important;
                            }';

                        $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front-module-heading,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-head h4, .bpa-front-tabs .bpa-front-module--payment-methods .bpa-front-module--pm-head .__content h4, .bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-heading h4,.bpa-front-select-payment-method-label{
                                color: ' . $title_label_color . ' !important;
                                font-size: ' . $title_font_size . ' !important;
                            }';                  
                        if ($title_font_family != 'Inherit Fonts' ) {
                            $bookingpress_customize_css_content .= '
                                .bpa-front-tabs .bpa-front-module-heading, .bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-head h4, .bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-amount-details h4, .bpa-front-tabs .bpa-front-module--payment-methods .bpa-front-module--pm-head .__content h4, .bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-heading h4,.bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__cell .vuecal__cell-date, .bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__weekdays-headings .weekday-label span, .bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-body .bpa-front--dt__ts-body--row .bpa-front--dt__ts-body--items .bpa-front--dt__ts-body--item span, .bpa-front-tabs .bpa-front-form-control input, .bpa-front-tabs .bpa-front-form-control .el-textarea__inner, .bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item h4, .bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-head p, .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p,.bpa-front-tabs .el-form-item__label .bpa-front-form-label, .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .--bpa-is-desc, .bpa-front-module--payment-methods .bpa-front-module--pm-body .bpa-front-module--pm-body__item p, .bpa-front-module--payment-methods .bpa-front-module--pm__empty-view h4,.bpa-front-tabs .bpa-front-tab-menu--item, .bpa-front-tabs .bpa-front-tab-menu .bpa-front-tab-menu--item,.el-form-item__error,.bpa-front-tabs .bpa-front-ci-item-title,.bpa-front-tabs .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p strong, .bpa-front-tabs .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si__card-body--heading, .bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-body .bpa-front--dt__ts-body--row h5,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item span,.bpa-front-module--bs-amount-details .bpa-fm--bs-amount-item .bpa-front-total-payment-amount-label, .bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__title-bar span,.bpa-front-dc--footer .bpa-front-tabs--foot .bpa-front-back-btn,.bpa-front-dc--footer .bpa-front-tabs--foot .bpa-front-next-btn,.bpa-front-select-payment-method-label{
                                    font-family: ' . $title_font_family . ' !important;
                                }';
                        }

                        $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__cell .vuecal__cell-date,.bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__weekdays-headings .weekday-label span,.bpa-front-tabs .bpa-front-form-control .el-textarea__inner,.bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p, .bpa-front-module--payment-methods .bpa-front-module--pm__empty-view h4,.bpa-front-tabs .bpa-front-tabs--vertical-left .bpa-front-tab-menu .bpa-front-tab-menu--item:hover {
                                color: ' . $content_color . ' !important;
                                font-size: ' . $content_font_size . ' !important;
                            }
                        ';
                        $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front-ci-item-title,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-head p,.bpa-front-tabs--vertical-left .bpa-front-tab-menu a span {
                            color: ' . $content_color . ' !important;
                        }';         
                        $bookingpress_customize_css_content .= '.bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .--bpa-is-desc,.bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-body .bpa-front--dt__ts-body--row .bpa-front--dt__ts-body--items .bpa-front--dt__ts-body--item span,.bpa-front-tabs .el-form-item__label span,.bpa-front-tabs .bpa-front-form-control input,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item span,.bpa-front-module--payment-methods .bpa-front-module--pm-body .bpa-front-module--pm-body__item p,.bpa-front-tabs--vertical-left .bpa-front-tab-menu a {
                            font-size: ' . $content_font_size . ' !important;
                        }';

                        $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p strong, .bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-body .bpa-front--dt__ts-body--row h5,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-amount-details .bpa-front-module--bs-ad--price, .bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__title-bar span,.bpa-front-dc--footer .bpa-front-tabs--foot .bpa-front-back-btn  {
                            color: ' . $sub_title_color . ' !important;      
                            font-size: ' . $sub_title_font_size . ' !important;                                                                              
                        }';  

                        $bookingpress_customize_css_content .= '.bpa-front-dc--footer .bpa-front-tabs--foot .bpa-front-next-btn,.bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p,.bpa-front-tabs .bpa-front-ci-item-title,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-head p,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item h4,.bpa-front-module--bs-amount-details .bpa-fm--bs-amount-item .bpa-front-total-payment-amount-label {
                            font-size: ' . $sub_title_font_size . ' !important;
                         } ';
                         $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si__card-body--heading,.bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .--bpa-is-desc,.bpa-front-tabs .bpa-front--dt__time-slots .bpa-front--dt__ts-body .bpa-front--dt__ts-body--row .bpa-front--dt__ts-body--items .bpa-front--dt__ts-body--item span,.bpa-front-tabs .el-form-item__label span,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item span,.bpa-front-module--payment-methods .bpa-front-module--pm-body .bpa-front-module--pm-body__item p,.bpa-front-tabs--vertical-left .bpa-front-tab-menu a{
                            color: ' . $sub_title_color . ' !important;      
                         }';
                        $bookingpress_customize_css_content .= '
                            .bpa-front-tabs--foot .bpa-front-btn--primary span, .bpa-front-tabs--foot .bpa-front-btn--primary strong,.bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si-cb__specs .bpa-front-si-cb__specs-item p strong.--is-service-price {
                                color: ' . $price_button_text_content_color . ' !important;
                            }
                            .bpa-front--dt__ts-body--item.__bpa-is-selected {
                                background-color: ' . $primary_alpha_color . ' !important;
                            }
                            .bpa-front-tabs .vuecal__cell--out-of-scope .vuecal__cell-date{
                                color: var(--bpa-gt-gray-400) !important;
                            }
                            .bpa-front-tabs .vuecal.vuecal--month-view .vuecal__title-bar .vuecal__arrow{
                                color: ' . $content_color . ' !important;
                            }
                        ';

                        $bookingpress_customize_css_content .= '.bpa-front-ci-pill.__bpa-is-active .bpa-front-ci-item-title,.bpa-front-tabs .bpa-front-form-control input,.bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-summary-content .bpa-front-module--bs-summary-content-item h4,.bpa-front-module--bs-amount-details .bpa-fm--bs-amount-item .bpa-front-total-payment-amount-label { 
                            color: ' . $title_label_color . ' !important;
                        }';
                        $bookingpress_customize_css_content .= '.bpa-front-tabs .bpa-front-module--service-item .bpa-front-si-card .bpa-front-si__card-body .bpa-front-si__card-body--heading{
                            font-size: ' . $title_font_size . ' !important;
                         }';
                        
                        $bookingpress_customize_css_content .= '
                        .bpa-front-tabs .bpa-front-module--booking-summary .bpa-front-module--bs-amount-details .bpa-front-module--bs-ad--price,.bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__cell--selected .vuecal__cell-date {
                            color: ' . $primary_color . ' !important;
                        }';

                        $bookingpress_customize_css_content .= '.bpa-front-module--booking-summary .bpa-front-module--bs-head .bpa-head__vector-item, .bpa-front-module--confirmation .bpa-head__vector--confirmation .bpa-head__vector-item {
                            fill: ' . $primary_color . ' !important;
                        }';

                        $bookingpress_customize_css_content .= '
                        .bpa-front-tabs--vertical-left .bpa-front-tab-menu .bpa-front-tab-menu--item.__bpa-is-active span,.bpa-front-tabs .bpa-front-tabs--foot .bpa-front-btn--primary:focus {                 
                            box-shadow: ' . $box_shadow_color . ' !important;
                        }';

                        $bookingpress_customize_css_content .= '               
                        .bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__cell--today .vuecal__cell-date,.bpa-front-tabs--vertical-left .bpa-front-tab-menu a.__bpa-is-active span {
                            color: var(--bpa-cl-white) !important;
                        }';

                        $bookingpress_customize_css_content .= '               
                        .bpa-front-tabs .bpa-front--dt__calendar .vuecal.vuecal--month-view .vuecal__cell--today.vuecal__cell--disabled .vuecal__cell-date {
                            color: '.$content_color.' !important;
                        }';
                        $bookingpress_customize_css_content .= '               
                        .bpa-front-tabs--vertical-left .bpa-front-tab-menu a.bpa-front-tab-menu--item.__bpa-is-active{
                            color: ' . $primary_color . ' !important;
                        }';

                        // Get custom CSS value
                        $bookingpress_customize_css_content .= $bookingpress_custom_data_arr['booking_form']['custom_css'];

                        if (! function_exists('WP_Filesystem') ) {
                            include_once ABSPATH . 'wp-admin/includes/file.php';
                        }
                        WP_Filesystem();
                        global $wp_filesystem;
                        $wp_upload_dir = wp_upload_dir();
                        $target_path   = $wp_upload_dir['basedir'] . '/bookingpress/bookingpress_front_custom_' . $bookingpress_customize_css_key . '.css';
                        $result        = $wp_filesystem->put_contents($target_path, $bookingpress_customize_css_content, 0777);
                    }                    
                }
            }     
        }
    }
}
global $BookingPress,$bookingpress_debug_payment_log_id;
$BookingPress = new BOOKINGPRESS();

$bookingpress_debug_payment_log_id = 0;
